fof(transitivity_of_transitive_reflexive_rewrite,axiom,
    ! [A,B,C] :
      ( ( transitive_reflexive_rewrite(A,B)
        & transitive_reflexive_rewrite(B,C) )
     => transitive_reflexive_rewrite(A,C) ) ).

fof(goal_to_be_proved,conjecture,
    goal ).

fof(rewrite_in_transitive_reflexive_rewrite,axiom,
    ! [A,B] :
      ( rewrite(A,B)
     => transitive_reflexive_rewrite(A,B) ) ).

fof(assumption,axiom,
    ( transitive_reflexive_rewrite(a,c)
    & transitive_reflexive_rewrite(a,b) ) ).

fof(found,axiom,
    ! [A] :
      ( goal
     <= ( transitive_reflexive_rewrite(b,A)
        & transitive_reflexive_rewrite(c,A) ) ) ).

fof(equality_in_transitive_reflexive_rewrite,axiom,
    ! [A,B] :
      ( transitive_reflexive_rewrite(A,B)
     <= A = B ) ).

fof(lo_cfl,axiom,
    ! [A,B,C] :
      ( ? [D] :
          ( transitive_reflexive_rewrite(B,D)
          & transitive_reflexive_rewrite(C,D) )
     <= ( rewrite(A,C)
        & rewrite(A,B) ) ) ).

fof(ih_cfl,axiom,
    ! [A,B,C] :
      ( ( transitive_reflexive_rewrite(A,B)
        & transitive_reflexive_rewrite(A,C)
        & rewrite(a,A) )
     => ? [D] :
          ( transitive_reflexive_rewrite(C,D)
          & transitive_reflexive_rewrite(B,D) ) ) ).

fof(equal_or_rewrite,axiom,
    ! [A,B] :
      ( transitive_reflexive_rewrite(A,B)
     => ( B = A
        | ? [C] :
            ( rewrite(A,C)
            & transitive_reflexive_rewrite(C,B) ) ) ) ).

