include('Axioms/MGT001+0.ax').
fof(assumption_18a,axiom,
    greater(high,mod1) ).

fof(theorem_7,conjecture,
    ! [X,T0,T1,T2] :
      ( ( zero = age(X,T0)
        & greater(age(X,T2),sigma)
        & smaller_or_equal(age(X,T1),sigma)
        & greater(sigma,zero)
        & ~ has_endowment(X)
        & fragile_position(X)
        & organization(X) )
     => ( hazard_of_mortality(X,T1) = hazard_of_mortality(X,T0)
        & greater(hazard_of_mortality(X,T2),hazard_of_mortality(X,T1)) ) ) ).

fof(assumption_18d,axiom,
    greater(high,mod2) ).

fof(definition_3,axiom,
    ! [X] :
      ( fragile_position(X)
    <=> ! [T] :
          ( ( greater(age(X,T),sigma)
           => ~ positional_advantage(X,T) )
          & ( smaller_or_equal(age(X,T),sigma)
           => positional_advantage(X,T) ) ) ) ).

fof(assumption_15,axiom,
    ! [X,T0,T] :
      ( ( organization(X)
        & zero = age(X,T0) )
     => ( dissimilar(X,T0,T)
      <=> greater(age(X,T),sigma) ) ) ).

fof(assumption_17,axiom,
    ! [X,T] :
      ( organization(X)
     => ( ( ( ( ( positional_advantage(X,T)
                & is_aligned(X,T) )
             => hazard_of_mortality(X,T) = low )
            & ( hazard_of_mortality(X,T) = mod2
             <= ( ~ positional_advantage(X,T)
                & is_aligned(X,T) ) )
            & ( ( ~ positional_advantage(X,T)
                & ~ is_aligned(X,T) )
             => hazard_of_mortality(X,T) = high )
            & ( ( ~ is_aligned(X,T)
                & positional_advantage(X,T) )
             => hazard_of_mortality(X,T) = mod1 ) )
         <= ~ has_immunity(X,T) )
        & ( has_immunity(X,T)
         => very_low = hazard_of_mortality(X,T) ) ) ) ).

fof(assumption_18b,axiom,
    greater(mod1,low) ).

fof(definition_2,axiom,
    ! [X,T0,T] :
      ( dissimilar(X,T0,T)
    <=> ( organization(X)
        & ~ ( is_aligned(X,T)
          <=> is_aligned(X,T0) ) ) ) ).

fof(assumption_18c,axiom,
    greater(low,very_low) ).

fof(assumption_1,axiom,
    ! [X,T] :
      ( ~ has_immunity(X,T)
     <= ( ~ has_endowment(X)
        & organization(X) ) ) ).

fof(assumption_13,axiom,
    ! [X,T] :
      ( ( age(X,T) = zero
        & organization(X) )
     => is_aligned(X,T) ) ).

fof(assumption_18e,axiom,
    greater(mod2,low) ).

