include('Axioms/MGT001+0.ax').
fof(definition_1,axiom,
    ! [X] :
      ( has_endowment(X)
    <=> ! [T] :
          ( organization(X)
          & ( smaller_or_equal(age(X,T),eta)
           => has_immunity(X,T) )
          & ( ~ has_immunity(X,T)
           <= greater(age(X,T),eta) ) ) ) ).

fof(assumption_18c,axiom,
    greater(low,very_low) ).

fof(assumption_18a,axiom,
    greater(high,mod1) ).

fof(assumption_13,axiom,
    ! [X,T] :
      ( ( organization(X)
        & age(X,T) = zero )
     => is_aligned(X,T) ) ).

fof(assumption_17,axiom,
    ! [X,T] :
      ( ( ( ( ( mod1 = hazard_of_mortality(X,T)
             <= ( ~ is_aligned(X,T)
                & positional_advantage(X,T) ) )
            & ( ( ~ positional_advantage(X,T)
                & is_aligned(X,T) )
             => hazard_of_mortality(X,T) = mod2 )
            & ( high = hazard_of_mortality(X,T)
             <= ( ~ is_aligned(X,T)
                & ~ positional_advantage(X,T) ) )
            & ( ( is_aligned(X,T)
                & positional_advantage(X,T) )
             => hazard_of_mortality(X,T) = low ) )
         <= ~ has_immunity(X,T) )
        & ( has_immunity(X,T)
         => very_low = hazard_of_mortality(X,T) ) )
     <= organization(X) ) ).

fof(definition_2,axiom,
    ! [X,T0,T] :
      ( dissimilar(X,T0,T)
    <=> ( ~ ( is_aligned(X,T)
          <=> is_aligned(X,T0) )
        & organization(X) ) ) ).

fof(assumption_18d,axiom,
    greater(high,mod2) ).

fof(assumption_18e,axiom,
    greater(mod2,low) ).

fof(assumption_15,axiom,
    ! [X,T0,T] :
      ( ( organization(X)
        & age(X,T0) = zero )
     => ( dissimilar(X,T0,T)
      <=> greater(age(X,T),sigma) ) ) ).

fof(assumption_18b,axiom,
    greater(mod1,low) ).

fof(theorem_11,conjecture,
    ! [X,T0,T1,T2] :
      ( ( organization(X)
        & has_endowment(X)
        & zero = age(X,T0)
        & greater(sigma,zero)
        & greater(age(X,T2),eta)
        & greater(age(X,T2),tau)
        & greater(age(X,T2),sigma)
        & smaller_or_equal(age(X,T1),eta)
        & smaller_or_equal(age(X,T1),tau)
        & smaller_or_equal(age(X,T1),sigma)
        & greater(eta,zero)
        & greater(tau,zero)
        & ( fragile_position(X)
          | robust_position(X) ) )
     => ( hazard_of_mortality(X,T0) = hazard_of_mortality(X,T1)
        & greater(hazard_of_mortality(X,T2),hazard_of_mortality(X,T1)) ) ) ).

