fof(summation_monotone,axiom,
    ! [X,Y] :
      ( lesseq(X,Y)
    <=> lesseq(summation(X),summation(Y)) ) ).

fof(ub,axiom,
    ! [X,Y,Z] :
      ( ( lesseq(X,Z)
        & lesseq(Y,Z) )
    <=> ub(X,Y,Z) ) ).

fof(max_is_ub_1,conjecture,
    ! [X,Y,Z] :
      ( minsol_model_ub(X,Y,Z)
    <=> minsol_model_max(X,Y,Z) ) ).

fof(model_max_1,axiom,
    ! [X,Y,N] :
      ( N = max(X,Y)
    <=> model_max(X,Y,N) ) ).

fof(lesseq_antisymmetric,axiom,
    ! [X,Y] :
      ( ( lesseq(Y,X)
        & lesseq(X,Y) )
     => Y = X ) ).

fof(lesseq_total,axiom,
    ! [X,Y] :
      ( lesseq(Y,X)
      | lesseq(X,Y) ) ).

fof(max_1,axiom,
    ! [X,Y] :
      ( ~ lesseq(Y,X)
      | max(X,Y) = X ) ).

fof(model_ub_1,axiom,
    ! [X,Y,N] :
      ( model_ub(X,Y,N)
    <=> ub(X,Y,N) ) ).

fof(lesseq_ref,axiom,
    ! [X] : lesseq(X,X) ).

fof(sum_monotone_1,axiom,
    ! [X,Y,Z] :
      ( lesseq(sum(Z,X),sum(Z,Y))
    <=> lesseq(X,Y) ) ).

fof(minsol_model_ub,axiom,
    ! [X,Y,N] :
      ( minsol_model_ub(X,Y,N)
    <=> ( model_ub(X,Y,N)
        & ! [Z] :
            ( model_ub(X,Y,Z)
           => lesseq(N,Z) ) ) ) ).

fof(max_2,axiom,
    ! [X,Y] :
      ( ~ lesseq(X,Y)
      | max(X,Y) = Y ) ).

fof(lesseq_trans,axiom,
    ! [X,Y,Z] :
      ( ( lesseq(X,Y)
        & lesseq(Y,Z) )
     => lesseq(X,Z) ) ).

fof(minsol_model_max,axiom,
    ! [X,Y,N] :
      ( ( ! [Z] :
            ( lesseq(N,Z)
           <= model_max(X,Y,Z) )
        & model_max(X,Y,N) )
    <=> minsol_model_max(X,Y,N) ) ).

