fof(dt_k1_tarski,axiom,
    $true ).

fof(dt_k6_relat_1,axiom,
    ! [A] : relation(identity_relation(A)) ).

fof(rc2_relat_1,axiom,
    ? [A] :
      ( ~ empty(A)
      & relation(A) ) ).

fof(antisymmetry_r2_hidden,axiom,
    ! [A,B] :
      ( in(A,B)
     => ~ in(B,A) ) ).

fof(d5_tarski,axiom,
    ! [A,B] : unordered_pair(unordered_pair(A,B),singleton(A)) = ordered_pair(A,B) ).

fof(fc10_relat_1,axiom,
    ! [A,B] :
      ( ( empty(relation_composition(B,A))
        & relation(relation_composition(B,A)) )
     <= ( empty(A)
        & relation(B) ) ) ).

fof(cc1_relat_1,axiom,
    ! [A] :
      ( relation(A)
     <= empty(A) ) ).

fof(dt_k4_tarski,axiom,
    $true ).

fof(t6_boole,axiom,
    ! [A] :
      ( empty(A)
     => A = empty_set ) ).

fof(dt_k1_xboole_0,axiom,
    $true ).

fof(fc3_subset_1,axiom,
    ! [A,B] : ~ empty(unordered_pair(A,B)) ).

fof(t1_subset,axiom,
    ! [A,B] :
      ( element(A,B)
     <= in(A,B) ) ).

fof(rc1_xboole_0,axiom,
    ? [A] : empty(A) ).

fof(fc2_subset_1,axiom,
    ! [A] : ~ empty(singleton(A)) ).

fof(rc1_relat_1,axiom,
    ? [A] :
      ( empty(A)
      & relation(A) ) ).

fof(t74_relat_1,conjecture,
    ! [A,B,C,D] :
      ( relation(D)
     => ( ( in(A,C)
          & in(ordered_pair(A,B),D) )
      <=> in(ordered_pair(A,B),relation_composition(identity_relation(C),D)) ) ) ).

fof(d10_relat_1,axiom,
    ! [A,B] :
      ( relation(B)
     => ( ! [C,D] :
            ( ( C = D
              & in(C,A) )
          <=> in(ordered_pair(C,D),B) )
      <=> identity_relation(A) = B ) ) ).

fof(fc1_zfmisc_1,axiom,
    ! [A,B] : ~ empty(ordered_pair(A,B)) ).

fof(fc9_relat_1,axiom,
    ! [A,B] :
      ( ( empty(A)
        & relation(B) )
     => ( empty(relation_composition(A,B))
        & relation(relation_composition(A,B)) ) ) ).

fof(t2_subset,axiom,
    ! [A,B] :
      ( element(A,B)
     => ( empty(B)
        | in(A,B) ) ) ).

fof(d8_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation(B)
         => ! [C] :
              ( relation(C)
             => ( relation_composition(A,B) = C
              <=> ! [D,E] :
                    ( ? [F] :
                        ( in(ordered_pair(D,F),A)
                        & in(ordered_pair(F,E),B) )
                  <=> in(ordered_pair(D,E),C) ) ) ) ) ) ).

fof(dt_k5_relat_1,axiom,
    ! [A,B] :
      ( relation(relation_composition(A,B))
     <= ( relation(A)
        & relation(B) ) ) ).

fof(t8_boole,axiom,
    ! [A,B] :
      ~ ( empty(B)
        & A != B
        & empty(A) ) ).

fof(commutativity_k2_tarski,axiom,
    ! [A,B] : unordered_pair(B,A) = unordered_pair(A,B) ).

fof(fc4_relat_1,axiom,
    ( relation(empty_set)
    & empty(empty_set) ) ).

fof(dt_k2_tarski,axiom,
    $true ).

fof(dt_m1_subset_1,axiom,
    $true ).

fof(rc2_xboole_0,axiom,
    ? [A] : ~ empty(A) ).

fof(t7_boole,axiom,
    ! [A,B] :
      ~ ( empty(B)
        & in(A,B) ) ).

fof(fc1_xboole_0,axiom,
    empty(empty_set) ).

fof(existence_m1_subset_1,axiom,
    ! [A] :
    ? [B] : element(B,A) ).

