fof(t47_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( ( relation_rng(A) = relation_rng(relation_composition(B,A))
           <= subset(relation_dom(A),relation_rng(B)) )
         <= relation(B) )
     <= relation(A) ) ).

fof(dt_k6_subset_1,axiom,
    ! [A,B,C] :
      ( ( element(B,powerset(A))
        & element(C,powerset(A)) )
     => element(subset_difference(A,B,C),powerset(A)) ) ).

fof(t33_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( A = C
        & D = B )
     <= ordered_pair(C,D) = ordered_pair(A,B) ) ).

fof(d11_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B,C] :
          ( relation(C)
         => ( relation_dom_restriction(A,B) = C
          <=> ! [D,E] :
                ( in(ordered_pair(D,E),C)
              <=> ( in(ordered_pair(D,E),A)
                  & in(D,B) ) ) ) ) ) ).

fof(d4_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( ? [D] :
              ( in(D,A)
              & in(C,D) )
        <=> in(C,B) )
    <=> B = union(A) ) ).

fof(t65_zfmisc_1,lemma,
    ! [A,B] :
      ( ~ in(B,A)
    <=> set_difference(A,singleton(B)) = A ) ).

fof(t38_zfmisc_1,lemma,
    ! [A,B,C] :
      ( ( in(B,C)
        & in(A,C) )
    <=> subset(unordered_pair(A,B),C) ) ).

fof(t8_boole,axiom,
    ! [A,B] :
      ~ ( A != B
        & empty(B)
        & empty(A) ) ).

fof(symmetry_r1_xboole_0,axiom,
    ! [A,B] :
      ( disjoint(B,A)
     <= disjoint(A,B) ) ).

fof(t63_xboole_1,lemma,
    ! [A,B,C] :
      ( disjoint(A,C)
     <= ( subset(A,B)
        & disjoint(B,C) ) ) ).

fof(l28_zfmisc_1,lemma,
    ! [A,B] :
      ( ~ in(A,B)
     => disjoint(singleton(A),B) ) ).

fof(l3_subset_1,lemma,
    ! [A,B] :
      ( ! [C] :
          ( in(C,A)
         <= in(C,B) )
     <= element(B,powerset(A)) ) ).

fof(antisymmetry_r2_xboole_0,axiom,
    ! [A,B] :
      ( ~ proper_subset(B,A)
     <= proper_subset(A,B) ) ).

fof(dt_k4_tarski,axiom,
    $true ).

fof(t2_xboole_1,lemma,
    ! [A] : subset(empty_set,A) ).

fof(l71_subset_1,lemma,
    ! [A,B] :
      ( element(A,powerset(B))
     <= ! [C] :
          ( in(C,B)
         <= in(C,A) ) ) ).

fof(t33_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(set_difference(A,C),set_difference(B,C))
     <= subset(A,B) ) ).

fof(dt_k2_tarski,axiom,
    $true ).

fof(antisymmetry_r2_hidden,axiom,
    ! [A,B] :
      ( ~ in(B,A)
     <= in(A,B) ) ).

fof(t17_xboole_1,lemma,
    ! [A,B] : subset(set_intersection2(A,B),A) ).

fof(t46_zfmisc_1,lemma,
    ! [A,B] :
      ( set_union2(singleton(A),B) = B
     <= in(A,B) ) ).

fof(t2_subset,axiom,
    ! [A,B] :
      ( element(A,B)
     => ( empty(B)
        | in(A,B) ) ) ).

fof(t37_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ( relation_rng(A) = relation_dom(relation_inverse(A))
        & relation_rng(relation_inverse(A)) = relation_dom(A) ) ) ).

fof(d1_zfmisc_1,axiom,
    ! [A,B] :
      ( ! [C] :
          ( in(C,B)
        <=> subset(C,A) )
    <=> powerset(A) = B ) ).

fof(t48_xboole_1,lemma,
    ! [A,B] : set_difference(A,set_difference(A,B)) = set_intersection2(A,B) ).

fof(d3_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( in(C,B)
         <= in(C,A) )
    <=> subset(A,B) ) ).

fof(t54_subset_1,lemma,
    ! [A,B,C] :
      ( element(C,powerset(A))
     => ~ ( in(B,subset_complement(A,C))
          & in(B,C) ) ) ).

fof(t6_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),singleton(B))
     => A = B ) ).

fof(involutiveness_k7_setfam_1,axiom,
    ! [A,B] :
      ( B = complements_of_subsets(A,complements_of_subsets(A,B))
     <= element(B,powerset(powerset(A))) ) ).

fof(dt_k7_relat_1,axiom,
    ! [A,B] :
      ( relation(relation_dom_restriction(A,B))
     <= relation(A) ) ).

fof(rc1_relat_1,axiom,
    ? [A] :
      ( relation(A)
      & empty(A) ) ).

fof(commutativity_k2_xboole_0,axiom,
    ! [A,B] : set_union2(B,A) = set_union2(A,B) ).

fof(dt_k4_relat_1,axiom,
    ! [A] :
      ( relation(relation_inverse(A))
     <= relation(A) ) ).

fof(d7_xboole_0,axiom,
    ! [A,B] :
      ( disjoint(A,B)
    <=> set_intersection2(A,B) = empty_set ) ).

fof(t21_relat_1,lemma,
    ! [A] :
      ( subset(A,cartesian_product2(relation_dom(A),relation_rng(A)))
     <= relation(A) ) ).

fof(t47_setfam_1,lemma,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => ( empty_set != B
       => meet_of_subsets(A,complements_of_subsets(A,B)) = subset_difference(A,cast_to_subset(A),union_of_subsets(A,B)) ) ) ).

fof(dt_k1_setfam_1,axiom,
    $true ).

fof(idempotence_k2_xboole_0,axiom,
    ! [A,B] : set_union2(A,A) = A ).

fof(fc10_relat_1,axiom,
    ! [A,B] :
      ( ( relation(B)
        & empty(A) )
     => ( empty(relation_composition(B,A))
        & relation(relation_composition(B,A)) ) ) ).

fof(dt_k3_relat_1,axiom,
    $true ).

fof(l50_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,union(B))
     <= in(A,B) ) ).

fof(dt_k3_subset_1,axiom,
    ! [A,B] :
      ( element(subset_complement(A,B),powerset(A))
     <= element(B,powerset(A)) ) ).

fof(t30_relat_1,lemma,
    ! [A,B,C] :
      ( relation(C)
     => ( ( in(A,relation_field(C))
          & in(B,relation_field(C)) )
       <= in(ordered_pair(A,B),C) ) ) ).

fof(dt_k2_relat_1,axiom,
    $true ).

fof(d4_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( ! [C] :
              ( in(C,B)
            <=> ? [D] : in(ordered_pair(C,D),A) )
        <=> B = relation_dom(A) )
     <= relation(A) ) ).

fof(l1_zfmisc_1,lemma,
    ! [A] : empty_set != singleton(A) ).

fof(d5_tarski,axiom,
    ! [A,B] : unordered_pair(unordered_pair(A,B),singleton(A)) = ordered_pair(A,B) ).

fof(dt_k2_xboole_0,axiom,
    $true ).

fof(t71_relat_1,lemma,
    ! [A] :
      ( A = relation_rng(identity_relation(A))
      & A = relation_dom(identity_relation(A)) ) ).

fof(d10_relat_1,axiom,
    ! [A,B] :
      ( relation(B)
     => ( B = identity_relation(A)
      <=> ! [C,D] :
            ( ( D = C
              & in(C,A) )
          <=> in(ordered_pair(C,D),B) ) ) ) ).

fof(d2_xboole_0,axiom,
    ! [A,B,C] :
      ( set_union2(A,B) = C
    <=> ! [D] :
          ( ( in(D,A)
            | in(D,B) )
        <=> in(D,C) ) ) ).

fof(t7_boole,axiom,
    ! [A,B] :
      ~ ( empty(B)
        & in(A,B) ) ).

fof(dt_k5_setfam_1,axiom,
    ! [A,B] :
      ( element(union_of_subsets(A,B),powerset(A))
     <= element(B,powerset(powerset(A))) ) ).

fof(fc1_xboole_0,axiom,
    empty(empty_set) ).

fof(t46_setfam_1,lemma,
    ! [A,B] :
      ( ~ ( B != empty_set
          & empty_set = complements_of_subsets(A,B) )
     <= element(B,powerset(powerset(A))) ) ).

fof(fc3_xboole_0,axiom,
    ! [A,B] :
      ( ~ empty(set_union2(B,A))
     <= ~ empty(A) ) ).

fof(d1_tarski,axiom,
    ! [A,B] :
      ( singleton(A) = B
    <=> ! [C] :
          ( C = A
        <=> in(C,B) ) ) ).

fof(t7_xboole_1,lemma,
    ! [A,B] : subset(A,set_union2(A,B)) ).

fof(t92_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,union(B))
     <= in(A,B) ) ).

fof(l32_xboole_1,lemma,
    ! [A,B] :
      ( empty_set = set_difference(A,B)
    <=> subset(A,B) ) ).

fof(redefinition_k6_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => meet_of_subsets(A,B) = set_meet(B) ) ).

fof(t2_boole,axiom,
    ! [A] : empty_set = set_intersection2(A,empty_set) ).

fof(rc2_xboole_0,axiom,
    ? [A] : ~ empty(A) ).

fof(t45_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( subset(relation_rng(relation_composition(A,B)),relation_rng(B))
         <= relation(B) ) ) ).

fof(d3_xboole_0,axiom,
    ! [A,B,C] :
      ( set_intersection2(A,B) = C
    <=> ! [D] :
          ( in(D,C)
        <=> ( in(D,A)
            & in(D,B) ) ) ) ).

fof(fc1_zfmisc_1,axiom,
    ! [A,B] : ~ empty(ordered_pair(A,B)) ).

fof(reflexivity_r1_tarski,axiom,
    ! [A,B] : subset(A,A) ).

fof(t36_xboole_1,lemma,
    ! [A,B] : subset(set_difference(A,B),A) ).

fof(t1_xboole_1,lemma,
    ! [A,B,C] :
      ( ( subset(B,C)
        & subset(A,B) )
     => subset(A,C) ) ).

fof(d10_xboole_0,axiom,
    ! [A,B] :
      ( ( subset(A,B)
        & subset(B,A) )
    <=> A = B ) ).

fof(t28_xboole_1,lemma,
    ! [A,B] :
      ( set_intersection2(A,B) = A
     <= subset(A,B) ) ).

fof(t1_boole,axiom,
    ! [A] : set_union2(A,empty_set) = A ).

fof(t19_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,set_intersection2(B,C))
     <= ( subset(A,C)
        & subset(A,B) ) ) ).

fof(t99_zfmisc_1,lemma,
    ! [A] : union(powerset(A)) = A ).

fof(l55_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( in(B,D)
        & in(A,C) )
    <=> in(ordered_pair(A,B),cartesian_product2(C,D)) ) ).

fof(t1_zfmisc_1,lemma,
    singleton(empty_set) = powerset(empty_set) ).

fof(fc4_relat_1,axiom,
    ( empty(empty_set)
    & relation(empty_set) ) ).

fof(fc8_relat_1,axiom,
    ! [A] :
      ( empty(A)
     => ( relation(relation_rng(A))
        & empty(relation_rng(A)) ) ) ).

fof(redefinition_k5_setfam_1,axiom,
    ! [A,B] :
      ( union_of_subsets(A,B) = union(B)
     <= element(B,powerset(powerset(A))) ) ).

fof(d6_relat_1,axiom,
    ! [A] :
      ( set_union2(relation_dom(A),relation_rng(A)) = relation_field(A)
     <= relation(A) ) ).

fof(t60_xboole_1,lemma,
    ! [A,B] :
      ~ ( subset(A,B)
        & proper_subset(B,A) ) ).

fof(t56_relat_1,lemma,
    ! [A] :
      ( ( ! [B,C] : ~ in(ordered_pair(B,C),A)
       => empty_set = A )
     <= relation(A) ) ).

fof(fc5_relat_1,axiom,
    ! [A] :
      ( ( ~ empty(A)
        & relation(A) )
     => ~ empty(relation_dom(A)) ) ).

fof(t2_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( in(C,A)
        <=> in(C,B) )
     => A = B ) ).

fof(t83_xboole_1,lemma,
    ! [A,B] :
      ( disjoint(A,B)
    <=> set_difference(A,B) = A ) ).

fof(t26_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,B)
     => subset(set_intersection2(A,C),set_intersection2(B,C)) ) ).

fof(d5_subset_1,axiom,
    ! [A,B] :
      ( element(B,powerset(A))
     => subset_complement(A,B) = set_difference(A,B) ) ).

fof(t86_relat_1,conjecture,
    ! [A,B,C] :
      ( ( in(A,relation_dom(relation_dom_restriction(C,B)))
      <=> ( in(A,B)
          & in(A,relation_dom(C)) ) )
     <= relation(C) ) ).

fof(d8_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation(B)
         => ! [C] :
              ( ( C = relation_composition(A,B)
              <=> ! [D,E] :
                    ( in(ordered_pair(D,E),C)
                  <=> ? [F] :
                        ( in(ordered_pair(D,F),A)
                        & in(ordered_pair(F,E),B) ) ) )
             <= relation(C) ) ) ) ).

fof(d7_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( ( relation_inverse(A) = B
          <=> ! [C,D] :
                ( in(ordered_pair(D,C),A)
              <=> in(ordered_pair(C,D),B) ) )
         <= relation(B) ) ) ).

fof(t8_zfmisc_1,lemma,
    ! [A,B,C] :
      ( unordered_pair(B,C) = singleton(A)
     => B = A ) ).

fof(rc2_subset_1,axiom,
    ! [A] :
    ? [B] :
      ( element(B,powerset(A))
      & empty(B) ) ).

fof(involutiveness_k3_subset_1,axiom,
    ! [A,B] :
      ( element(B,powerset(A))
     => B = subset_complement(A,subset_complement(A,B)) ) ).

fof(dt_m1_subset_1,axiom,
    $true ).

fof(l3_zfmisc_1,lemma,
    ! [A,B,C] :
      ( ( in(C,A)
        | subset(A,set_difference(B,singleton(C))) )
     <= subset(A,B) ) ).

fof(d1_xboole_0,axiom,
    ! [A] :
      ( A = empty_set
    <=> ! [B] : ~ in(B,A) ) ).

fof(t3_boole,axiom,
    ! [A] : A = set_difference(A,empty_set) ).

fof(rc2_relat_1,axiom,
    ? [A] :
      ( relation(A)
      & ~ empty(A) ) ).

fof(l4_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,singleton(B))
    <=> ( A = singleton(B)
        | A = empty_set ) ) ).

fof(l23_zfmisc_1,lemma,
    ! [A,B] :
      ( in(A,B)
     => set_union2(singleton(A),B) = B ) ).

fof(fc2_subset_1,axiom,
    ! [A] : ~ empty(singleton(A)) ).

fof(t3_xboole_1,lemma,
    ! [A] :
      ( subset(A,empty_set)
     => A = empty_set ) ).

fof(t60_relat_1,lemma,
    ( relation_dom(empty_set) = empty_set
    & relation_rng(empty_set) = empty_set ) ).

fof(d1_relat_1,axiom,
    ! [A] :
      ( relation(A)
    <=> ! [B] :
          ~ ( in(B,A)
            & ! [C,D] : ordered_pair(C,D) != B ) ) ).

fof(t65_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ( relation_dom(A) = empty_set
      <=> empty_set = relation_rng(A) ) ) ).

fof(t44_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => subset(relation_dom(relation_composition(A,B)),relation_dom(A)) )
     <= relation(A) ) ).

fof(d2_zfmisc_1,axiom,
    ! [A,B,C] :
      ( ! [D] :
          ( in(D,C)
        <=> ? [E,F] :
              ( in(E,A)
              & D = ordered_pair(E,F)
              & in(F,B) ) )
    <=> cartesian_product2(A,B) = C ) ).

fof(fc7_relat_1,axiom,
    ! [A] :
      ( ( relation(relation_dom(A))
        & empty(relation_dom(A)) )
     <= empty(A) ) ).

fof(t69_enumset1,lemma,
    ! [A] : unordered_pair(A,A) = singleton(A) ).

fof(dt_k1_xboole_0,axiom,
    $true ).

fof(t45_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
     => B = set_union2(A,set_difference(B,A)) ) ).

fof(redefinition_k6_subset_1,axiom,
    ! [A,B,C] :
      ( subset_difference(A,B,C) = set_difference(B,C)
     <= ( element(B,powerset(A))
        & element(C,powerset(A)) ) ) ).

fof(t3_subset,axiom,
    ! [A,B] :
      ( subset(A,B)
    <=> element(A,powerset(B)) ) ).

fof(t4_boole,axiom,
    ! [A] : set_difference(empty_set,A) = empty_set ).

fof(dt_k6_setfam_1,axiom,
    ! [A,B] :
      ( element(meet_of_subsets(A,B),powerset(A))
     <= element(B,powerset(powerset(A))) ) ).

fof(rc1_subset_1,axiom,
    ! [A] :
      ( ~ empty(A)
     => ? [B] :
          ( ~ empty(B)
          & element(B,powerset(A)) ) ) ).

fof(d1_setfam_1,axiom,
    ! [A,B] :
      ( ( ( B = empty_set
        <=> set_meet(A) = B )
       <= empty_set = A )
      & ( ( set_meet(A) = B
        <=> ! [C] :
              ( in(C,B)
            <=> ! [D] :
                  ( in(C,D)
                 <= in(D,A) ) ) )
       <= empty_set != A ) ) ).

fof(t119_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( subset(A,B)
        & subset(C,D) )
     => subset(cartesian_product2(A,C),cartesian_product2(B,D)) ) ).

fof(t1_subset,axiom,
    ! [A,B] :
      ( element(A,B)
     <= in(A,B) ) ).

fof(commutativity_k3_xboole_0,axiom,
    ! [A,B] : set_intersection2(A,B) = set_intersection2(B,A) ).

fof(d8_xboole_0,axiom,
    ! [A,B] :
      ( ( subset(A,B)
        & A != B )
    <=> proper_subset(A,B) ) ).

fof(t4_subset,axiom,
    ! [A,B,C] :
      ( ( element(B,powerset(C))
        & in(A,B) )
     => element(A,C) ) ).

fof(irreflexivity_r2_xboole_0,axiom,
    ! [A,B] : ~ proper_subset(A,A) ).

fof(dt_k2_zfmisc_1,axiom,
    $true ).

fof(t9_tarski,axiom,
    ! [A] :
    ? [B] :
      ( ! [C] :
          ~ ( ! [D] :
                ~ ( in(D,B)
                  & ! [E] :
                      ( in(E,D)
                     <= subset(E,C) ) )
            & in(C,B) )
      & ! [C] :
          ~ ( subset(C,B)
            & ~ are_equipotent(C,B)
            & ~ in(C,B) )
      & ! [C,D] :
          ( in(D,B)
         <= ( subset(D,C)
            & in(C,B) ) )
      & in(A,B) ) ).

fof(t9_zfmisc_1,lemma,
    ! [A,B,C] :
      ( singleton(A) = unordered_pair(B,C)
     => B = C ) ).

fof(l2_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),B)
    <=> in(A,B) ) ).

fof(fc2_relat_1,axiom,
    ! [A,B] :
      ( relation(set_union2(A,B))
     <= ( relation(A)
        & relation(B) ) ) ).

fof(t4_xboole_0,lemma,
    ! [A,B] :
      ( ~ ( ? [C] : in(C,set_intersection2(A,B))
          & disjoint(A,B) )
      & ~ ( ! [C] : ~ in(C,set_intersection2(A,B))
          & ~ disjoint(A,B) ) ) ).

fof(d2_tarski,axiom,
    ! [A,B,C] :
      ( C = unordered_pair(A,B)
    <=> ! [D] :
          ( ( A = D
            | B = D )
        <=> in(D,C) ) ) ).

fof(t20_relat_1,lemma,
    ! [A,B,C] :
      ( relation(C)
     => ( in(ordered_pair(A,B),C)
       => ( in(A,relation_dom(C))
          & in(B,relation_rng(C)) ) ) ) ).

fof(t37_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
    <=> empty_set = set_difference(A,B) ) ).

fof(t8_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(set_union2(A,C),B)
     <= ( subset(C,B)
        & subset(A,B) ) ) ).

fof(t46_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( ( subset(relation_rng(A),relation_dom(B))
           => relation_dom(A) = relation_dom(relation_composition(A,B)) )
         <= relation(B) ) ) ).

fof(t40_xboole_1,lemma,
    ! [A,B] : set_difference(set_union2(A,B),B) = set_difference(A,B) ).

fof(fc9_relat_1,axiom,
    ! [A,B] :
      ( ( empty(relation_composition(A,B))
        & relation(relation_composition(A,B)) )
     <= ( relation(B)
        & empty(A) ) ) ).

fof(dt_k1_tarski,axiom,
    $true ).

fof(t37_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),B)
    <=> in(A,B) ) ).

fof(d8_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => ! [C] :
          ( element(C,powerset(powerset(A)))
         => ( ! [D] :
                ( element(D,powerset(A))
               => ( in(subset_complement(A,D),B)
                <=> in(D,C) ) )
          <=> C = complements_of_subsets(A,B) ) ) ) ).

fof(t106_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( in(ordered_pair(A,B),cartesian_product2(C,D))
    <=> ( in(A,C)
        & in(B,D) ) ) ).

fof(t64_relat_1,lemma,
    ! [A] :
      ( ( A = empty_set
       <= ( empty_set = relation_rng(A)
          | empty_set = relation_dom(A) ) )
     <= relation(A) ) ).

fof(d2_subset_1,axiom,
    ! [A,B] :
      ( ( ( empty(B)
        <=> element(B,A) )
       <= empty(A) )
      & ( ~ empty(A)
       => ( element(B,A)
        <=> in(B,A) ) ) ) ).

fof(dt_k1_zfmisc_1,axiom,
    $true ).

fof(fc3_subset_1,axiom,
    ! [A,B] : ~ empty(unordered_pair(A,B)) ).

fof(cc1_relat_1,axiom,
    ! [A] :
      ( empty(A)
     => relation(A) ) ).

fof(d4_xboole_0,axiom,
    ! [A,B,C] :
      ( C = set_difference(A,B)
    <=> ! [D] :
          ( ( in(D,A)
            & ~ in(D,B) )
        <=> in(D,C) ) ) ).

fof(fc4_subset_1,axiom,
    ! [A,B] :
      ( ~ empty(cartesian_product2(A,B))
     <= ( ~ empty(B)
        & ~ empty(A) ) ) ).

fof(involutiveness_k4_relat_1,axiom,
    ! [A] :
      ( relation_inverse(relation_inverse(A)) = A
     <= relation(A) ) ).

fof(t50_subset_1,lemma,
    ! [A] :
      ( A != empty_set
     => ! [B] :
          ( element(B,powerset(A))
         => ! [C] :
              ( ( in(C,subset_complement(A,B))
               <= ~ in(C,B) )
             <= element(C,A) ) ) ) ).

fof(commutativity_k2_tarski,axiom,
    ! [A,B] : unordered_pair(A,B) = unordered_pair(B,A) ).

fof(t118_zfmisc_1,lemma,
    ! [A,B,C] :
      ( subset(A,B)
     => ( subset(cartesian_product2(C,A),cartesian_product2(C,B))
        & subset(cartesian_product2(A,C),cartesian_product2(B,C)) ) ) ).

fof(dt_k2_subset_1,axiom,
    ! [A] : element(cast_to_subset(A),powerset(A)) ).

fof(t25_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ( subset(A,B)
           => ( subset(relation_dom(A),relation_dom(B))
              & subset(relation_rng(A),relation_rng(B)) ) ) )
     <= relation(A) ) ).

fof(dt_k1_relat_1,axiom,
    $true ).

fof(t39_xboole_1,lemma,
    ! [A,B] : set_union2(A,B) = set_union2(A,set_difference(B,A)) ).

fof(l25_zfmisc_1,lemma,
    ! [A,B] :
      ~ ( disjoint(singleton(A),B)
        & in(A,B) ) ).

fof(existence_m1_subset_1,axiom,
    ! [A] :
    ? [B] : element(B,A) ).

fof(t39_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,singleton(B))
    <=> ( A = singleton(B)
        | A = empty_set ) ) ).

fof(t3_xboole_0,lemma,
    ! [A,B] :
      ( ~ ( ~ disjoint(A,B)
          & ! [C] :
              ~ ( in(C,A)
                & in(C,B) ) )
      & ~ ( ? [C] :
              ( in(C,B)
              & in(C,A) )
          & disjoint(A,B) ) ) ).

fof(fc6_relat_1,axiom,
    ! [A] :
      ( ( relation(A)
        & ~ empty(A) )
     => ~ empty(relation_rng(A)) ) ).

fof(d5_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( B = relation_rng(A)
        <=> ! [C] :
              ( ? [D] : in(ordered_pair(D,C),A)
            <=> in(C,B) ) )
     <= relation(A) ) ).

fof(fc2_xboole_0,axiom,
    ! [A,B] :
      ( ~ empty(set_union2(A,B))
     <= ~ empty(A) ) ).

fof(t74_relat_1,lemma,
    ! [A,B,C,D] :
      ( relation(D)
     => ( ( in(ordered_pair(A,B),D)
          & in(A,C) )
      <=> in(ordered_pair(A,B),relation_composition(identity_relation(C),D)) ) ) ).

fof(fc1_subset_1,axiom,
    ! [A] : ~ empty(powerset(A)) ).

fof(t48_setfam_1,lemma,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => ( union_of_subsets(A,complements_of_subsets(A,B)) = subset_difference(A,cast_to_subset(A),meet_of_subsets(A,B))
       <= B != empty_set ) ) ).

fof(t43_subset_1,lemma,
    ! [A,B] :
      ( element(B,powerset(A))
     => ! [C] :
          ( ( subset(B,subset_complement(A,C))
          <=> disjoint(B,C) )
         <= element(C,powerset(A)) ) ) ).

fof(d4_subset_1,axiom,
    ! [A] : A = cast_to_subset(A) ).

fof(rc1_xboole_0,axiom,
    ? [A] : empty(A) ).

fof(dt_k4_xboole_0,axiom,
    $true ).

fof(dt_k3_xboole_0,axiom,
    $true ).

fof(t6_boole,axiom,
    ! [A] :
      ( empty(A)
     => A = empty_set ) ).

fof(t10_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ~ ( A != D
        & A != C
        & unordered_pair(A,B) = unordered_pair(C,D) ) ).

fof(dt_k3_tarski,axiom,
    $true ).

fof(idempotence_k3_xboole_0,axiom,
    ! [A,B] : set_intersection2(A,A) = A ).

fof(t5_subset,axiom,
    ! [A,B,C] :
      ~ ( empty(C)
        & element(B,powerset(C))
        & in(A,B) ) ).

fof(t136_zfmisc_1,lemma,
    ! [A] :
    ? [B] :
      ( in(A,B)
      & ! [C] :
          ~ ( subset(C,B)
            & ~ in(C,B)
            & ~ are_equipotent(C,B) )
      & ! [C] :
          ( in(powerset(C),B)
         <= in(C,B) )
      & ! [C,D] :
          ( in(D,B)
         <= ( in(C,B)
            & subset(D,C) ) ) ) ).

fof(dt_k5_relat_1,axiom,
    ! [A,B] :
      ( ( relation(B)
        & relation(A) )
     => relation(relation_composition(A,B)) ) ).

fof(t12_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
     => B = set_union2(A,B) ) ).

fof(dt_k7_setfam_1,axiom,
    ! [A,B] :
      ( element(complements_of_subsets(A,B),powerset(powerset(A)))
     <= element(B,powerset(powerset(A))) ) ).

fof(dt_k6_relat_1,axiom,
    ! [A] : relation(identity_relation(A)) ).

