fof(dt_k1_relat_1,axiom,
    $true ).

fof(t12_relset_1,lemma,
    ! [A,B,C] :
      ( ( subset(relation_dom(C),A)
        & subset(relation_rng(C),B) )
     <= relation_of2_as_subset(C,A,B) ) ).

fof(existence_m1_subset_1,axiom,
    ! [A] :
    ? [B] : element(B,A) ).

fof(t39_xboole_1,lemma,
    ! [A,B] : set_union2(A,B) = set_union2(A,set_difference(B,A)) ).

fof(dt_k6_setfam_1,axiom,
    ! [A,B] :
      ( element(meet_of_subsets(A,B),powerset(A))
     <= element(B,powerset(powerset(A))) ) ).

fof(fc4_funct_1,axiom,
    ! [A,B] :
      ( ( function(relation_dom_restriction(A,B))
        & relation(relation_dom_restriction(A,B)) )
     <= ( function(A)
        & relation(A) ) ) ).

fof(symmetry_r1_xboole_0,axiom,
    ! [A,B] :
      ( disjoint(A,B)
     => disjoint(B,A) ) ).

fof(t118_relat_1,lemma,
    ! [A,B] :
      ( subset(relation_rng(relation_rng_restriction(A,B)),relation_rng(B))
     <= relation(B) ) ).

fof(dt_k1_ordinal1,axiom,
    $true ).

fof(t37_xboole_1,lemma,
    ! [A,B] :
      ( empty_set = set_difference(A,B)
    <=> subset(A,B) ) ).

fof(t7_xboole_1,lemma,
    ! [A,B] : subset(A,set_union2(A,B)) ).

fof(t14_relset_1,lemma,
    ! [A,B,C,D] :
      ( ( relation_of2_as_subset(D,C,B)
       <= subset(relation_rng(D),B) )
     <= relation_of2_as_subset(D,C,A) ) ).

fof(dt_k9_relat_1,axiom,
    $true ).

fof(d12_relat_1,axiom,
    ! [A,B] :
      ( ! [C] :
          ( relation(C)
         => ( relation_rng_restriction(A,B) = C
          <=> ! [D,E] :
                ( ( in(ordered_pair(D,E),B)
                  & in(E,A) )
              <=> in(ordered_pair(D,E),C) ) ) )
     <= relation(B) ) ).

fof(redefinition_m2_relset_1,axiom,
    ! [A,B,C] :
      ( relation_of2_as_subset(C,A,B)
    <=> relation_of2(C,A,B) ) ).

fof(s1_tarski__e8_6__wellord2__1,axiom,
    ! [A,B] :
      ( ( ! [C,D,E] :
            ( ( C = D
              & E = C
              & ? [G] :
                  ( ordinal(G)
                  & in(G,A)
                  & G = E )
              & ? [F] :
                  ( ordinal(F)
                  & F = D
                  & in(F,A) ) )
           => D = E )
       => ? [C] :
          ! [D] :
            ( in(D,C)
          <=> ? [E] :
                ( in(E,succ(B))
                & E = D
                & ? [H] :
                    ( H = D
                    & in(H,A)
                    & ordinal(H) ) ) ) )
     <= ordinal(B) ) ).

fof(t17_wellord1,lemma,
    ! [A,B] :
      ( relation_dom_restriction(relation_rng_restriction(A,B),A) = relation_restriction(B,A)
     <= relation(B) ) ).

fof(d5_funct_1,axiom,
    ! [A] :
      ( ( relation(A)
        & function(A) )
     => ! [B] :
          ( ! [C] :
              ( ? [D] :
                  ( in(D,relation_dom(A))
                  & C = apply(A,D) )
            <=> in(C,B) )
        <=> relation_rng(A) = B ) ) ).

fof(fc12_relat_1,axiom,
    ( empty(empty_set)
    & relation_empty_yielding(empty_set)
    & relation(empty_set) ) ).

fof(t17_xboole_1,lemma,
    ! [A,B] : subset(set_intersection2(A,B),A) ).

fof(l30_wellord2,lemma,
    ! [A,B] :
      ( relation(B)
     => ~ ( well_ordering(B)
          & ! [C] :
              ( ~ well_orders(C,A)
             <= relation(C) )
          & equipotent(A,relation_field(B)) ) ) ).

fof(d2_zfmisc_1,axiom,
    ! [A,B,C] :
      ( cartesian_product2(A,B) = C
    <=> ! [D] :
          ( in(D,C)
        <=> ? [E,F] :
              ( in(E,A)
              & in(F,B)
              & D = ordered_pair(E,F) ) ) ) ).

fof(l1_zfmisc_1,lemma,
    ! [A] : singleton(A) != empty_set ).

fof(t37_relat_1,lemma,
    ! [A] :
      ( ( relation_rng(A) = relation_dom(relation_inverse(A))
        & relation_dom(A) = relation_rng(relation_inverse(A)) )
     <= relation(A) ) ).

fof(fc3_subset_1,axiom,
    ! [A,B] : ~ empty(unordered_pair(A,B)) ).

fof(d1_relat_1,axiom,
    ! [A] :
      ( relation(A)
    <=> ! [B] :
          ~ ( ! [C,D] : B != ordered_pair(C,D)
            & in(B,A) ) ) ).

fof(d6_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => relation_field(A) = set_union2(relation_dom(A),relation_rng(A)) ) ).

fof(t41_ordinal1,lemma,
    ! [A] :
      ( ordinal(A)
     => ( being_limit_ordinal(A)
      <=> ! [B] :
            ( ( in(succ(B),A)
             <= in(B,A) )
           <= ordinal(B) ) ) ) ).

fof(t45_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
     => B = set_union2(A,set_difference(B,A)) ) ).

fof(t22_relset_1,lemma,
    ! [A,B,C] :
      ( relation_of2_as_subset(C,B,A)
     => ( B = relation_dom_as_subset(B,A,C)
      <=> ! [D] :
            ~ ( ! [E] : ~ in(ordered_pair(D,E),C)
              & in(D,B) ) ) ) ).

fof(l4_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,singleton(B))
    <=> ( A = empty_set
        | A = singleton(B) ) ) ).

fof(d5_subset_1,axiom,
    ! [A,B] :
      ( subset_complement(A,B) = set_difference(A,B)
     <= element(B,powerset(A)) ) ).

fof(fc11_relat_1,axiom,
    ! [A] :
      ( ( empty(relation_inverse(A))
        & relation(relation_inverse(A)) )
     <= empty(A) ) ).

fof(t4_wellord2,lemma,
    ! [A] :
      ( connected(inclusion_relation(A))
     <= ordinal(A) ) ).

fof(t94_relat_1,lemma,
    ! [A,B] :
      ( relation_dom_restriction(B,A) = relation_composition(identity_relation(A),B)
     <= relation(B) ) ).

fof(t43_subset_1,lemma,
    ! [A,B] :
      ( ! [C] :
          ( ( subset(B,subset_complement(A,C))
          <=> disjoint(B,C) )
         <= element(C,powerset(A)) )
     <= element(B,powerset(A)) ) ).

fof(t167_relat_1,lemma,
    ! [A,B] :
      ( relation(B)
     => subset(relation_inverse_image(B,A),relation_dom(B)) ) ).

fof(s1_xboole_0__e6_22__wellord2,lemma,
    ! [A] :
    ? [B] :
    ! [C] :
      ( in(C,B)
    <=> ( in(C,A)
        & ordinal(C) ) ) ).

fof(t38_zfmisc_1,lemma,
    ! [A,B,C] :
      ( subset(unordered_pair(A,B),C)
    <=> ( in(B,C)
        & in(A,C) ) ) ).

fof(dt_k7_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => element(complements_of_subsets(A,B),powerset(powerset(A))) ) ).

fof(t10_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ~ ( unordered_pair(C,D) = unordered_pair(A,B)
        & A != D
        & A != C ) ).

fof(d2_xboole_0,axiom,
    ! [A,B,C] :
      ( ! [D] :
          ( in(D,C)
        <=> ( in(D,B)
            | in(D,A) ) )
    <=> C = set_union2(A,B) ) ).

fof(t69_enumset1,lemma,
    ! [A] : unordered_pair(A,A) = singleton(A) ).

fof(l32_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
    <=> set_difference(A,B) = empty_set ) ).

fof(d1_wellord1,axiom,
    ! [A] :
      ( ! [B,C] :
          ( ! [D] :
              ( ( in(ordered_pair(D,B),A)
                & D != B )
            <=> in(D,C) )
        <=> C = fiber(A,B) )
     <= relation(A) ) ).

fof(t117_relat_1,lemma,
    ! [A,B] :
      ( relation(B)
     => subset(relation_rng_restriction(A,B),B) ) ).

fof(dt_m1_relset_1,axiom,
    $true ).

fof(d2_wellord1,axiom,
    ! [A] :
      ( ( ! [B] :
            ~ ( subset(B,relation_field(A))
              & ! [C] :
                  ~ ( in(C,B)
                    & disjoint(fiber(A,C),B) )
              & B != empty_set )
      <=> well_founded_relation(A) )
     <= relation(A) ) ).

fof(t22_funct_1,lemma,
    ! [A,B] :
      ( ! [C] :
          ( ( function(C)
            & relation(C) )
         => ( apply(B,apply(C,A)) = apply(relation_composition(C,B),A)
           <= in(A,relation_dom(relation_composition(C,B))) ) )
     <= ( relation(B)
        & function(B) ) ) ).

fof(d13_funct_1,axiom,
    ! [A] :
      ( ! [B,C] :
          ( C = relation_inverse_image(A,B)
        <=> ! [D] :
              ( ( in(apply(A,D),B)
                & in(D,relation_dom(A)) )
            <=> in(D,C) ) )
     <= ( relation(A)
        & function(A) ) ) ).

fof(dt_k1_tarski,axiom,
    $true ).

fof(dt_k4_xboole_0,axiom,
    $true ).

fof(redefinition_k4_relset_1,axiom,
    ! [A,B,C] :
      ( relation_of2(C,A,B)
     => relation_dom_as_subset(A,B,C) = relation_dom(C) ) ).

fof(t8_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(set_union2(A,C),B)
     <= ( subset(C,B)
        & subset(A,B) ) ) ).

fof(t146_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => relation_rng(A) = relation_image(A,relation_dom(A)) ) ).

fof(dt_k1_funct_1,axiom,
    $true ).

fof(t49_wellord1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ! [C] :
              ( ( function(C)
                & relation(C) )
             => ( relation_isomorphism(B,A,function_inverse(C))
               <= relation_isomorphism(A,B,C) ) ) )
     <= relation(A) ) ).

fof(d1_enumset1,axiom,
    ! [A,B,C,D] :
      ( ! [E] :
          ( in(E,D)
        <=> ~ ( B != E
              & C != E
              & E != A ) )
    <=> unordered_triple(A,B,C) = D ) ).

fof(reflexivity_r1_tarski,axiom,
    ! [A,B] : subset(A,A) ).

fof(l3_subset_1,lemma,
    ! [A,B] :
      ( element(B,powerset(A))
     => ! [C] :
          ( in(C,A)
         <= in(C,B) ) ) ).

fof(existence_m2_relset_1,axiom,
    ! [A,B] :
    ? [C] : relation_of2_as_subset(C,A,B) ).

fof(t6_boole,axiom,
    ! [A] :
      ( empty(A)
     => A = empty_set ) ).

fof(rc1_funct_1,axiom,
    ? [A] :
      ( relation(A)
      & function(A) ) ).

fof(t146_funct_1,lemma,
    ! [A,B] :
      ( relation(B)
     => ( subset(A,relation_inverse_image(B,relation_image(B,A)))
       <= subset(A,relation_dom(B)) ) ) ).

fof(rc3_funct_1,axiom,
    ? [A] :
      ( function(A)
      & one_to_one(A)
      & relation(A) ) ).

fof(commutativity_k3_xboole_0,axiom,
    ! [A,B] : set_intersection2(B,A) = set_intersection2(A,B) ).

fof(rc3_ordinal1,axiom,
    ? [A] :
      ( ~ empty(A)
      & epsilon_transitive(A)
      & epsilon_connected(A)
      & ordinal(A) ) ).

fof(t60_relat_1,lemma,
    ( empty_set = relation_rng(empty_set)
    & empty_set = relation_dom(empty_set) ) ).

fof(t23_ordinal1,lemma,
    ! [A,B] :
      ( ordinal(B)
     => ( in(A,B)
       => ordinal(A) ) ) ).

fof(t2_boole,axiom,
    ! [A] : set_intersection2(A,empty_set) = empty_set ).

fof(d1_wellord2,axiom,
    ! [A,B] :
      ( ( inclusion_relation(A) = B
      <=> ( ! [C,D] :
              ( ( in(ordered_pair(C,D),B)
              <=> subset(C,D) )
             <= ( in(D,A)
                & in(C,A) ) )
          & relation_field(B) = A ) )
     <= relation(B) ) ).

fof(t28_xboole_1,lemma,
    ! [A,B] :
      ( A = set_intersection2(A,B)
     <= subset(A,B) ) ).

fof(t7_tarski,axiom,
    ! [A,B] :
      ~ ( ! [C] :
            ~ ( in(C,B)
              & ! [D] :
                  ~ ( in(D,C)
                    & in(D,B) ) )
        & in(A,B) ) ).

fof(d9_relat_2,axiom,
    ! [A] :
      ( relation(A)
     => ( is_reflexive_in(A,relation_field(A))
      <=> reflexive(A) ) ) ).

fof(t3_boole,axiom,
    ! [A] : A = set_difference(A,empty_set) ).

fof(t99_relat_1,lemma,
    ! [A,B] :
      ( subset(relation_rng(relation_dom_restriction(B,A)),relation_rng(B))
     <= relation(B) ) ).

fof(involutiveness_k7_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => complements_of_subsets(A,complements_of_subsets(A,B)) = B ) ).

fof(d11_relat_1,axiom,
    ! [A] :
      ( ! [B,C] :
          ( ( relation_dom_restriction(A,B) = C
          <=> ! [D,E] :
                ( ( in(ordered_pair(D,E),A)
                  & in(D,B) )
              <=> in(ordered_pair(D,E),C) ) )
         <= relation(C) )
     <= relation(A) ) ).

fof(t3_wellord2,lemma,
    ! [A] : transitive(inclusion_relation(A)) ).

fof(l82_funct_1,lemma,
    ! [A,B,C] :
      ( ( in(B,relation_dom(relation_dom_restriction(C,A)))
      <=> ( in(B,A)
          & in(B,relation_dom(C)) ) )
     <= ( function(C)
        & relation(C) ) ) ).

fof(fc2_relat_1,axiom,
    ! [A,B] :
      ( relation(set_union2(A,B))
     <= ( relation(B)
        & relation(A) ) ) ).

fof(t160_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation_rng(relation_composition(A,B)) = relation_image(B,relation_rng(A))
         <= relation(B) ) ) ).

fof(l28_zfmisc_1,lemma,
    ! [A,B] :
      ( disjoint(singleton(A),B)
     <= ~ in(A,B) ) ).

fof(fc1_zfmisc_1,axiom,
    ! [A,B] : ~ empty(ordered_pair(A,B)) ).

fof(dt_k2_tarski,axiom,
    $true ).

fof(dt_k5_relat_1,axiom,
    ! [A,B] :
      ( relation(relation_composition(A,B))
     <= ( relation(A)
        & relation(B) ) ) ).

fof(d6_relat_2,axiom,
    ! [A] :
      ( ! [B] :
          ( ! [C,D] :
              ~ ( in(D,B)
                & ~ in(ordered_pair(D,C),A)
                & ~ in(ordered_pair(C,D),A)
                & D != C
                & in(C,B) )
        <=> is_connected_in(A,B) )
     <= relation(A) ) ).

fof(t21_ordinal1,lemma,
    ! [A] :
      ( ! [B] :
          ( ordinal(B)
         => ( proper_subset(A,B)
           => in(A,B) ) )
     <= epsilon_transitive(A) ) ).

fof(t65_zfmisc_1,lemma,
    ! [A,B] :
      ( set_difference(A,singleton(B)) = A
    <=> ~ in(B,A) ) ).

fof(d12_funct_1,axiom,
    ! [A] :
      ( ( function(A)
        & relation(A) )
     => ! [B,C] :
          ( relation_image(A,B) = C
        <=> ! [D] :
              ( in(D,C)
            <=> ? [E] :
                  ( in(E,B)
                  & apply(A,E) = D
                  & in(E,relation_dom(A)) ) ) ) ) ).

fof(t20_relat_1,lemma,
    ! [A,B,C] :
      ( ( in(ordered_pair(A,B),C)
       => ( in(B,relation_rng(C))
          & in(A,relation_dom(C)) ) )
     <= relation(C) ) ).

fof(d6_ordinal1,axiom,
    ! [A] :
      ( A = union(A)
    <=> being_limit_ordinal(A) ) ).

fof(t6_zfmisc_1,lemma,
    ! [A,B] :
      ( A = B
     <= subset(singleton(A),singleton(B)) ) ).

fof(t118_zfmisc_1,lemma,
    ! [A,B,C] :
      ( ( subset(cartesian_product2(C,A),cartesian_product2(C,B))
        & subset(cartesian_product2(A,C),cartesian_product2(B,C)) )
     <= subset(A,B) ) ).

fof(t36_xboole_1,lemma,
    ! [A,B] : subset(set_difference(A,B),A) ).

fof(t119_relat_1,lemma,
    ! [A,B] :
      ( relation_rng(relation_rng_restriction(A,B)) = set_intersection2(relation_rng(B),A)
     <= relation(B) ) ).

fof(involutiveness_k4_relat_1,axiom,
    ! [A] :
      ( relation_inverse(relation_inverse(A)) = A
     <= relation(A) ) ).

fof(d3_xboole_0,axiom,
    ! [A,B,C] :
      ( ! [D] :
          ( in(D,C)
        <=> ( in(D,A)
            & in(D,B) ) )
    <=> C = set_intersection2(A,B) ) ).

fof(t145_funct_1,lemma,
    ! [A,B] :
      ( subset(relation_image(B,relation_inverse_image(B,A)),A)
     <= ( relation(B)
        & function(B) ) ) ).

fof(t64_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ( ( empty_set = relation_rng(A)
          | empty_set = relation_dom(A) )
       => empty_set = A ) ) ).

fof(t1_boole,axiom,
    ! [A] : set_union2(A,empty_set) = A ).

fof(dt_k3_xboole_0,axiom,
    $true ).

fof(d1_xboole_0,axiom,
    ! [A] :
      ( A = empty_set
    <=> ! [B] : ~ in(B,A) ) ).

fof(t23_relset_1,lemma,
    ! [A,B,C] :
      ( relation_of2_as_subset(C,A,B)
     => ( ! [D] :
            ~ ( ! [E] : ~ in(ordered_pair(E,D),C)
              & in(D,B) )
      <=> relation_rng_as_subset(A,B,C) = B ) ) ).

fof(d9_funct_1,axiom,
    ! [A] :
      ( ( function(A)
        & relation(A) )
     => ( function_inverse(A) = relation_inverse(A)
       <= one_to_one(A) ) ) ).

fof(dt_k2_subset_1,axiom,
    ! [A] : element(cast_to_subset(A),powerset(A)) ).

fof(fc4_relat_1,axiom,
    ( empty(empty_set)
    & relation(empty_set) ) ).

fof(t63_xboole_1,lemma,
    ! [A,B,C] :
      ( ( subset(A,B)
        & disjoint(B,C) )
     => disjoint(A,C) ) ).

fof(t92_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,union(B))
     <= in(A,B) ) ).

fof(t25_wellord2,lemma,
    ! [A,B] :
      ( relation(B)
     => ( ( well_ordering(relation_restriction(B,A))
          & relation_field(relation_restriction(B,A)) = A )
       <= well_orders(B,A) ) ) ).

fof(d13_relat_1,axiom,
    ! [A] :
      ( ! [B,C] :
          ( relation_image(A,B) = C
        <=> ! [D] :
              ( in(D,C)
            <=> ? [E] :
                  ( in(E,B)
                  & in(ordered_pair(E,D),A) ) ) )
     <= relation(A) ) ).

fof(fc5_funct_1,axiom,
    ! [A,B] :
      ( ( function(B)
        & relation(B) )
     => ( relation(relation_rng_restriction(A,B))
        & function(relation_rng_restriction(A,B)) ) ) ).

fof(redefinition_k5_setfam_1,axiom,
    ! [A,B] :
      ( union_of_subsets(A,B) = union(B)
     <= element(B,powerset(powerset(A))) ) ).

fof(t21_wellord1,lemma,
    ! [A,B,C] :
      ( relation(C)
     => subset(fiber(relation_restriction(C,A),B),fiber(C,B)) ) ).

fof(dt_k1_wellord2,axiom,
    ! [A] : relation(inclusion_relation(A)) ).

fof(idempotence_k3_xboole_0,axiom,
    ! [A,B] : A = set_intersection2(A,A) ).

fof(t24_wellord1,lemma,
    ! [A,B] :
      ( ( transitive(B)
       => transitive(relation_restriction(B,A)) )
     <= relation(B) ) ).

fof(t54_subset_1,lemma,
    ! [A,B,C] :
      ( ~ ( in(B,C)
          & in(B,subset_complement(A,C)) )
     <= element(C,powerset(A)) ) ).

fof(fc1_ordinal1,axiom,
    ! [A] : ~ empty(succ(A)) ).

fof(s1_tarski__e6_22__wellord2__1,axiom,
    ! [A] :
      ( ? [B] :
        ! [C] :
          ( in(C,B)
        <=> ? [D] :
              ( ordinal(C)
              & C = D
              & in(D,A) ) )
     <= ! [B,C,D] :
          ( C = D
         <= ( ordinal(C)
            & ordinal(D)
            & D = B
            & C = B ) ) ) ).

fof(d2_mcart_1,axiom,
    ! [A] :
      ( ! [B] :
          ( pair_second(A) = B
        <=> ! [C,D] :
              ( D = B
             <= ordered_pair(C,D) = A ) )
     <= ? [B,C] : A = ordered_pair(B,C) ) ).

fof(t33_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,B)
     => subset(set_difference(A,C),set_difference(B,C)) ) ).

fof(t144_relat_1,lemma,
    ! [A,B] :
      ( subset(relation_image(B,A),relation_rng(B))
     <= relation(B) ) ).

fof(dt_k1_setfam_1,axiom,
    $true ).

fof(antisymmetry_r2_xboole_0,axiom,
    ! [A,B] :
      ( ~ proper_subset(B,A)
     <= proper_subset(A,B) ) ).

fof(s1_relat_1__e6_21__wellord2,lemma,
    ! [A,B,C] :
      ( ( relation(B)
        & function(C)
        & relation(C) )
     => ? [D] :
          ( ! [E,F] :
              ( ( in(ordered_pair(apply(C,E),apply(C,F)),B)
                & in(F,A)
                & in(E,A) )
            <=> in(ordered_pair(E,F),D) )
          & relation(D) ) ) ).

fof(rc4_funct_1,axiom,
    ? [A] :
      ( relation(A)
      & relation_empty_yielding(A)
      & function(A) ) ).

fof(t119_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( subset(cartesian_product2(A,C),cartesian_product2(B,D))
     <= ( subset(A,B)
        & subset(C,D) ) ) ).

fof(t18_wellord1,lemma,
    ! [A,B] :
      ( relation(B)
     => relation_rng_restriction(A,relation_dom_restriction(B,A)) = relation_restriction(B,A) ) ).

fof(t3_subset,axiom,
    ! [A,B] :
      ( subset(A,B)
    <=> element(A,powerset(B)) ) ).

fof(t68_funct_1,lemma,
    ! [A,B] :
      ( ( relation(B)
        & function(B) )
     => ! [C] :
          ( ( function(C)
            & relation(C) )
         => ( B = relation_dom_restriction(C,A)
          <=> ( set_intersection2(relation_dom(C),A) = relation_dom(B)
              & ! [D] :
                  ( apply(B,D) = apply(C,D)
                 <= in(D,relation_dom(B)) ) ) ) ) ) ).

fof(d3_wellord1,axiom,
    ! [A] :
      ( ! [B] :
          ( is_well_founded_in(A,B)
        <=> ! [C] :
              ~ ( empty_set != C
                & ! [D] :
                    ~ ( disjoint(fiber(A,D),C)
                      & in(D,C) )
                & subset(C,B) ) )
     <= relation(A) ) ).

fof(t42_ordinal1,lemma,
    ! [A] :
      ( ( ~ ( ! [B] :
                ( A != succ(B)
               <= ordinal(B) )
            & ~ being_limit_ordinal(A) )
        & ~ ( ? [B] :
                ( ordinal(B)
                & succ(B) = A )
            & being_limit_ordinal(A) ) )
     <= ordinal(A) ) ).

fof(s3_funct_1__e16_22__wellord2,conjecture,
    ! [A] :
    ? [B] :
      ( function(B)
      & relation_dom(B) = A
      & ! [C] :
          ( apply(B,C) = singleton(C)
         <= in(C,A) )
      & relation(B) ) ).

fof(fc13_relat_1,axiom,
    ! [A,B] :
      ( ( relation(relation_dom_restriction(A,B))
        & relation_empty_yielding(relation_dom_restriction(A,B)) )
     <= ( relation_empty_yielding(A)
        & relation(A) ) ) ).

fof(t19_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,set_intersection2(B,C))
     <= ( subset(A,C)
        & subset(A,B) ) ) ).

fof(t99_zfmisc_1,lemma,
    ! [A] : A = union(powerset(A)) ).

fof(d3_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ( ! [C,D] :
                ( in(ordered_pair(C,D),A)
               => in(ordered_pair(C,D),B) )
          <=> subset(A,B) ) )
     <= relation(A) ) ).

fof(t4_subset,axiom,
    ! [A,B,C] :
      ( element(A,C)
     <= ( element(B,powerset(C))
        & in(A,B) ) ) ).

fof(t8_funct_1,lemma,
    ! [A,B,C] :
      ( ( in(ordered_pair(A,B),C)
      <=> ( in(A,relation_dom(C))
          & apply(C,A) = B ) )
     <= ( relation(C)
        & function(C) ) ) ).

fof(cc3_ordinal1,axiom,
    ! [A] :
      ( empty(A)
     => ( ordinal(A)
        & epsilon_connected(A)
        & epsilon_transitive(A) ) ) ).

fof(redefinition_r2_wellord2,axiom,
    ! [A,B] :
      ( equipotent(A,B)
    <=> are_equipotent(A,B) ) ).

fof(dt_k4_relset_1,axiom,
    ! [A,B,C] :
      ( relation_of2(C,A,B)
     => element(relation_dom_as_subset(A,B,C),powerset(A)) ) ).

fof(d7_wellord1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation(B)
         => ! [C] :
              ( ( relation_isomorphism(A,B,C)
              <=> ( ! [D,E] :
                      ( in(ordered_pair(D,E),A)
                    <=> ( in(ordered_pair(apply(C,D),apply(C,E)),B)
                        & in(E,relation_field(A))
                        & in(D,relation_field(A)) ) )
                  & one_to_one(C)
                  & relation_field(B) = relation_rng(C)
                  & relation_field(A) = relation_dom(C) ) )
             <= ( function(C)
                & relation(C) ) ) ) ) ).

fof(t39_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,singleton(B))
    <=> ( A = empty_set
        | A = singleton(B) ) ) ).

fof(fc3_relat_1,axiom,
    ! [A,B] :
      ( relation(set_difference(A,B))
     <= ( relation(A)
        & relation(B) ) ) ).

fof(fc2_ordinal1,axiom,
    ( relation(empty_set)
    & relation_empty_yielding(empty_set)
    & function(empty_set)
    & empty(empty_set)
    & ordinal(empty_set)
    & epsilon_connected(empty_set)
    & epsilon_transitive(empty_set)
    & one_to_one(empty_set) ) ).

fof(rc1_xboole_0,axiom,
    ? [A] : empty(A) ).

fof(d1_funct_1,axiom,
    ! [A] :
      ( ! [B,C,D] :
          ( ( in(ordered_pair(B,D),A)
            & in(ordered_pair(B,C),A) )
         => C = D )
    <=> function(A) ) ).

fof(t57_funct_1,lemma,
    ! [A,B] :
      ( ( ( in(A,relation_rng(B))
          & one_to_one(B) )
       => ( apply(relation_composition(function_inverse(B),B),A) = A
          & A = apply(B,apply(function_inverse(B),A)) ) )
     <= ( relation(B)
        & function(B) ) ) ).

fof(connectedness_r1_ordinal1,axiom,
    ! [A,B] :
      ( ( ordinal(A)
        & ordinal(B) )
     => ( ordinal_subset(B,A)
        | ordinal_subset(A,B) ) ) ).

fof(dt_k7_relat_1,axiom,
    ! [A,B] :
      ( relation(relation_dom_restriction(A,B))
     <= relation(A) ) ).

fof(dt_k10_relat_1,axiom,
    $true ).

fof(t16_wellord1,lemma,
    ! [A,B,C] :
      ( ( ( in(A,cartesian_product2(B,B))
          & in(A,C) )
      <=> in(A,relation_restriction(C,B)) )
     <= relation(C) ) ).

fof(fc3_ordinal1,axiom,
    ! [A] :
      ( ( ordinal(succ(A))
        & epsilon_connected(succ(A))
        & epsilon_transitive(succ(A))
        & ~ empty(succ(A)) )
     <= ordinal(A) ) ).

fof(t6_wellord2,lemma,
    ! [A] :
      ( well_founded_relation(inclusion_relation(A))
     <= ordinal(A) ) ).

fof(t86_relat_1,lemma,
    ! [A,B,C] :
      ( relation(C)
     => ( ( in(A,relation_dom(C))
          & in(A,B) )
      <=> in(A,relation_dom(relation_dom_restriction(C,B))) ) ) ).

fof(d16_relat_2,axiom,
    ! [A] :
      ( relation(A)
     => ( is_transitive_in(A,relation_field(A))
      <=> transitive(A) ) ) ).

fof(dt_k4_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => relation(relation_inverse(A)) ) ).

fof(d1_relset_1,axiom,
    ! [A,B,C] :
      ( subset(C,cartesian_product2(A,B))
    <=> relation_of2(C,A,B) ) ).

fof(t4_boole,axiom,
    ! [A] : set_difference(empty_set,A) = empty_set ).

fof(t5_subset,axiom,
    ! [A,B,C] :
      ~ ( empty(C)
        & element(B,powerset(C))
        & in(A,B) ) ).

fof(l3_wellord1,lemma,
    ! [A] :
      ( ( antisymmetric(A)
      <=> ! [B,C] :
            ( C = B
           <= ( in(ordered_pair(B,C),A)
              & in(ordered_pair(C,B),A) ) ) )
     <= relation(A) ) ).

fof(t32_ordinal1,lemma,
    ! [A,B] :
      ( ordinal(B)
     => ~ ( subset(A,B)
          & ! [C] :
              ( ~ ( ! [D] :
                      ( ( ordinal_subset(C,D)
                       <= in(D,A) )
                     <= ordinal(D) )
                  & in(C,A) )
             <= ordinal(C) )
          & A != empty_set ) ) ).

fof(t88_relat_1,lemma,
    ! [A,B] :
      ( relation(B)
     => subset(relation_dom_restriction(B,A),B) ) ).

fof(d1_ordinal1,axiom,
    ! [A] : set_union2(A,singleton(A)) = succ(A) ).

fof(t31_wellord1,lemma,
    ! [A,B] :
      ( ( well_founded_relation(relation_restriction(B,A))
       <= well_founded_relation(B) )
     <= relation(B) ) ).

fof(t3_ordinal1,lemma,
    ! [A,B,C] :
      ~ ( in(B,C)
        & in(C,A)
        & in(A,B) ) ).

fof(t48_xboole_1,lemma,
    ! [A,B] : set_intersection2(A,B) = set_difference(A,set_difference(A,B)) ).

fof(antisymmetry_r2_hidden,axiom,
    ! [A,B] :
      ( ~ in(B,A)
     <= in(A,B) ) ).

fof(t31_ordinal1,lemma,
    ! [A] :
      ( ordinal(A)
     <= ! [B] :
          ( in(B,A)
         => ( ordinal(B)
            & subset(B,A) ) ) ) ).

fof(d10_relat_1,axiom,
    ! [A,B] :
      ( ( identity_relation(A) = B
      <=> ! [C,D] :
            ( in(ordered_pair(C,D),B)
          <=> ( in(C,A)
              & C = D ) ) )
     <= relation(B) ) ).

fof(l55_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( in(ordered_pair(A,B),cartesian_product2(C,D))
    <=> ( in(A,C)
        & in(B,D) ) ) ).

fof(dt_k5_relset_1,axiom,
    ! [A,B,C] :
      ( relation_of2(C,A,B)
     => element(relation_rng_as_subset(A,B,C),powerset(B)) ) ).

fof(reflexivity_r1_ordinal1,axiom,
    ! [A,B] :
      ( ( ordinal(B)
        & ordinal(A) )
     => ordinal_subset(A,A) ) ).

fof(t25_wellord1,lemma,
    ! [A,B] :
      ( relation(B)
     => ( antisymmetric(B)
       => antisymmetric(relation_restriction(B,A)) ) ) ).

fof(d5_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( ! [C] :
              ( ? [D] : in(ordered_pair(D,C),A)
            <=> in(C,B) )
        <=> relation_rng(A) = B )
     <= relation(A) ) ).

fof(dt_k1_mcart_1,axiom,
    $true ).

fof(t37_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),B)
    <=> in(A,B) ) ).

fof(fc3_xboole_0,axiom,
    ! [A,B] :
      ( ~ empty(set_union2(B,A))
     <= ~ empty(A) ) ).

fof(t50_subset_1,lemma,
    ! [A] :
      ( empty_set != A
     => ! [B] :
          ( ! [C] :
              ( element(C,A)
             => ( ~ in(C,B)
               => in(C,subset_complement(A,B)) ) )
         <= element(B,powerset(A)) ) ) ).

fof(dt_k2_funct_1,axiom,
    ! [A] :
      ( ( relation(function_inverse(A))
        & function(function_inverse(A)) )
     <= ( relation(A)
        & function(A) ) ) ).

fof(redefinition_k5_relset_1,axiom,
    ! [A,B,C] :
      ( relation_of2(C,A,B)
     => relation_rng(C) = relation_rng_as_subset(A,B,C) ) ).

fof(t54_wellord1,lemma,
    ! [A] :
      ( ! [B] :
          ( ! [C] :
              ( ( well_ordering(B)
               <= ( relation_isomorphism(A,B,C)
                  & well_ordering(A) ) )
             <= ( function(C)
                & relation(C) ) )
         <= relation(B) )
     <= relation(A) ) ).

fof(d2_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( ( ! [C,D] :
                ( in(ordered_pair(C,D),A)
              <=> in(ordered_pair(C,D),B) )
          <=> B = A )
         <= relation(B) )
     <= relation(A) ) ).

fof(irreflexivity_r2_xboole_0,axiom,
    ! [A,B] : ~ proper_subset(A,A) ).

fof(t26_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(set_intersection2(A,C),set_intersection2(B,C))
     <= subset(A,B) ) ).

fof(t174_relat_1,lemma,
    ! [A,B] :
      ( relation(B)
     => ~ ( empty_set = relation_inverse_image(B,A)
          & subset(A,relation_rng(B))
          & A != empty_set ) ) ).

fof(t53_wellord1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ! [C] :
              ( ( relation(C)
                & function(C) )
             => ( ( ( antisymmetric(A)
                   => antisymmetric(B) )
                  & ( well_founded_relation(B)
                   <= well_founded_relation(A) )
                  & ( connected(A)
                   => connected(B) )
                  & ( transitive(B)
                   <= transitive(A) )
                  & ( reflexive(A)
                   => reflexive(B) ) )
               <= relation_isomorphism(A,B,C) ) ) )
     <= relation(A) ) ).

fof(dt_k3_subset_1,axiom,
    ! [A,B] :
      ( element(subset_complement(A,B),powerset(A))
     <= element(B,powerset(A)) ) ).

fof(dt_k6_subset_1,axiom,
    ! [A,B,C] :
      ( ( element(C,powerset(A))
        & element(B,powerset(A)) )
     => element(subset_difference(A,B,C),powerset(A)) ) ).

fof(t166_relat_1,lemma,
    ! [A,B,C] :
      ( ( ? [D] :
            ( in(D,relation_rng(C))
            & in(ordered_pair(A,D),C)
            & in(D,B) )
      <=> in(A,relation_inverse_image(C,B)) )
     <= relation(C) ) ).

fof(t178_relat_1,lemma,
    ! [A,B,C] :
      ( ( subset(relation_inverse_image(C,A),relation_inverse_image(C,B))
       <= subset(A,B) )
     <= relation(C) ) ).

fof(t70_funct_1,lemma,
    ! [A,B,C] :
      ( ( in(B,relation_dom(relation_dom_restriction(C,A)))
       => apply(relation_dom_restriction(C,A),B) = apply(C,B) )
     <= ( function(C)
        & relation(C) ) ) ).

fof(commutativity_k2_xboole_0,axiom,
    ! [A,B] : set_union2(B,A) = set_union2(A,B) ).

fof(l2_wellord1,lemma,
    ! [A] :
      ( ( ! [B,C,D] :
            ( ( in(ordered_pair(C,D),A)
              & in(ordered_pair(B,C),A) )
           => in(ordered_pair(B,D),A) )
      <=> transitive(A) )
     <= relation(A) ) ).

fof(fc1_xboole_0,axiom,
    empty(empty_set) ).

fof(dt_k1_wellord1,axiom,
    $true ).

fof(fc9_relat_1,axiom,
    ! [A,B] :
      ( ( empty(relation_composition(A,B))
        & relation(relation_composition(A,B)) )
     <= ( relation(B)
        & empty(A) ) ) ).

fof(d8_relat_2,axiom,
    ! [A] :
      ( ! [B] :
          ( ! [C,D,E] :
              ( in(ordered_pair(C,E),A)
             <= ( in(C,B)
                & in(D,B)
                & in(E,B)
                & in(ordered_pair(D,E),A)
                & in(ordered_pair(C,D),A) ) )
        <=> is_transitive_in(A,B) )
     <= relation(A) ) ).

fof(s1_funct_1__e16_22__wellord2__1,lemma,
    ! [A] :
      ( ! [B,C,D] :
          ( ( in(B,A)
            & singleton(B) = D
            & C = singleton(B)
            & in(B,A) )
         => C = D )
     => ? [B] :
          ( relation(B)
          & function(B)
          & ! [C,D] :
              ( in(ordered_pair(C,D),B)
            <=> ( singleton(C) = D
                & in(C,A)
                & in(C,A) ) ) ) ) ).

fof(t47_setfam_1,lemma,
    ! [A,B] :
      ( ( meet_of_subsets(A,complements_of_subsets(A,B)) = subset_difference(A,cast_to_subset(A),union_of_subsets(A,B))
       <= B != empty_set )
     <= element(B,powerset(powerset(A))) ) ).

fof(d3_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( in(C,A)
         => in(C,B) )
    <=> subset(A,B) ) ).

fof(cc1_funct_1,axiom,
    ! [A] :
      ( function(A)
     <= empty(A) ) ).

fof(t65_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ( empty_set = relation_dom(A)
      <=> empty_set = relation_rng(A) ) ) ).

fof(t33_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( B = D
        & A = C )
     <= ordered_pair(C,D) = ordered_pair(A,B) ) ).

fof(t7_wellord2,lemma,
    ! [A] :
      ( well_ordering(inclusion_relation(A))
     <= ordinal(A) ) ).

fof(dt_m1_subset_1,axiom,
    $true ).

fof(t1_zfmisc_1,lemma,
    singleton(empty_set) = powerset(empty_set) ).

fof(d1_mcart_1,axiom,
    ! [A] :
      ( ! [B] :
          ( pair_first(A) = B
        <=> ! [C,D] :
              ( B = C
             <= A = ordered_pair(C,D) ) )
     <= ? [B,C] : ordered_pair(B,C) = A ) ).

fof(fc3_funct_1,axiom,
    ! [A] :
      ( ( relation(relation_inverse(A))
        & function(relation_inverse(A)) )
     <= ( relation(A)
        & function(A)
        & one_to_one(A) ) ) ).

fof(s1_tarski__e6_21__wellord2__1,axiom,
    ! [A,B,C] :
      ( ( ! [D,E,F] :
            ( E = F
           <= ( E = D
              & F = D
              & ? [I,J] :
                  ( in(ordered_pair(apply(C,I),apply(C,J)),B)
                  & F = ordered_pair(I,J) )
              & ? [G,H] :
                  ( E = ordered_pair(G,H)
                  & in(ordered_pair(apply(C,G),apply(C,H)),B) ) ) )
       => ? [D] :
          ! [E] :
            ( in(E,D)
          <=> ? [F] :
                ( in(F,cartesian_product2(A,A))
                & ? [K,L] :
                    ( in(ordered_pair(apply(C,K),apply(C,L)),B)
                    & ordered_pair(K,L) = E )
                & F = E ) ) )
     <= ( relation(B)
        & relation(C)
        & function(C) ) ) ).

fof(t8_zfmisc_1,lemma,
    ! [A,B,C] :
      ( A = B
     <= unordered_pair(B,C) = singleton(A) ) ).

fof(t60_xboole_1,lemma,
    ! [A,B] :
      ~ ( subset(A,B)
        & proper_subset(B,A) ) ).

fof(l29_wellord1,lemma,
    ! [A,B] :
      ( subset(relation_dom(relation_rng_restriction(A,B)),relation_dom(B))
     <= relation(B) ) ).

fof(rc2_xboole_0,axiom,
    ? [A] : ~ empty(A) ).

fof(rc2_relat_1,axiom,
    ? [A] :
      ( relation(A)
      & ~ empty(A) ) ).

fof(t1_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,C)
     <= ( subset(A,B)
        & subset(B,C) ) ) ).

fof(fc1_relat_1,axiom,
    ! [A,B] :
      ( relation(set_intersection2(A,B))
     <= ( relation(B)
        & relation(A) ) ) ).

fof(d8_funct_1,axiom,
    ! [A] :
      ( ( function(A)
        & relation(A) )
     => ( ! [B,C] :
            ( ( apply(A,C) = apply(A,B)
              & in(C,relation_dom(A))
              & in(B,relation_dom(A)) )
           => C = B )
      <=> one_to_one(A) ) ) ).

fof(t8_boole,axiom,
    ! [A,B] :
      ~ ( A != B
        & empty(B)
        & empty(A) ) ).

fof(t30_relat_1,lemma,
    ! [A,B,C] :
      ( ( ( in(A,relation_field(C))
          & in(B,relation_field(C)) )
       <= in(ordered_pair(A,B),C) )
     <= relation(C) ) ).

fof(d6_wellord1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] : set_intersection2(A,cartesian_product2(B,B)) = relation_restriction(A,B) ) ).

fof(cc2_funct_1,axiom,
    ! [A] :
      ( ( relation(A)
        & function(A)
        & one_to_one(A) )
     <= ( relation(A)
        & empty(A)
        & function(A) ) ) ).

fof(d4_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( ! [C] :
              ( in(C,B)
            <=> ? [D] : in(ordered_pair(C,D),A) )
        <=> relation_dom(A) = B )
     <= relation(A) ) ).

fof(t56_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ( ! [B,C] : ~ in(ordered_pair(B,C),A)
       => empty_set = A ) ) ).

fof(reflexivity_r2_wellord2,axiom,
    ! [A,B] : equipotent(A,A) ).

fof(t74_relat_1,lemma,
    ! [A,B,C,D] :
      ( ( ( in(A,C)
          & in(ordered_pair(A,B),D) )
      <=> in(ordered_pair(A,B),relation_composition(identity_relation(C),D)) )
     <= relation(D) ) ).

fof(cc1_ordinal1,axiom,
    ! [A] :
      ( ordinal(A)
     => ( epsilon_transitive(A)
        & epsilon_connected(A) ) ) ).

fof(t44_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => subset(relation_dom(relation_composition(A,B)),relation_dom(A)) )
     <= relation(A) ) ).

fof(involutiveness_k3_subset_1,axiom,
    ! [A,B] :
      ( element(B,powerset(A))
     => subset_complement(A,subset_complement(A,B)) = B ) ).

fof(dt_k3_relat_1,axiom,
    $true ).

fof(l50_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,union(B))
     <= in(A,B) ) ).

fof(cc2_ordinal1,axiom,
    ! [A] :
      ( ( epsilon_transitive(A)
        & epsilon_connected(A) )
     => ordinal(A) ) ).

fof(idempotence_k2_xboole_0,axiom,
    ! [A,B] : A = set_union2(A,A) ).

fof(d5_wellord1,axiom,
    ! [A] :
      ( ! [B] :
          ( well_orders(A,B)
        <=> ( is_reflexive_in(A,B)
            & is_well_founded_in(A,B)
            & is_connected_in(A,B)
            & is_antisymmetric_in(A,B)
            & is_transitive_in(A,B) ) )
     <= relation(A) ) ).

fof(redefinition_k6_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => meet_of_subsets(A,B) = set_meet(B) ) ).

fof(t46_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ( subset(relation_rng(A),relation_dom(B))
           => relation_dom(relation_composition(A,B)) = relation_dom(A) ) )
     <= relation(A) ) ).

fof(t147_funct_1,lemma,
    ! [A,B] :
      ( ( function(B)
        & relation(B) )
     => ( A = relation_image(B,relation_inverse_image(B,A))
       <= subset(A,relation_rng(B)) ) ) ).

fof(s1_tarski__e16_22__wellord2__2,axiom,
    ! [A,B] :
      ( ? [C] :
        ! [D] :
          ( in(D,C)
        <=> ? [E] :
              ( ? [J,K] :
                  ( K = singleton(J)
                  & in(J,A)
                  & D = ordered_pair(J,K) )
              & E = D
              & in(E,cartesian_product2(A,B)) ) )
     <= ! [C,D,E] :
          ( D = E
         <= ( ? [H,I] :
                ( ordered_pair(H,I) = E
                & in(H,A)
                & singleton(H) = I )
            & E = C
            & ? [F,G] :
                ( D = ordered_pair(F,G)
                & in(F,A)
                & singleton(F) = G )
            & D = C ) ) ) ).

fof(d1_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( C = A
        <=> in(C,B) )
    <=> B = singleton(A) ) ).

fof(t140_relat_1,lemma,
    ! [A,B,C] :
      ( relation(C)
     => relation_rng_restriction(A,relation_dom_restriction(C,B)) = relation_dom_restriction(relation_rng_restriction(A,C),B) ) ).

fof(existence_m1_relset_1,axiom,
    ! [A,B] :
    ? [C] : relation_of2(C,A,B) ).

fof(commutativity_k2_tarski,axiom,
    ! [A,B] : unordered_pair(B,A) = unordered_pair(A,B) ).

fof(t40_xboole_1,lemma,
    ! [A,B] : set_difference(set_union2(A,B),B) = set_difference(A,B) ).

fof(d10_xboole_0,axiom,
    ! [A,B] :
      ( B = A
    <=> ( subset(A,B)
        & subset(B,A) ) ) ).

fof(t33_ordinal1,lemma,
    ! [A] :
      ( ordinal(A)
     => ! [B] :
          ( ( ordinal_subset(succ(A),B)
          <=> in(A,B) )
         <= ordinal(B) ) ) ).

fof(rc3_relat_1,axiom,
    ? [A] :
      ( relation(A)
      & relation_empty_yielding(A) ) ).

fof(t55_funct_1,lemma,
    ! [A] :
      ( ( relation(A)
        & function(A) )
     => ( one_to_one(A)
       => ( relation_dom(A) = relation_rng(function_inverse(A))
          & relation_dom(function_inverse(A)) = relation_rng(A) ) ) ) ).

fof(d2_ordinal1,axiom,
    ! [A] :
      ( epsilon_transitive(A)
    <=> ! [B] :
          ( in(B,A)
         => subset(B,A) ) ) ).

fof(l3_zfmisc_1,lemma,
    ! [A,B,C] :
      ( subset(A,B)
     => ( subset(A,set_difference(B,singleton(C)))
        | in(C,A) ) ) ).

fof(t3_xboole_1,lemma,
    ! [A] :
      ( subset(A,empty_set)
     => empty_set = A ) ).

fof(dt_k1_zfmisc_1,axiom,
    $true ).

fof(t83_xboole_1,lemma,
    ! [A,B] :
      ( set_difference(A,B) = A
    <=> disjoint(A,B) ) ).

fof(d4_funct_1,axiom,
    ! [A] :
      ( ! [B,C] :
          ( ( ~ in(B,relation_dom(A))
           => ( C = empty_set
            <=> C = apply(A,B) ) )
          & ( in(B,relation_dom(A))
           => ( in(ordered_pair(B,C),A)
            <=> apply(A,B) = C ) ) )
     <= ( relation(A)
        & function(A) ) ) ).

fof(d12_relat_2,axiom,
    ! [A] :
      ( relation(A)
     => ( is_antisymmetric_in(A,relation_field(A))
      <=> antisymmetric(A) ) ) ).

fof(fc1_subset_1,axiom,
    ! [A] : ~ empty(powerset(A)) ).

fof(dt_k2_relat_1,axiom,
    $true ).

fof(t145_relat_1,lemma,
    ! [A,B] :
      ( relation_image(B,set_intersection2(relation_dom(B),A)) = relation_image(B,A)
     <= relation(B) ) ).

fof(t143_relat_1,lemma,
    ! [A,B,C] :
      ( ( ? [D] :
            ( in(D,relation_dom(C))
            & in(D,B)
            & in(ordered_pair(D,A),C) )
      <=> in(A,relation_image(C,B)) )
     <= relation(C) ) ).

fof(t19_wellord1,lemma,
    ! [A,B,C] :
      ( ( ( in(A,B)
          & in(A,relation_field(C)) )
       <= in(A,relation_field(relation_restriction(C,B))) )
     <= relation(C) ) ).

fof(d8_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => ! [C] :
          ( element(C,powerset(powerset(A)))
         => ( ! [D] :
                ( ( in(subset_complement(A,D),B)
                <=> in(D,C) )
               <= element(D,powerset(A)) )
          <=> complements_of_subsets(A,B) = C ) ) ) ).

fof(rc2_subset_1,axiom,
    ! [A] :
    ? [B] :
      ( empty(B)
      & element(B,powerset(A)) ) ).

fof(s1_tarski__e16_22__wellord2__1,axiom,
    ! [A] :
      ( ! [B,C,D] :
          ( ( in(B,A)
            & D = singleton(B)
            & singleton(B) = C
            & in(B,A) )
         => D = C )
     => ? [B] :
        ! [C] :
          ( in(C,B)
        <=> ? [D] :
              ( C = singleton(D)
              & in(D,A)
              & in(D,A) ) ) ) ).

fof(t62_funct_1,lemma,
    ! [A] :
      ( ( function(A)
        & relation(A) )
     => ( one_to_one(A)
       => one_to_one(function_inverse(A)) ) ) ).

fof(d14_relat_2,axiom,
    ! [A] :
      ( ( connected(A)
      <=> is_connected_in(A,relation_field(A)) )
     <= relation(A) ) ).

fof(dt_k5_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => element(union_of_subsets(A,B),powerset(A)) ) ).

fof(fc6_relat_1,axiom,
    ! [A] :
      ( ( ~ empty(A)
        & relation(A) )
     => ~ empty(relation_rng(A)) ) ).

fof(cc1_relset_1,axiom,
    ! [A,B,C] :
      ( relation(C)
     <= element(C,powerset(cartesian_product2(A,B))) ) ).

fof(d4_subset_1,axiom,
    ! [A] : A = cast_to_subset(A) ).

fof(dt_k2_xboole_0,axiom,
    $true ).

fof(t2_xboole_1,lemma,
    ! [A] : subset(empty_set,A) ).

fof(s1_xboole_0__e6_21__wellord2__1,lemma,
    ! [A,B,C] :
      ( ( relation(B)
        & relation(C)
        & function(C) )
     => ? [D] :
        ! [E] :
          ( in(E,D)
        <=> ( in(E,cartesian_product2(A,A))
            & ? [F,G] :
                ( in(ordered_pair(apply(C,F),apply(C,G)),B)
                & E = ordered_pair(F,G) ) ) ) ) ).

fof(t2_tarski,axiom,
    ! [A,B] :
      ( B = A
     <= ! [C] :
          ( in(C,A)
        <=> in(C,B) ) ) ).

fof(t23_wellord1,lemma,
    ! [A,B] :
      ( ( connected(B)
       => connected(relation_restriction(B,A)) )
     <= relation(B) ) ).

fof(d1_setfam_1,axiom,
    ! [A,B] :
      ( ( ( ! [C] :
              ( in(C,B)
            <=> ! [D] :
                  ( in(D,A)
                 => in(C,D) ) )
        <=> set_meet(A) = B )
       <= A != empty_set )
      & ( A = empty_set
       => ( empty_set = B
        <=> B = set_meet(A) ) ) ) ).

fof(d2_subset_1,axiom,
    ! [A,B] :
      ( ( empty(A)
       => ( element(B,A)
        <=> empty(B) ) )
      & ( ( in(B,A)
        <=> element(B,A) )
       <= ~ empty(A) ) ) ).

fof(t24_ordinal1,lemma,
    ! [A] :
      ( ordinal(A)
     => ! [B] :
          ( ordinal(B)
         => ~ ( ~ in(B,A)
              & B != A
              & ~ in(A,B) ) ) ) ).

fof(d4_ordinal1,axiom,
    ! [A] :
      ( ordinal(A)
    <=> ( epsilon_connected(A)
        & epsilon_transitive(A) ) ) ).

fof(symmetry_r2_wellord2,axiom,
    ! [A,B] :
      ( equipotent(A,B)
     => equipotent(B,A) ) ).

fof(rc1_ordinal1,axiom,
    ? [A] :
      ( epsilon_transitive(A)
      & ordinal(A)
      & epsilon_connected(A) ) ).

fof(t12_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
     => B = set_union2(A,B) ) ).

fof(cc1_relat_1,axiom,
    ! [A] :
      ( empty(A)
     => relation(A) ) ).

fof(t10_ordinal1,lemma,
    ! [A] : in(A,succ(A)) ).

fof(t72_funct_1,lemma,
    ! [A,B,C] :
      ( ( relation(C)
        & function(C) )
     => ( apply(relation_dom_restriction(C,A),B) = apply(C,B)
       <= in(B,A) ) ) ).

fof(fc5_relat_1,axiom,
    ! [A] :
      ( ~ empty(relation_dom(A))
     <= ( relation(A)
        & ~ empty(A) ) ) ).

fof(d7_xboole_0,axiom,
    ! [A,B] :
      ( empty_set = set_intersection2(A,B)
    <=> disjoint(A,B) ) ).

fof(t47_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ( subset(relation_dom(A),relation_rng(B))
           => relation_rng(A) = relation_rng(relation_composition(B,A)) ) )
     <= relation(A) ) ).

fof(t35_funct_1,lemma,
    ! [A,B] :
      ( apply(identity_relation(A),B) = B
     <= in(B,A) ) ).

fof(s1_xboole_0__e16_22__wellord2__1,lemma,
    ! [A,B] :
    ? [C] :
    ! [D] :
      ( ( in(D,cartesian_product2(A,B))
        & ? [E,F] :
            ( F = singleton(E)
            & in(E,A)
            & ordered_pair(E,F) = D ) )
    <=> in(D,C) ) ).

fof(dt_k2_zfmisc_1,axiom,
    $true ).

fof(t2_subset,axiom,
    ! [A,B] :
      ( element(A,B)
     => ( in(A,B)
        | empty(B) ) ) ).

fof(l23_zfmisc_1,lemma,
    ! [A,B] :
      ( in(A,B)
     => B = set_union2(singleton(A),B) ) ).

fof(t46_zfmisc_1,lemma,
    ! [A,B] :
      ( set_union2(singleton(A),B) = B
     <= in(A,B) ) ).

fof(t21_funct_1,lemma,
    ! [A,B] :
      ( ( function(B)
        & relation(B) )
     => ! [C] :
          ( ( relation(C)
            & function(C) )
         => ( ( in(A,relation_dom(C))
              & in(apply(C,A),relation_dom(B)) )
          <=> in(A,relation_dom(relation_composition(C,B))) ) ) ) ).

fof(t21_relat_1,lemma,
    ! [A] :
      ( subset(A,cartesian_product2(relation_dom(A),relation_rng(A)))
     <= relation(A) ) ).

fof(t90_relat_1,lemma,
    ! [A,B] :
      ( relation(B)
     => set_intersection2(relation_dom(B),A) = relation_dom(relation_dom_restriction(B,A)) ) ).

fof(t115_relat_1,lemma,
    ! [A,B,C] :
      ( ( in(A,relation_rng(relation_rng_restriction(B,C)))
      <=> ( in(A,B)
          & in(A,relation_rng(C)) ) )
     <= relation(C) ) ).

fof(d8_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ! [C] :
              ( relation(C)
             => ( ! [D,E] :
                    ( ? [F] :
                        ( in(ordered_pair(F,E),B)
                        & in(ordered_pair(D,F),A) )
                  <=> in(ordered_pair(D,E),C) )
              <=> relation_composition(A,B) = C ) ) )
     <= relation(A) ) ).

fof(t32_wellord1,lemma,
    ! [A,B] :
      ( relation(B)
     => ( well_ordering(B)
       => well_ordering(relation_restriction(B,A)) ) ) ).

fof(fc2_xboole_0,axiom,
    ! [A,B] :
      ( ~ empty(A)
     => ~ empty(set_union2(A,B)) ) ).

fof(t4_xboole_0,lemma,
    ! [A,B] :
      ( ~ ( ? [C] : in(C,set_intersection2(A,B))
          & disjoint(A,B) )
      & ~ ( ~ disjoint(A,B)
          & ! [C] : ~ in(C,set_intersection2(A,B)) ) ) ).

fof(d3_ordinal1,axiom,
    ! [A] :
      ( ! [B,C] :
          ~ ( in(B,A)
            & ~ in(B,C)
            & C != B
            & ~ in(C,B)
            & in(C,A) )
    <=> epsilon_connected(A) ) ).

fof(t9_zfmisc_1,lemma,
    ! [A,B,C] :
      ( B = C
     <= singleton(A) = unordered_pair(B,C) ) ).

fof(t8_wellord1,lemma,
    ! [A] :
      ( relation(A)
     => ( well_ordering(A)
      <=> well_orders(A,relation_field(A)) ) ) ).

fof(t2_wellord2,lemma,
    ! [A] : reflexive(inclusion_relation(A)) ).

fof(dt_k8_relat_1,axiom,
    ! [A,B] :
      ( relation(relation_rng_restriction(A,B))
     <= relation(B) ) ).

fof(dt_k4_tarski,axiom,
    $true ).

fof(t9_tarski,axiom,
    ! [A] :
    ? [B] :
      ( in(A,B)
      & ! [C,D] :
          ( ( in(C,B)
            & subset(D,C) )
         => in(D,B) )
      & ! [C] :
          ~ ( in(C,B)
            & ! [D] :
                ~ ( ! [E] :
                      ( in(E,D)
                     <= subset(E,C) )
                  & in(D,B) ) )
      & ! [C] :
          ~ ( subset(C,B)
            & ~ are_equipotent(C,B)
            & ~ in(C,B) ) ) ).

fof(t5_wellord1,lemma,
    ! [A] :
      ( relation(A)
     => ( well_founded_relation(A)
      <=> is_well_founded_in(A,relation_field(A)) ) ) ).

fof(fc4_subset_1,axiom,
    ! [A,B] :
      ( ~ empty(cartesian_product2(A,B))
     <= ( ~ empty(B)
        & ~ empty(A) ) ) ).

fof(dt_k1_xboole_0,axiom,
    $true ).

fof(t23_funct_1,lemma,
    ! [A,B] :
      ( ( relation(B)
        & function(B) )
     => ! [C] :
          ( ( apply(C,apply(B,A)) = apply(relation_composition(B,C),A)
           <= in(A,relation_dom(B)) )
         <= ( function(C)
            & relation(C) ) ) ) ).

fof(t7_boole,axiom,
    ! [A,B] :
      ~ ( empty(B)
        & in(A,B) ) ).

fof(dt_k1_enumset1,axiom,
    $true ).

fof(fc2_funct_1,axiom,
    ! [A] :
      ( function(identity_relation(A))
      & relation(identity_relation(A)) ) ).

fof(t54_funct_1,lemma,
    ! [A] :
      ( ( function(A)
        & relation(A) )
     => ( one_to_one(A)
       => ! [B] :
            ( ( relation(B)
              & function(B) )
           => ( ( relation_rng(A) = relation_dom(B)
                & ! [C,D] :
                    ( ( ( in(C,relation_rng(A))
                        & D = apply(B,C) )
                     => ( C = apply(A,D)
                        & in(D,relation_dom(A)) ) )
                    & ( ( apply(B,C) = D
                        & in(C,relation_rng(A)) )
                     <= ( C = apply(A,D)
                        & in(D,relation_dom(A)) ) ) ) )
            <=> function_inverse(A) = B ) ) ) ) ).

fof(s2_funct_1__e16_22__wellord2__1,lemma,
    ! [A] :
      ( ? [B] :
          ( relation(B)
          & function(B)
          & ! [C] :
              ( singleton(C) = apply(B,C)
             <= in(C,A) )
          & A = relation_dom(B) )
     <= ( ! [B,C,D] :
            ( ( in(B,A)
              & singleton(B) = D
              & C = singleton(B) )
           => C = D )
        & ! [B] :
            ~ ( ! [C] : singleton(B) != C
              & in(B,A) ) ) ) ).

fof(redefinition_k6_subset_1,axiom,
    ! [A,B,C] :
      ( ( element(B,powerset(A))
        & element(C,powerset(A)) )
     => subset_difference(A,B,C) = set_difference(B,C) ) ).

fof(t5_wellord2,lemma,
    ! [A] : antisymmetric(inclusion_relation(A)) ).

fof(d4_xboole_0,axiom,
    ! [A,B,C] :
      ( C = set_difference(A,B)
    <=> ! [D] :
          ( ( in(D,A)
            & ~ in(D,B) )
        <=> in(D,C) ) ) ).

fof(d8_xboole_0,axiom,
    ! [A,B] :
      ( proper_subset(A,B)
    <=> ( A != B
        & subset(A,B) ) ) ).

fof(t20_wellord1,lemma,
    ! [A,B] :
      ( relation(B)
     => ( subset(relation_field(relation_restriction(B,A)),relation_field(B))
        & subset(relation_field(relation_restriction(B,A)),A) ) ) ).

fof(dt_k2_wellord1,axiom,
    ! [A,B] :
      ( relation(A)
     => relation(relation_restriction(A,B)) ) ).

fof(l1_wellord1,lemma,
    ! [A] :
      ( relation(A)
     => ( reflexive(A)
      <=> ! [B] :
            ( in(B,relation_field(A))
           => in(ordered_pair(B,B),A) ) ) ) ).

fof(s1_ordinal1__e8_6__wellord2,lemma,
    ! [A] :
      ( ? [B] :
          ( in(B,A)
          & ordinal(B) )
     => ? [B] :
          ( ! [C] :
              ( ordinal(C)
             => ( ordinal_subset(B,C)
               <= in(C,A) ) )
          & in(B,A)
          & ordinal(B) ) ) ).

fof(d1_relat_2,axiom,
    ! [A] :
      ( ! [B] :
          ( ! [C] :
              ( in(ordered_pair(C,C),A)
             <= in(C,B) )
        <=> is_reflexive_in(A,B) )
     <= relation(A) ) ).

fof(t7_mcart_1,lemma,
    ! [A,B] :
      ( pair_first(ordered_pair(A,B)) = A
      & pair_second(ordered_pair(A,B)) = B ) ).

fof(rc2_funct_1,axiom,
    ? [A] :
      ( relation(A)
      & empty(A)
      & function(A) ) ).

fof(d1_zfmisc_1,axiom,
    ! [A,B] :
      ( powerset(A) = B
    <=> ! [C] :
          ( in(C,B)
        <=> subset(C,A) ) ) ).

fof(t71_relat_1,lemma,
    ! [A] :
      ( A = relation_rng(identity_relation(A))
      & relation_dom(identity_relation(A)) = A ) ).

fof(d4_tarski,axiom,
    ! [A,B] :
      ( union(A) = B
    <=> ! [C] :
          ( ? [D] :
              ( in(D,A)
              & in(C,D) )
        <=> in(C,B) ) ) ).

fof(t25_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( ( ( subset(relation_rng(A),relation_rng(B))
              & subset(relation_dom(A),relation_dom(B)) )
           <= subset(A,B) )
         <= relation(B) )
     <= relation(A) ) ).

fof(s1_xboole_0__e8_6__wellord2__1,lemma,
    ! [A,B] :
      ( ? [C] :
        ! [D] :
          ( ( in(D,succ(B))
            & ? [E] :
                ( in(E,A)
                & E = D
                & ordinal(E) ) )
        <=> in(D,C) )
     <= ordinal(B) ) ).

fof(fc1_funct_1,axiom,
    ! [A,B] :
      ( ( function(A)
        & function(B)
        & relation(B)
        & relation(A) )
     => ( relation(relation_composition(A,B))
        & function(relation_composition(A,B)) ) ) ).

fof(fc2_subset_1,axiom,
    ! [A] : ~ empty(singleton(A)) ).

fof(d4_wellord1,axiom,
    ! [A] :
      ( ( well_ordering(A)
      <=> ( reflexive(A)
          & transitive(A)
          & antisymmetric(A)
          & connected(A)
          & well_founded_relation(A) ) )
     <= relation(A) ) ).

fof(t34_funct_1,lemma,
    ! [A,B] :
      ( ( ( A = relation_dom(B)
          & ! [C] :
              ( in(C,A)
             => apply(B,C) = C ) )
      <=> identity_relation(A) = B )
     <= ( relation(B)
        & function(B) ) ) ).

fof(t136_zfmisc_1,lemma,
    ! [A] :
    ? [B] :
      ( in(A,B)
      & ! [C] :
          ~ ( ~ are_equipotent(C,B)
            & ~ in(C,B)
            & subset(C,B) )
      & ! [C] :
          ( in(C,B)
         => in(powerset(C),B) )
      & ! [C,D] :
          ( ( subset(D,C)
            & in(C,B) )
         => in(D,B) ) ) ).

fof(t3_xboole_0,lemma,
    ! [A,B] :
      ( ~ ( disjoint(A,B)
          & ? [C] :
              ( in(C,B)
              & in(C,A) ) )
      & ~ ( ! [C] :
              ~ ( in(C,A)
                & in(C,B) )
          & ~ disjoint(A,B) ) ) ).

fof(t106_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( in(A,C)
        & in(B,D) )
    <=> in(ordered_pair(A,B),cartesian_product2(C,D)) ) ).

fof(d5_tarski,axiom,
    ! [A,B] : unordered_pair(unordered_pair(A,B),singleton(A)) = ordered_pair(A,B) ).

fof(d4_wellord2,axiom,
    ! [A,B] :
      ( ? [C] :
          ( relation(C)
          & function(C)
          & one_to_one(C)
          & relation_dom(C) = A
          & B = relation_rng(C) )
    <=> equipotent(A,B) ) ).

fof(d14_relat_1,axiom,
    ! [A] :
      ( ! [B,C] :
          ( C = relation_inverse_image(A,B)
        <=> ! [D] :
              ( ? [E] :
                  ( in(E,B)
                  & in(ordered_pair(D,E),A) )
            <=> in(D,C) ) )
     <= relation(A) ) ).

fof(d2_tarski,axiom,
    ! [A,B,C] :
      ( unordered_pair(A,B) = C
    <=> ! [D] :
          ( ( D = B
            | A = D )
        <=> in(D,C) ) ) ).

fof(t1_subset,axiom,
    ! [A,B] :
      ( element(A,B)
     <= in(A,B) ) ).

fof(t45_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => subset(relation_rng(relation_composition(A,B)),relation_rng(B)) )
     <= relation(A) ) ).

fof(rc1_relat_1,axiom,
    ? [A] :
      ( relation(A)
      & empty(A) ) ).

fof(rc2_ordinal1,axiom,
    ? [A] :
      ( one_to_one(A)
      & empty(A)
      & ordinal(A)
      & epsilon_connected(A)
      & epsilon_transitive(A)
      & function(A)
      & relation(A) ) ).

fof(t16_relset_1,lemma,
    ! [A,B,C,D] :
      ( relation_of2_as_subset(D,C,A)
     => ( subset(A,B)
       => relation_of2_as_subset(D,C,B) ) ) ).

fof(l71_subset_1,lemma,
    ! [A,B] :
      ( ! [C] :
          ( in(C,B)
         <= in(C,A) )
     => element(A,powerset(B)) ) ).

fof(t22_wellord1,lemma,
    ! [A,B] :
      ( ( reflexive(relation_restriction(B,A))
       <= reflexive(B) )
     <= relation(B) ) ).

fof(t46_setfam_1,lemma,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => ~ ( empty_set = complements_of_subsets(A,B)
          & empty_set != B ) ) ).

fof(dt_k6_relat_1,axiom,
    ! [A] : relation(identity_relation(A)) ).

fof(t116_relat_1,lemma,
    ! [A,B] :
      ( subset(relation_rng(relation_rng_restriction(A,B)),A)
     <= relation(B) ) ).

fof(t39_wellord1,lemma,
    ! [A,B] :
      ( relation(B)
     => ( A = relation_field(relation_restriction(B,A))
       <= ( subset(A,relation_field(B))
          & well_ordering(B) ) ) ) ).

fof(l4_wellord1,lemma,
    ! [A] :
      ( ( ! [B,C] :
            ~ ( in(B,relation_field(A))
              & in(C,relation_field(A))
              & ~ in(ordered_pair(C,B),A)
              & ~ in(ordered_pair(B,C),A)
              & C != B )
      <=> connected(A) )
     <= relation(A) ) ).

fof(l25_zfmisc_1,lemma,
    ! [A,B] :
      ~ ( in(A,B)
        & disjoint(singleton(A),B) ) ).

fof(dt_k2_mcart_1,axiom,
    $true ).

fof(d7_relat_1,axiom,
    ! [A] :
      ( ! [B] :
          ( relation(B)
         => ( relation_inverse(A) = B
          <=> ! [C,D] :
                ( in(ordered_pair(C,D),B)
              <=> in(ordered_pair(D,C),A) ) ) )
     <= relation(A) ) ).

fof(redefinition_r1_ordinal1,axiom,
    ! [A,B] :
      ( ( ordinal(A)
        & ordinal(B) )
     => ( subset(A,B)
      <=> ordinal_subset(A,B) ) ) ).

fof(fc10_relat_1,axiom,
    ! [A,B] :
      ( ( relation(relation_composition(B,A))
        & empty(relation_composition(B,A)) )
     <= ( relation(B)
        & empty(A) ) ) ).

fof(fc4_ordinal1,axiom,
    ! [A] :
      ( ordinal(A)
     => ( ordinal(union(A))
        & epsilon_connected(union(A))
        & epsilon_transitive(union(A)) ) ) ).

fof(d4_relat_2,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( ! [C,D] :
              ( ( in(C,B)
                & in(D,B)
                & in(ordered_pair(C,D),A)
                & in(ordered_pair(D,C),A) )
             => D = C )
        <=> is_antisymmetric_in(A,B) ) ) ).

fof(fc7_relat_1,axiom,
    ! [A] :
      ( ( relation(relation_dom(A))
        & empty(relation_dom(A)) )
     <= empty(A) ) ).

fof(rc1_subset_1,axiom,
    ! [A] :
      ( ~ empty(A)
     => ? [B] :
          ( ~ empty(B)
          & element(B,powerset(A)) ) ) ).

fof(dt_k3_tarski,axiom,
    $true ).

fof(fc8_relat_1,axiom,
    ! [A] :
      ( ( empty(relation_rng(A))
        & relation(relation_rng(A)) )
     <= empty(A) ) ).

fof(dt_m2_relset_1,axiom,
    ! [A,B,C] :
      ( element(C,powerset(cartesian_product2(A,B)))
     <= relation_of2_as_subset(C,A,B) ) ).

fof(l2_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),B)
    <=> in(A,B) ) ).

fof(t48_setfam_1,lemma,
    ! [A,B] :
      ( ( union_of_subsets(A,complements_of_subsets(A,B)) = subset_difference(A,cast_to_subset(A),meet_of_subsets(A,B))
       <= empty_set != B )
     <= element(B,powerset(powerset(A))) ) ).

