include('Axioms/SWV003+0.ax').
fof(gt_5_tptp_minus_1,axiom,
    gt(n5,tptp_minus_1) ).

fof(gt_2_0,axiom,
    gt(n2,n0) ).

fof(gt_1_tptp_minus_1,axiom,
    gt(n1,tptp_minus_1) ).

fof(gt_3_tptp_minus_1,axiom,
    gt(n3,tptp_minus_1) ).

fof(gt_4_1,axiom,
    gt(n4,n1) ).

fof(gt_330_5,axiom,
    gt(n330,n5) ).

fof(gt_3_2,axiom,
    gt(n3,n2) ).

fof(finite_domain_5,axiom,
    ! [X] :
      ( ( n1 = X
        | n3 = X
        | n4 = X
        | n5 = X
        | n2 = X
        | X = n0 )
     <= ( leq(n0,X)
        & leq(X,n5) ) ) ).

fof(gt_330_tptp_minus_1,axiom,
    gt(n330,tptp_minus_1) ).

fof(successor_1,axiom,
    n1 = succ(n0) ).

fof(gt_410_330,axiom,
    gt(n410,n330) ).

fof(successor_5,axiom,
    n5 = succ(succ(succ(succ(succ(n0))))) ).

fof(gt_3_0,axiom,
    gt(n3,n0) ).

fof(successor_4,axiom,
    succ(succ(succ(succ(n0)))) = n4 ).

fof(gt_5_1,axiom,
    gt(n5,n1) ).

fof(successor_3,axiom,
    n3 = succ(succ(succ(n0))) ).

fof(successor_2,axiom,
    succ(succ(n0)) = n2 ).

fof(finite_domain_1,axiom,
    ! [X] :
      ( ( leq(X,n1)
        & leq(n0,X) )
     => ( n0 = X
        | X = n1 ) ) ).

fof(gt_330_3,axiom,
    gt(n330,n3) ).

fof(gt_410_tptp_minus_1,axiom,
    gt(n410,tptp_minus_1) ).

fof(gt_4_tptp_minus_1,axiom,
    gt(n4,tptp_minus_1) ).

fof(gt_4_3,axiom,
    gt(n4,n3) ).

fof(gt_410_1,axiom,
    gt(n410,n1) ).

fof(gt_5_0,axiom,
    gt(n5,n0) ).

fof(gt_5_2,axiom,
    gt(n5,n2) ).

fof(finite_domain_4,axiom,
    ! [X] :
      ( ( n1 = X
        | X = n3
        | X = n4
        | n2 = X
        | X = n0 )
     <= ( leq(n0,X)
        & leq(X,n4) ) ) ).

fof(gt_4_2,axiom,
    gt(n4,n2) ).

fof(gt_5_3,axiom,
    gt(n5,n3) ).

fof(gt_410_3,axiom,
    gt(n410,n3) ).

fof(gt_330_0,axiom,
    gt(n330,n0) ).

fof(gt_410_4,axiom,
    gt(n410,n4) ).

fof(gt_5_4,axiom,
    gt(n5,n4) ).

fof(gt_410_2,axiom,
    gt(n410,n2) ).

fof(gt_2_1,axiom,
    gt(n2,n1) ).

fof(gt_2_tptp_minus_1,axiom,
    gt(n2,tptp_minus_1) ).

fof(finite_domain_3,axiom,
    ! [X] :
      ( ( X = n0
        | X = n1
        | X = n2
        | X = n3 )
     <= ( leq(X,n3)
        & leq(n0,X) ) ) ).

fof(finite_domain_2,axiom,
    ! [X] :
      ( ( n0 = X
        | X = n1
        | n2 = X )
     <= ( leq(X,n2)
        & leq(n0,X) ) ) ).

fof(gt_330_2,axiom,
    gt(n330,n2) ).

fof(finite_domain_0,axiom,
    ! [X] :
      ( X = n0
     <= ( leq(X,n0)
        & leq(n0,X) ) ) ).

fof(gt_410_5,axiom,
    gt(n410,n5) ).

fof(gt_330_1,axiom,
    gt(n330,n1) ).

fof(gt_0_tptp_minus_1,axiom,
    gt(n0,tptp_minus_1) ).

fof(gt_1_0,axiom,
    gt(n1,n0) ).

fof(gauss_init_0061,conjecture,
    ( ( s_best7_init = init
      & leq(n0,s_sworst7)
      & leq(n0,s_worst7)
      & leq(s_best7,n3)
      & leq(s_sworst7,n3)
      & ! [A] :
          ( ! [B] :
              ( init = a_select3(simplex7_init,B,A)
             <= ( leq(n0,B)
                & leq(B,n3) ) )
         <= ( leq(A,n2)
            & leq(n0,A) ) )
      & ! [C] :
          ( ( leq(C,n3)
            & leq(n0,C) )
         => init = a_select2(s_values7_init,C) )
      & ! [D] :
          ( ( leq(n0,D)
            & leq(D,n2) )
         => a_select2(s_center7_init,D) = init )
      & ( gt(loopcounter,n1)
       => ( pvar1400_init = init
          & pvar1402_init = init
          & init = pvar1401_init ) )
      & ! [E] :
          ( ( leq(n0,E)
            & leq(E,minus(n3,n1)) )
         => init = a_select2(s_try7_init,E) )
      & leq(s_worst7,n3)
      & leq(n0,s_best7)
      & init = s_worst7_init
      & init = s_sworst7_init )
   => ( init = init
      & init = s_worst7_init
      & init = a_select2(s_values7_init,s_worst7)
      & ( ( s_best7_init = init
          & init = a_select2(s_values7_init,s_best7)
          & ( ( s_best7_init = init
              & s_sworst7_init = init
              & ! [S] :
                  ( ( leq(S,n3)
                    & leq(n0,S) )
                 => a_select2(s_values7_init,S) = init )
              & ! [T] :
                  ( init = a_select2(s_center7_init,T)
                 <= ( leq(T,n2)
                    & leq(n0,T) ) )
              & ! [U] :
                  ( ( leq(U,minus(n3,n1))
                    & leq(n0,U) )
                 => init = a_select2(s_try7_init,U) )
              & ( ( pvar1400_init = init
                  & pvar1402_init = init
                  & pvar1401_init = init )
               <= gt(loopcounter,n1) )
              & ! [Q] :
                  ( ( leq(Q,n2)
                    & leq(n0,Q) )
                 => ! [R] :
                      ( ( leq(R,n3)
                        & leq(n0,R) )
                     => a_select3(simplex7_init,R,Q) = init ) )
              & leq(s_worst7,n3)
              & leq(s_sworst7,n3)
              & leq(s_best7,n3)
              & leq(n0,s_worst7)
              & leq(n0,s_sworst7)
              & leq(n0,s_best7)
              & s_worst7_init = init )
           <= geq(plus(log(n2),divide(minus(minus(minus(plus(log(n330),log(n410)),log(pv1410)),n1),log(n4)),n2)),a_select2(s_values7,s_best7)) )
          & ( ~ geq(plus(log(n2),divide(minus(minus(minus(plus(log(n330),log(n410)),log(pv1410)),n1),log(n4)),n2)),a_select2(s_values7,s_best7))
           => ( init = init
              & ( ( ( ( ! [H] :
                          ( init = a_select2(s_values7_init,H)
                         <= ( leq(H,n3)
                            & leq(n0,H) ) )
                      & ( ( s_best7_init = init
                          & init = s_sworst7_init
                          & s_worst7_init = init
                          & leq(n0,s_best7)
                          & leq(n0,s_worst7)
                          & leq(s_best7,n3)
                          & leq(s_sworst7,n3)
                          & leq(s_worst7,n3)
                          & leq(n0,s_sworst7) )
                       <= ~ geq(pv1403,tptp_float_0_001) )
                      & ( gt(loopcounter,n0)
                       => ( a_select2(s_values7_init,s_best7) = init
                          & init = a_select2(s_values7_init,s_sworst7)
                          & init = a_select2(s_values7_init,s_worst7) ) )
                      & ( gt(loopcounter,n0)
                       => ( s_worst7_init = init
                          & leq(n0,s_sworst7)
                          & leq(s_worst7,n3)
                          & leq(s_sworst7,n3)
                          & leq(s_best7,n3)
                          & leq(n0,s_worst7)
                          & leq(n0,s_best7)
                          & init = s_sworst7_init
                          & s_best7_init = init ) )
                      & ! [F] :
                          ( ! [G] :
                              ( a_select3(simplex7_init,G,F) = init
                             <= ( leq(G,n3)
                                & leq(n0,G) ) )
                         <= ( leq(n0,F)
                            & leq(F,n2) ) ) )
                   <= ~ gt(loopcounter,n1) )
                  & ( ( pvar1400_init = init
                      & init = s_best7_init
                      & init = s_sworst7_init
                      & init = a_select2(s_values7_init,s_best7)
                      & init = a_select2(s_values7_init,s_sworst7)
                      & init = a_select2(s_values7_init,s_worst7)
                      & ! [K] :
                          ( ( leq(K,n3)
                            & leq(n0,K) )
                         => a_select2(s_values7_init,K) = init )
                      & ( gt(loopcounter,n0)
                       => ( init = s_sworst7_init
                          & s_worst7_init = init
                          & leq(n0,s_best7)
                          & leq(s_worst7,n3)
                          & leq(s_sworst7,n3)
                          & leq(s_best7,n3)
                          & leq(n0,s_worst7)
                          & leq(n0,s_sworst7)
                          & s_best7_init = init ) )
                      & ( ( init = a_select2(s_values7_init,s_best7)
                          & init = a_select2(s_values7_init,s_sworst7)
                          & init = a_select2(s_values7_init,s_worst7) )
                       <= gt(loopcounter,n0) )
                      & ( ~ geq(plus(abs(minus(a_select2(s_values7,s_best7),pv1400)),plus(abs(minus(a_select2(s_values7,s_sworst7),pv1401)),abs(minus(a_select2(s_values7,s_worst7),pv1402)))),tptp_float_0_001)
                       => ( s_best7_init = init
                          & init = s_sworst7_init
                          & s_worst7_init = init
                          & leq(n0,s_best7)
                          & leq(s_best7,n3)
                          & leq(s_worst7,n3)
                          & leq(s_sworst7,n3)
                          & leq(n0,s_worst7)
                          & leq(n0,s_sworst7) ) )
                      & ! [I] :
                          ( ( leq(n0,I)
                            & leq(I,n2) )
                         => ! [J] :
                              ( a_select3(simplex7_init,J,I) = init
                             <= ( leq(J,n3)
                                & leq(n0,J) ) ) )
                      & s_worst7_init = init
                      & pvar1402_init = init
                      & init = pvar1401_init )
                   <= gt(loopcounter,n1) )
                  & init = init )
               <= ~ leq(plus(log(n2),divide(minus(minus(minus(plus(log(n330),log(n410)),log(pv1410)),n1),log(n4)),n2)),a_select2(s_values7,s_sworst7)) )
              & ( leq(plus(log(n2),divide(minus(minus(minus(plus(log(n330),log(n410)),log(pv1410)),n1),log(n4)),n2)),a_select2(s_values7,s_sworst7))
               => ( s_best7_init = init
                  & leq(n0,s_sworst7)
                  & ! [L] :
                      ( ! [M] :
                          ( init = a_select3(simplex7_init,M,L)
                         <= ( leq(n0,M)
                            & leq(M,n3) ) )
                     <= ( leq(L,n2)
                        & leq(n0,L) ) )
                  & ! [N] :
                      ( init = a_select2(s_values7_init,N)
                     <= ( leq(n0,N)
                        & leq(N,n3) ) )
                  & ! [P] :
                      ( init = a_select2(s_try7_init,P)
                     <= ( leq(n0,P)
                        & leq(P,minus(n3,n1)) ) )
                  & ( gt(loopcounter,n1)
                   => ( pvar1400_init = init
                      & init = pvar1402_init
                      & init = pvar1401_init ) )
                  & ! [O] :
                      ( ( leq(O,n2)
                        & leq(n0,O) )
                     => a_select2(s_center7_init,O) = init )
                  & leq(s_worst7,n3)
                  & leq(s_sworst7,n3)
                  & leq(s_best7,n3)
                  & leq(n0,s_worst7)
                  & leq(n0,s_best7)
                  & a_select2(s_values7_init,s_worst7) = init
                  & s_worst7_init = init
                  & s_sworst7_init = init ) )
              & init = a_select2(s_values7_init,s_sworst7)
              & init = s_sworst7_init ) )
          & init = init )
       <= ~ gt(plus(log(n2),divide(minus(minus(minus(plus(log(n330),log(n410)),log(pv1410)),n1),log(n4)),n2)),a_select2(s_values7,s_worst7)) )
      & ( gt(plus(log(n2),divide(minus(minus(minus(plus(log(n330),log(n410)),log(pv1410)),n1),log(n4)),n2)),a_select2(s_values7,s_worst7))
       => ( leq(n0,s_best7)
          & leq(s_best7,n3)
          & leq(s_sworst7,n3)
          & ( gt(loopcounter,n1)
           => ( init = pvar1402_init
              & pvar1401_init = init
              & pvar1400_init = init ) )
          & ! [Z] :
              ( ( leq(Z,minus(n3,n1))
                & leq(n0,Z) )
             => a_select2(s_try7_init,Z) = init )
          & ! [Y] :
              ( ( leq(n0,Y)
                & leq(Y,n2) )
             => init = a_select2(s_center7_init,Y) )
          & ! [X] :
              ( ( leq(X,n3)
                & leq(n0,X) )
             => a_select2(tptp_update2(s_values7_init,s_worst7,init),X) = init )
          & ! [V] :
              ( ! [W] :
                  ( ( leq(n0,W)
                    & leq(W,n3) )
                 => a_select3(simplex7_init,W,V) = init )
             <= ( leq(n0,V)
                & leq(V,n2) ) )
          & leq(s_worst7,n3)
          & leq(n0,s_worst7)
          & leq(n0,s_sworst7)
          & init = s_worst7_init
          & s_sworst7_init = init
          & init = s_best7_init
          & init = init ) ) ) ) ).

fof(gt_4_0,axiom,
    gt(n4,n0) ).

fof(gt_410_0,axiom,
    gt(n410,n0) ).

fof(gt_330_4,axiom,
    gt(n330,n4) ).

fof(gt_3_1,axiom,
    gt(n3,n1) ).

