fof(less_than_transitive,axiom,
    ! [A,B,C] :
      ( ( less_than(A,B)
        & less_than(B,C) )
     => less_than(A,C) ) ).

fof(less_than_meet_join,axiom,
    ! [A,B] :
      ( less_than(A,B)
     => ( meet(A,B,A)
        & join(A,B,B) ) ) ).

fof(meet_join_assumption,axiom,
    ( join(x,w,p)
    & meet(y,z,w) ) ).

fof(commutitivity_meet,axiom,
    ! [A,B,C] :
      ( meet(B,A,C)
     <= meet(A,B,C) ) ).

fof(less_than_reflexive,axiom,
    ! [A] : less_than(A,A) ).

fof(join_assumption,axiom,
    ( join(x,y,t)
    & join(x,z,u) ) ).

fof(meet_assumption,axiom,
    meet(t,u,v) ).

fof(goal_to_be_proved,conjecture,
    goal ).

fof(least_upper_bound_join,axiom,
    ! [A,B,C,D] :
      ( ( less_than(B,D)
        & less_than(A,D)
        & join(A,B,C) )
     => less_than(C,D) ) ).

fof(lower_bound_meet,axiom,
    ! [A,B,C] :
      ( ( less_than(C,B)
        & less_than(C,A) )
     <= meet(A,B,C) ) ).

fof(greatest_lower_bound_meet,axiom,
    ! [A,B,C,D] :
      ( less_than(D,C)
     <= ( less_than(D,B)
        & less_than(D,A)
        & meet(A,B,C) ) ) ).

fof(associativity_meet,axiom,
    ! [A,B,C,D,E,F] :
      ( meet(A,F,E)
     <= ( meet(B,C,F)
        & meet(D,C,E)
        & meet(A,B,D) ) ) ).

fof(do_lattice,axiom,
    ! [A,B] :
    ? [C] : meet(A,B,C) ).

fof(associativity_join,axiom,
    ! [A,B,C,D,E,F] :
      ( ( join(A,B,D)
        & join(B,C,F)
        & join(D,C,E) )
     => join(A,F,E) ) ).

fof(upper_bound_join,axiom,
    ! [A,B,C] :
      ( ( less_than(B,C)
        & less_than(A,C) )
     <= join(A,B,C) ) ).

fof(lo_le_distr,axiom,
    ! [A,B,C,D,E,F,G,H] :
      ( less_than(D,G)
     <= ( join(B,C,H)
        & meet(A,B,E)
        & meet(A,C,F)
        & join(E,F,G)
        & meet(A,H,D) ) ) ).

fof(commutitivity_join,axiom,
    ! [A,B,C] :
      ( join(B,A,C)
     <= join(A,B,C) ) ).

fof(goal_ax,axiom,
    ( less_than(v,p)
   => goal ) ).

