thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] : ( A @ X @ W ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] : ( A @ X @ W ) ) ) ).

thf(unit_decl,type,
    unit: $i ).

thf(e0_decl,type,
    e0: $i ).

thf(e1_decl,type,
    e1: $i ).

thf(e2_decl,type,
    e2: $i ).

thf(e3_decl,type,
    e3: $i ).

thf(qmltpeq_decl,type,
    qmltpeq: $i > $i > mworld > $o ).

thf(inv_decl,type,
    inv: $i > $i ).

thf(op_decl,type,
    op: $i > $i > $i ).

thf(ax5,axiom,
    mlocal @ ( mbox @ ( qmltpeq @ ( inv @ unit ) @ unit ) ) ).

thf(ax8,axiom,
    mlocal @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ ( inv @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ ( inv @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ ( inv @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ ( inv @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ ( inv @ e3 ) ) ) ) ) @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ ( inv @ e3 ) ) ) ) ) ) ) ) ) ) ).

thf(op_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( qmltpeq @ ( op @ A @ C ) @ ( op @ B @ C ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax3,axiom,
    mlocal @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ unit @ e0 ) @ e0 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ unit ) @ e0 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ unit @ e1 ) @ e1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ unit ) @ e1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ unit @ e2 ) @ e2 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ unit ) @ e2 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ unit @ e3 ) @ e3 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e3 @ unit ) @ e3 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ unit @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ unit @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ unit @ e2 ) ) @ ( mbox @ ( qmltpeq @ unit @ e3 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax2,axiom,
    mlocal @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e0 ) @ e0 ) @ ( op @ e0 @ ( op @ e0 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e0 ) @ e1 ) @ ( op @ e0 @ ( op @ e0 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e0 ) @ e2 ) @ ( op @ e0 @ ( op @ e0 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e0 ) @ e3 ) @ ( op @ e0 @ ( op @ e0 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e1 ) @ e0 ) @ ( op @ e0 @ ( op @ e1 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e1 ) @ e1 ) @ ( op @ e0 @ ( op @ e1 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e1 ) @ e2 ) @ ( op @ e0 @ ( op @ e1 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e1 ) @ e3 ) @ ( op @ e0 @ ( op @ e1 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e2 ) @ e0 ) @ ( op @ e0 @ ( op @ e2 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e2 ) @ e1 ) @ ( op @ e0 @ ( op @ e2 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e2 ) @ e2 ) @ ( op @ e0 @ ( op @ e2 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e2 ) @ e3 ) @ ( op @ e0 @ ( op @ e2 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e3 ) @ e0 ) @ ( op @ e0 @ ( op @ e3 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e3 ) @ e1 ) @ ( op @ e0 @ ( op @ e3 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e3 ) @ e2 ) @ ( op @ e0 @ ( op @ e3 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e0 @ e3 ) @ e3 ) @ ( op @ e0 @ ( op @ e3 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e0 ) @ e0 ) @ ( op @ e1 @ ( op @ e0 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e0 ) @ e1 ) @ ( op @ e1 @ ( op @ e0 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e0 ) @ e2 ) @ ( op @ e1 @ ( op @ e0 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e0 ) @ e3 ) @ ( op @ e1 @ ( op @ e0 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e1 ) @ e0 ) @ ( op @ e1 @ ( op @ e1 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e1 ) @ e1 ) @ ( op @ e1 @ ( op @ e1 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e1 ) @ e2 ) @ ( op @ e1 @ ( op @ e1 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e1 ) @ e3 ) @ ( op @ e1 @ ( op @ e1 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e2 ) @ e0 ) @ ( op @ e1 @ ( op @ e2 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e2 ) @ e1 ) @ ( op @ e1 @ ( op @ e2 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e2 ) @ e2 ) @ ( op @ e1 @ ( op @ e2 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e2 ) @ e3 ) @ ( op @ e1 @ ( op @ e2 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e3 ) @ e0 ) @ ( op @ e1 @ ( op @ e3 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e3 ) @ e1 ) @ ( op @ e1 @ ( op @ e3 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e3 ) @ e2 ) @ ( op @ e1 @ ( op @ e3 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e1 @ e3 ) @ e3 ) @ ( op @ e1 @ ( op @ e3 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e0 ) @ e0 ) @ ( op @ e2 @ ( op @ e0 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e0 ) @ e1 ) @ ( op @ e2 @ ( op @ e0 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e0 ) @ e2 ) @ ( op @ e2 @ ( op @ e0 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e0 ) @ e3 ) @ ( op @ e2 @ ( op @ e0 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e1 ) @ e0 ) @ ( op @ e2 @ ( op @ e1 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e1 ) @ e1 ) @ ( op @ e2 @ ( op @ e1 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e1 ) @ e2 ) @ ( op @ e2 @ ( op @ e1 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e1 ) @ e3 ) @ ( op @ e2 @ ( op @ e1 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e2 ) @ e0 ) @ ( op @ e2 @ ( op @ e2 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e2 ) @ e1 ) @ ( op @ e2 @ ( op @ e2 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e2 ) @ e2 ) @ ( op @ e2 @ ( op @ e2 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e2 ) @ e3 ) @ ( op @ e2 @ ( op @ e2 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e3 ) @ e0 ) @ ( op @ e2 @ ( op @ e3 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e3 ) @ e1 ) @ ( op @ e2 @ ( op @ e3 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e3 ) @ e2 ) @ ( op @ e2 @ ( op @ e3 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e2 @ e3 ) @ e3 ) @ ( op @ e2 @ ( op @ e3 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e0 ) @ e0 ) @ ( op @ e3 @ ( op @ e0 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e0 ) @ e1 ) @ ( op @ e3 @ ( op @ e0 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e0 ) @ e2 ) @ ( op @ e3 @ ( op @ e0 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e0 ) @ e3 ) @ ( op @ e3 @ ( op @ e0 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e1 ) @ e0 ) @ ( op @ e3 @ ( op @ e1 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e1 ) @ e1 ) @ ( op @ e3 @ ( op @ e1 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e1 ) @ e2 ) @ ( op @ e3 @ ( op @ e1 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e1 ) @ e3 ) @ ( op @ e3 @ ( op @ e1 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e2 ) @ e0 ) @ ( op @ e3 @ ( op @ e2 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e2 ) @ e1 ) @ ( op @ e3 @ ( op @ e2 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e2 ) @ e2 ) @ ( op @ e3 @ ( op @ e2 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e2 ) @ e3 ) @ ( op @ e3 @ ( op @ e2 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e3 ) @ e0 ) @ ( op @ e3 @ ( op @ e3 @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e3 ) @ e1 ) @ ( op @ e3 @ ( op @ e3 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e3 ) @ e2 ) @ ( op @ e3 @ ( op @ e3 @ e2 ) ) ) ) @ ( mbox @ ( qmltpeq @ ( op @ ( op @ e3 @ e3 ) @ e3 ) @ ( op @ e3 @ ( op @ e3 @ e3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax11,axiom,
    mlocal @ ( mand @ ( mbox @ ( qmltpeq @ e0 @ ( op @ e3 @ e3 ) ) ) @ ( mbox @ ( qmltpeq @ e1 @ ( op @ e2 @ e3 ) ) ) ) ).

thf(transitivity,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [Y: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [Z: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ X @ Y ) ) @ ( mbox @ ( qmltpeq @ Y @ Z ) ) ) @ ( mbox @ ( qmltpeq @ X @ Z ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax4,axiom,
    mlocal @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ ( inv @ e0 ) ) @ unit ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( inv @ e0 ) @ e0 ) @ unit ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ ( inv @ e1 ) ) @ unit ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( inv @ e1 ) @ e1 ) @ unit ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ ( inv @ e2 ) ) @ unit ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( inv @ e2 ) @ e2 ) @ unit ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e3 @ ( inv @ e3 ) ) @ unit ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ ( inv @ e3 ) @ e3 ) @ unit ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e3 ) ) ) ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax10,axiom,
    mlocal @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ e0 @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ e0 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ e0 @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ e1 @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ e1 @ e3 ) ) ) ) @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ e2 @ e3 ) ) ) ) ) ) ) ) ) ).

thf(symmetry,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [Y: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ X @ Y ) ) @ ( mbox @ ( qmltpeq @ Y @ X ) ) ) ) ) ) ) ) ) ).

thf(mrel_reflexive,axiom,
    ! [W: mworld] : ( mrel @ W @ W ) ).

thf(inv_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( qmltpeq @ ( inv @ A ) @ ( inv @ B ) ) ) ) ) ) ) ) ) ) ).

thf(reflexivity,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] : ( mbox @ ( qmltpeq @ X @ X ) ) ) ) ) ).

thf(ax6,axiom,
    mlocal @ ( mand @ ( mbox @ ( qmltpeq @ ( inv @ ( inv @ e0 ) ) @ e0 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( inv @ ( inv @ e1 ) ) @ e1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( inv @ ( inv @ e2 ) ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ ( inv @ e3 ) ) @ e3 ) ) ) ) ) ).

thf(op_substitution_2,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( qmltpeq @ ( op @ C @ A ) @ ( op @ C @ B ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(co1,conjecture,
    mlocal @ ( mbox @ ( mnot @ ( mand @ ( mor @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e0 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e0 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e0 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e0 ) ) ) ) ) @ ( mor @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e1 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e1 ) ) ) ) ) @ ( mor @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e2 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e2 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e3 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e3 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e3 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e3 ) ) ) ) ) ) ) ) @ ( mbox @ ( mnot @ ( mor @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e0 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e0 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e0 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e0 ) ) ) ) ) @ ( mor @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e1 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e1 ) ) ) ) ) @ ( mor @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e2 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e2 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e3 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e3 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e3 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e3 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax9,axiom,
    mlocal @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ ( op @ e1 @ e0 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ ( op @ e2 @ e0 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ ( op @ e3 @ e0 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ ( op @ e2 @ e0 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ ( op @ e3 @ e0 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ ( op @ e3 @ e0 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ ( op @ e1 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ ( op @ e2 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ ( op @ e3 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ ( op @ e2 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ ( op @ e3 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e1 ) @ ( op @ e3 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ ( op @ e1 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ ( op @ e2 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ ( op @ e3 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e2 ) @ ( op @ e2 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e2 ) @ ( op @ e3 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ ( op @ e3 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e3 ) @ ( op @ e1 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e3 ) @ ( op @ e2 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e3 ) @ ( op @ e3 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e3 ) @ ( op @ e2 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e3 ) @ ( op @ e3 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e3 ) @ ( op @ e3 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ ( op @ e0 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ ( op @ e0 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ ( op @ e0 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ ( op @ e0 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ ( op @ e0 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ ( op @ e0 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ ( op @ e1 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ ( op @ e1 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ ( op @ e1 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ ( op @ e1 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ ( op @ e1 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e2 ) @ ( op @ e1 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ ( op @ e2 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ ( op @ e2 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ ( op @ e2 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e1 ) @ ( op @ e2 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e1 ) @ ( op @ e2 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ ( op @ e2 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e0 ) @ ( op @ e3 @ e1 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e0 ) @ ( op @ e3 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e0 ) @ ( op @ e3 @ e3 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e1 ) @ ( op @ e3 @ e2 ) ) ) ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e1 ) @ ( op @ e3 @ e3 ) ) ) ) ) @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e2 ) @ ( op @ e3 @ e3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax7,axiom,
    mlocal @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e0 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e1 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e3 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e0 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e0 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e1 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e3 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e1 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e0 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e1 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e3 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e2 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e0 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e0 ) @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e1 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e1 ) @ e3 ) ) ) ) @ ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e2 ) @ e3 ) ) ) ) @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e3 ) ) @ ( mbox @ ( qmltpeq @ ( inv @ e3 ) @ e3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax1,axiom,
    mlocal @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e0 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e1 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e2 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e3 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e3 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e3 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e0 @ e3 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e0 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e1 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e2 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e2 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e2 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e3 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e3 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e3 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e1 @ e3 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e0 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e1 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e1 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e1 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e1 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e2 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e3 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e3 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e3 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e2 @ e3 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e0 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e0 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e0 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e0 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e1 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e1 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e1 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e1 ) @ e3 ) ) ) ) ) @ ( mand @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e2 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e2 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e2 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e2 ) @ e3 ) ) ) ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e0 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e1 ) ) @ ( mor @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e2 ) ) @ ( mbox @ ( qmltpeq @ ( op @ e3 @ e3 ) @ e3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

