thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(eiw_di_type,type,
    eiw_di: $i > mworld > $o ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] :
          ( ( eiw_di @ X @ W )
         => ( A @ X @ W ) ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] :
          ( ( eiw_di @ X @ W )
          & ( A @ X @ W ) ) ) ) ).

thf(chevy_decl,type,
    chevy: $i > mworld > $o ).

thf(dirty_decl,type,
    dirty: $i > mworld > $o ).

thf(barrel_decl,type,
    barrel: $i > $i > mworld > $o ).

thf(hollywood_decl,type,
    hollywood: $i > mworld > $o ).

thf(city_decl,type,
    city: $i > mworld > $o ).

thf(in_decl,type,
    in: $i > $i > mworld > $o ).

thf(young_decl,type,
    young: $i > mworld > $o ).

thf(old_decl,type,
    old: $i > mworld > $o ).

thf(down_decl,type,
    down: $i > $i > mworld > $o ).

thf(way_decl,type,
    way: $i > mworld > $o ).

thf(qmltpeq_decl,type,
    qmltpeq: $i > $i > mworld > $o ).

thf(seat_decl,type,
    seat: $i > mworld > $o ).

thf(white_decl,type,
    white: $i > mworld > $o ).

thf(car_decl,type,
    car: $i > mworld > $o ).

thf(furniture_decl,type,
    furniture: $i > mworld > $o ).

thf(street_decl,type,
    street: $i > mworld > $o ).

thf(fellow_decl,type,
    fellow: $i > mworld > $o ).

thf(front_decl,type,
    front: $i > mworld > $o ).

thf(man_decl,type,
    man: $i > mworld > $o ).

thf(event_decl,type,
    event: $i > mworld > $o ).

thf(lonely_decl,type,
    lonely: $i > mworld > $o ).

thf(city_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( city @ A ) ) @ ( city @ B ) ) ) ) ) ).

thf(hollywood_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( hollywood @ A ) ) @ ( hollywood @ B ) ) ) ) ) ).

thf(in_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( in @ A @ C ) ) @ ( in @ B @ C ) ) ) ) ) ) ).

thf(man_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( man @ A ) ) @ ( man @ B ) ) ) ) ) ).

thf(furniture_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( furniture @ A ) ) @ ( furniture @ B ) ) ) ) ) ).

thf(street_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( street @ A ) ) @ ( street @ B ) ) ) ) ) ).

thf(transitivity,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [Y: $i] :
              ( mforall_di
              @ ^ [Z: $i] : ( mimplies @ ( mand @ ( qmltpeq @ X @ Y ) @ ( qmltpeq @ Y @ Z ) ) @ ( qmltpeq @ X @ Z ) ) ) ) ) ) ).

thf(co1,conjecture,
    ( mlocal
    @ ( mand
      @ ( mimplies
        @ ( mexists_di
          @ ^ [U: $i] :
              ( mexists_di
              @ ^ [V: $i] :
                  ( mexists_di
                  @ ^ [W: $i] :
                      ( mexists_di
                      @ ^ [X: $i] :
                          ( mexists_di
                          @ ^ [Y: $i] :
                              ( mexists_di
                              @ ^ [Z: $i] :
                                  ( mexists_di
                                  @ ^ [X1: $i] :
                                      ( mexists_di
                                      @ ^ [X2: $i] :
                                          ( mexists_di
                                          @ ^ [X4: $i] :
                                              ( mexists_di
                                              @ ^ [X5: $i] : ( mand @ ( seat @ U ) @ ( mand @ ( furniture @ U ) @ ( mand @ ( front @ U ) @ ( mand @ ( seat @ V ) @ ( mand @ ( furniture @ V ) @ ( mand @ ( front @ V ) @ ( mand @ ( hollywood @ W ) @ ( mand @ ( city @ W ) @ ( mand @ ( event @ X ) @ ( mand @ ( street @ Y ) @ ( mand @ ( way @ Y ) @ ( mand @ ( lonely @ Y ) @ ( mand @ ( chevy @ Z ) @ ( mand @ ( car @ Z ) @ ( mand @ ( white @ Z ) @ ( mand @ ( dirty @ Z ) @ ( mand @ ( old @ Z ) @ ( mand @ ( barrel @ X @ Z ) @ ( mand @ ( down @ X @ Y ) @ ( mand @ ( in @ X @ W ) @ ( mand @ ( mnot @ ( qmltpeq @ X1 @ X2 ) ) @ ( mand @ ( fellow @ X1 ) @ ( mand @ ( man @ X1 ) @ ( mand @ ( young @ X1 ) @ ( mand @ ( fellow @ X2 ) @ ( mand @ ( man @ X2 ) @ ( mand @ ( young @ X2 ) @ ( mand @ ( qmltpeq @ X1 @ X4 ) @ ( mand @ ( in @ X4 @ U ) @ ( mand @ ( qmltpeq @ X2 @ X5 ) @ ( in @ X5 @ V ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
        @ ( mexists_di
          @ ^ [X6: $i] :
              ( mexists_di
              @ ^ [X7: $i] :
                  ( mexists_di
                  @ ^ [X8: $i] :
                      ( mexists_di
                      @ ^ [X9: $i] :
                          ( mexists_di
                          @ ^ [X10: $i] :
                              ( mexists_di
                              @ ^ [X11: $i] :
                                  ( mexists_di
                                  @ ^ [X12: $i] :
                                      ( mexists_di
                                      @ ^ [X13: $i] :
                                          ( mexists_di
                                          @ ^ [X15: $i] :
                                              ( mexists_di
                                              @ ^ [X16: $i] : ( mand @ ( seat @ X6 ) @ ( mand @ ( furniture @ X6 ) @ ( mand @ ( front @ X6 ) @ ( mand @ ( seat @ X7 ) @ ( mand @ ( furniture @ X7 ) @ ( mand @ ( front @ X7 ) @ ( mand @ ( hollywood @ X8 ) @ ( mand @ ( city @ X8 ) @ ( mand @ ( event @ X9 ) @ ( mand @ ( chevy @ X10 ) @ ( mand @ ( car @ X10 ) @ ( mand @ ( white @ X10 ) @ ( mand @ ( dirty @ X10 ) @ ( mand @ ( old @ X10 ) @ ( mand @ ( street @ X11 ) @ ( mand @ ( way @ X11 ) @ ( mand @ ( lonely @ X11 ) @ ( mand @ ( barrel @ X9 @ X10 ) @ ( mand @ ( down @ X9 @ X11 ) @ ( mand @ ( in @ X9 @ X8 ) @ ( mand @ ( mnot @ ( qmltpeq @ X12 @ X13 ) ) @ ( mand @ ( fellow @ X12 ) @ ( mand @ ( man @ X12 ) @ ( mand @ ( young @ X12 ) @ ( mand @ ( fellow @ X13 ) @ ( mand @ ( man @ X13 ) @ ( mand @ ( young @ X13 ) @ ( mand @ ( qmltpeq @ X12 @ X15 ) @ ( mand @ ( in @ X15 @ X6 ) @ ( mand @ ( qmltpeq @ X13 @ X16 ) @ ( in @ X16 @ X7 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
      @ ( mimplies
        @ ( mexists_di
          @ ^ [X17: $i] :
              ( mexists_di
              @ ^ [X18: $i] :
                  ( mexists_di
                  @ ^ [X19: $i] :
                      ( mexists_di
                      @ ^ [X20: $i] :
                          ( mexists_di
                          @ ^ [X21: $i] :
                              ( mexists_di
                              @ ^ [X22: $i] :
                                  ( mexists_di
                                  @ ^ [X23: $i] :
                                      ( mexists_di
                                      @ ^ [X24: $i] :
                                          ( mexists_di
                                          @ ^ [X26: $i] :
                                              ( mexists_di
                                              @ ^ [X27: $i] : ( mand @ ( seat @ X17 ) @ ( mand @ ( furniture @ X17 ) @ ( mand @ ( front @ X17 ) @ ( mand @ ( seat @ X18 ) @ ( mand @ ( furniture @ X18 ) @ ( mand @ ( front @ X18 ) @ ( mand @ ( hollywood @ X19 ) @ ( mand @ ( city @ X19 ) @ ( mand @ ( event @ X20 ) @ ( mand @ ( chevy @ X21 ) @ ( mand @ ( car @ X21 ) @ ( mand @ ( white @ X21 ) @ ( mand @ ( dirty @ X21 ) @ ( mand @ ( old @ X21 ) @ ( mand @ ( street @ X22 ) @ ( mand @ ( way @ X22 ) @ ( mand @ ( lonely @ X22 ) @ ( mand @ ( barrel @ X20 @ X21 ) @ ( mand @ ( down @ X20 @ X22 ) @ ( mand @ ( in @ X20 @ X19 ) @ ( mand @ ( mnot @ ( qmltpeq @ X23 @ X24 ) ) @ ( mand @ ( fellow @ X23 ) @ ( mand @ ( man @ X23 ) @ ( mand @ ( young @ X23 ) @ ( mand @ ( fellow @ X24 ) @ ( mand @ ( man @ X24 ) @ ( mand @ ( young @ X24 ) @ ( mand @ ( qmltpeq @ X23 @ X26 ) @ ( mand @ ( in @ X26 @ X17 ) @ ( mand @ ( qmltpeq @ X24 @ X27 ) @ ( in @ X27 @ X18 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
        @ ( mexists_di
          @ ^ [X28: $i] :
              ( mexists_di
              @ ^ [X29: $i] :
                  ( mexists_di
                  @ ^ [X30: $i] :
                      ( mexists_di
                      @ ^ [X31: $i] :
                          ( mexists_di
                          @ ^ [X32: $i] :
                              ( mexists_di
                              @ ^ [X33: $i] :
                                  ( mexists_di
                                  @ ^ [X34: $i] :
                                      ( mexists_di
                                      @ ^ [X35: $i] :
                                          ( mexists_di
                                          @ ^ [X37: $i] :
                                              ( mexists_di
                                              @ ^ [X38: $i] : ( mand @ ( seat @ X28 ) @ ( mand @ ( furniture @ X28 ) @ ( mand @ ( front @ X28 ) @ ( mand @ ( seat @ X29 ) @ ( mand @ ( furniture @ X29 ) @ ( mand @ ( front @ X29 ) @ ( mand @ ( hollywood @ X30 ) @ ( mand @ ( city @ X30 ) @ ( mand @ ( event @ X31 ) @ ( mand @ ( street @ X32 ) @ ( mand @ ( way @ X32 ) @ ( mand @ ( lonely @ X32 ) @ ( mand @ ( chevy @ X33 ) @ ( mand @ ( car @ X33 ) @ ( mand @ ( white @ X33 ) @ ( mand @ ( dirty @ X33 ) @ ( mand @ ( old @ X33 ) @ ( mand @ ( barrel @ X31 @ X33 ) @ ( mand @ ( down @ X31 @ X32 ) @ ( mand @ ( in @ X31 @ X30 ) @ ( mand @ ( mnot @ ( qmltpeq @ X34 @ X35 ) ) @ ( mand @ ( fellow @ X34 ) @ ( mand @ ( man @ X34 ) @ ( mand @ ( young @ X34 ) @ ( mand @ ( fellow @ X35 ) @ ( mand @ ( man @ X35 ) @ ( mand @ ( young @ X35 ) @ ( mand @ ( qmltpeq @ X34 @ X37 ) @ ( mand @ ( in @ X37 @ X28 ) @ ( mand @ ( qmltpeq @ X35 @ X38 ) @ ( in @ X38 @ X29 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(barrel_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( barrel @ A @ C ) ) @ ( barrel @ B @ C ) ) ) ) ) ) ).

thf(dirty_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( dirty @ A ) ) @ ( dirty @ B ) ) ) ) ) ).

thf(event_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( event @ A ) ) @ ( event @ B ) ) ) ) ) ).

thf(old_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( old @ A ) ) @ ( old @ B ) ) ) ) ) ).

thf(car_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( car @ A ) ) @ ( car @ B ) ) ) ) ) ).

thf(symmetry,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [Y: $i] : ( mimplies @ ( qmltpeq @ X @ Y ) @ ( qmltpeq @ Y @ X ) ) ) ) ) ).

thf(down_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( down @ C @ A ) ) @ ( down @ C @ B ) ) ) ) ) ) ).

thf(eiw_di_nonempty,axiom,
    ! [W: mworld] :
    ? [X: $i] : ( eiw_di @ X @ W ) ).

thf(young_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( young @ A ) ) @ ( young @ B ) ) ) ) ) ).

thf(front_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( front @ A ) ) @ ( front @ B ) ) ) ) ) ).

thf(reflexivity,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] : ( qmltpeq @ X @ X ) ) ) ).

thf(white_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( white @ A ) ) @ ( white @ B ) ) ) ) ) ).

thf(seat_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( seat @ A ) ) @ ( seat @ B ) ) ) ) ) ).

thf(lonely_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( lonely @ A ) ) @ ( lonely @ B ) ) ) ) ) ).

thf(in_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( in @ C @ A ) ) @ ( in @ C @ B ) ) ) ) ) ) ).

thf(chevy_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( chevy @ A ) ) @ ( chevy @ B ) ) ) ) ) ).

thf(eiw_di_cumul,axiom,
    ! [W: mworld,V: mworld,X: $i] :
      ( ( eiw_di @ X @ V )
     <= ( ( eiw_di @ X @ W )
        & ( mrel @ W @ V ) ) ) ).

thf(barrel_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( barrel @ C @ A ) ) @ ( barrel @ C @ B ) ) ) ) ) ) ).

thf(down_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( down @ A @ C ) ) @ ( down @ B @ C ) ) ) ) ) ) ).

thf(fellow_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( fellow @ A ) ) @ ( fellow @ B ) ) ) ) ) ).

thf(way_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( way @ A ) ) @ ( way @ B ) ) ) ) ) ).

