thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] : ( A @ X @ W ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] : ( A @ X @ W ) ) ) ).

thf(u_decl,type,
    u: $i ).

thf(one_decl,type,
    one: $i ).

thf(number_decl,type,
    number: $i > $i > mworld > $o ).

thf(string_decl,type,
    string: $i > mworld > $o ).

thf(in_decl,type,
    in: $i > $i > $i > mworld > $o ).

thf(do_decl,type,
    do: $i > $i > $i > mworld > $o ).

thf(entry_box_decl,type,
    entry_box: $i > mworld > $o ).

thf(userid_decl,type,
    userid: $i > $i > mworld > $o ).

thf(ax3,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [S: $i] :
            ( mforall_di
            @ ^ [I: $i] :
                ( mforall_di
                @ ^ [B: $i] :
                    ( mimplies @ ( mand @ ( string @ I ) @ ( entry_box @ B ) )
                    @ ( mexists_di
                      @ ^ [A: $i] :
                          ( mbox
                          @ ( mforall_di
                            @ ^ [S2: $i] : ( mimplies @ ( do @ S @ A @ S2 ) @ ( in @ I @ B @ S2 ) ) ) ) ) ) ) ) ) ) ) ).

thf(mrel_reflexive,axiom,
    ! [W: mworld] : ( mrel @ W @ W ) ).

thf(mrel_transitive,axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( ( mrel @ V @ U )
        & ( mrel @ W @ V ) )
     => ( mrel @ W @ U ) ) ).

thf(con,conjecture,
    ( mlocal
    @ ( mbox
      @ ( mexists_di
        @ ^ [I: $i] :
            ( mexists_di
            @ ^ [B: $i] :
                ( mexists_di
                @ ^ [A: $i] :
                    ( mexists_di
                    @ ^ [S: $i] :
                        ( mand @ ( mbox @ ( mand @ ( userid @ u @ I ) @ ( mand @ ( entry_box @ B ) @ ( number @ B @ one ) ) ) )
                        @ ( mbox
                          @ ( mforall_di
                            @ ^ [S2: $i] : ( mimplies @ ( do @ S @ A @ S2 ) @ ( in @ I @ B @ S2 ) ) ) ) ) ) ) ) ) ) ) ).

thf(ax1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mexists_di
        @ ^ [I: $i] : ( mbox @ ( mand @ ( userid @ u @ I ) @ ( string @ I ) ) ) ) ) ) ).

thf(ax2,axiom,
    ( mlocal
    @ ( mexists_di
      @ ^ [B: $i] : ( mbox @ ( mand @ ( entry_box @ B ) @ ( number @ B @ one ) ) ) ) ) ).

