thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] : ( A @ X @ W ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] : ( A @ X @ W ) ) ) ).

thf(d_decl,type,
    d: $i ).

thf(n_decl,type,
    n: $i ).

thf(o_decl,type,
    o: $i ).

thf(h_decl,type,
    h: $i > mworld > $o ).

thf(closed_decl,type,
    closed: $i > mworld > $o ).

thf(combo_decl,type,
    combo: $i > $i > mworld > $o ).

thf(open_decl,type,
    open: $i > mworld > $o ).

thf(ax5,axiom,
    ( mlocal
    @ ( mexists_di
      @ ^ [V: $i] : ( mbox @ ( combo @ d @ V ) ) ) ) ).

thf(mrel_reflexive,axiom,
    ! [W: mworld] : ( mrel @ W @ W ) ).

thf(ax1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [S: $i] :
            ( mforall_di
            @ ^ [V: $i] :
                ( mexists_di
                @ ^ [O: $i] : ( mand @ ( mbox @ ( mimplies @ ( mand @ ( closed @ S ) @ ( mand @ ( combo @ S @ V ) @ ( h @ O ) ) ) @ ( mbox @ ( open @ S ) ) ) ) @ ( mbox @ ( mimplies @ ( mand @ ( closed @ S ) @ ( mand @ ( mnot @ ( combo @ S @ V ) ) @ ( h @ o ) ) ) @ ( mbox @ ( closed @ S ) ) ) ) ) ) ) ) ) ) ).

thf(ax4,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [S: $i] : ( mnot @ ( mand @ ( open @ S ) @ ( closed @ S ) ) ) ) ) ) ).

thf(con,conjecture,
    ( mlocal
    @ ( mbox
      @ ( mexists_di
        @ ^ [V: $i] :
            ( mexists_di
            @ ^ [O: $i] : ( mimplies @ ( mbox @ ( mand @ ( combo @ d @ V ) @ ( h @ O ) ) ) @ ( mbox @ ( open @ d ) ) ) ) ) ) ) ).

thf(ax2,axiom,
    mlocal @ ( mbox @ ( closed @ d ) ) ).

thf(mrel_transitive,axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( ( mrel @ W @ V )
        & ( mrel @ V @ U ) )
     => ( mrel @ W @ U ) ) ).

thf(ax3,axiom,
    mlocal @ ( mbox @ ( mor @ ( combo @ d @ n ) @ ( mnot @ ( combo @ d @ n ) ) ) ) ).

