thf(mworld,type,
    mworld: $tType ).

thf(mindex,type,
    mindex: $tType ).

thf(mrel_type,type,
    mrel: mindex > mworld > mworld > $o ).

thf('#c_type',type,
    '#c': mindex ).

thf('#u_type',type,
    '#u': mindex ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: mindex > ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [R: mindex,Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ R @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: mindex > ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [R: mindex,Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ R @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(charge_decl,type,
    charge: mworld > $o ).

thf(called_decl,type,
    called: mworld > $o ).

thf(paid_decl,type,
    paid: mworld > $o ).

thf(requirement_1,conjecture,
    mlocal @ ( mimplies @ ( mnot @ ( mimplies @ charge @ ( mand @ called @ ( mnot @ paid ) ) ) ) @ ( mbox @ '#u' @ ( mnot @ ( mimplies @ charge @ ( mand @ called @ ( mnot @ paid ) ) ) ) ) ) ).

thf('mrel_#u_transitive',axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( mrel @ '#u' @ W @ U )
     <= ( ( mrel @ '#u' @ W @ V )
        & ( mrel @ '#u' @ V @ U ) ) ) ).

thf('mrel_#c_reflexive',axiom,
    ! [W: mworld] : ( mrel @ '#c' @ W @ W ) ).

thf(axiom_2,axiom,
    mlocal @ ( mbox @ '#c' @ ( mimplies @ paid @ ( mbox @ '#u' @ paid ) ) ) ).

thf(axiom_charge_u,axiom,
    mlocal @ ( mimplies @ charge @ ( mand @ ( mbox @ '#u' @ charge ) @ ( mbox @ '#c' @ charge ) ) ) ).

thf(axiom_3,axiom,
    mlocal @ ( mimplies @ ( mnot @ ( mbox @ '#c' @ called ) ) @ ( mbox @ '#u' @ ( mnot @ ( mbox @ '#c' @ called ) ) ) ) ).

thf(axiom_4,axiom,
    mlocal @ ( mimplies @ ( mnot @ ( mbox @ '#u' @ paid ) ) @ ( mbox @ '#c' @ ( mnot @ ( mbox @ '#u' @ paid ) ) ) ) ).

thf(axiom_1,axiom,
    mlocal @ ( mbox @ '#u' @ ( mimplies @ called @ ( mbox @ '#c' @ called ) ) ) ).

thf(aciom_paid_charge,axiom,
    mlocal @ ( mimplies @ paid @ called ) ).

thf('mrel_#u_reflexive',axiom,
    ! [W: mworld] : ( mrel @ '#u' @ W @ W ) ).

thf('mrel_#c_transitive',axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( ( mrel @ '#c' @ V @ U )
        & ( mrel @ '#c' @ W @ V ) )
     => ( mrel @ '#c' @ W @ U ) ) ).

