thf(mworld,type,
    mworld: $tType ).

thf(mindex,type,
    mindex: $tType ).

thf(mrel_type,type,
    mrel: mindex > mworld > mworld > $o ).

thf('#c_type',type,
    '#c': mindex ).

thf('#b_type',type,
    '#b': mindex ).

thf('#a_type',type,
    '#a': mindex ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: mindex > ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [R: mindex,Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ R @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: mindex > ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [R: mindex,Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ R @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(c0_decl,type,
    c0: mworld > $o ).

thf(c1_decl,type,
    c1: mworld > $o ).

thf(b0_decl,type,
    b0: mworld > $o ).

thf(c2_decl,type,
    c2: mworld > $o ).

thf(b1_decl,type,
    b1: mworld > $o ).

thf(a0_decl,type,
    a0: mworld > $o ).

thf(b2_decl,type,
    b2: mworld > $o ).

thf(a1_decl,type,
    a1: mworld > $o ).

thf(a2_decl,type,
    a2: mworld > $o ).

thf(cb_decl,type,
    cb: mworld > $o ).

thf(axiom_knows_a_b_c,axiom,
    mlocal @ ( mbox @ '#a' @ ( mbox @ '#b' @ ( mor @ ( mbox @ '#c' @ c0 ) @ ( mor @ ( mbox @ '#c' @ c1 ) @ ( mbox @ '#c' @ c2 ) ) ) ) ) ).

thf(axiom_knows_c_a_b,axiom,
    mlocal @ ( mbox @ '#c' @ ( mbox @ '#a' @ ( mor @ ( mbox @ '#b' @ cb ) @ ( mor @ ( mbox @ '#b' @ b1 ) @ ( mbox @ '#b' @ b2 ) ) ) ) ) ).

thf(axiom_knows_a_b_c_0,axiom,
    mlocal @ ( mbox @ '#a' @ ( mbox @ '#b' @ ( mor @ ( mbox @ '#c' @ c0 ) @ ( mor @ ( mbox @ '#c' @ c1 ) @ ( mbox @ '#c' @ c2 ) ) ) ) ) ).

thf('mrel_#a_universal',axiom,
    ! [W: mworld,V: mworld] : ( mrel @ '#a' @ W @ V ) ).

thf('mrel_#b_universal',axiom,
    ! [W: mworld,V: mworld] : ( mrel @ '#b' @ W @ V ) ).

thf('mrel_#c_universal',axiom,
    ! [W: mworld,V: mworld] : ( mrel @ '#c' @ W @ V ) ).

thf(axiom_knows_b_a_c,axiom,
    mlocal @ ( mbox @ '#b' @ ( mbox @ '#a' @ ( mor @ ( mbox @ '#c' @ c0 ) @ ( mor @ ( mbox @ '#c' @ c1 ) @ ( mbox @ '#c' @ c2 ) ) ) ) ) ).

thf(axiom_knows_b_c_a,axiom,
    mlocal @ ( mbox @ '#b' @ ( mbox @ '#c' @ ( mor @ ( mbox @ '#a' @ a0 ) @ ( mor @ ( mbox @ '#a' @ a1 ) @ ( mbox @ '#a' @ a2 ) ) ) ) ) ).

thf(axiom_knows_c_b_a,axiom,
    mlocal @ ( mbox @ '#c' @ ( mbox @ '#b' @ ( mor @ ( mbox @ '#a' @ a0 ) @ ( mor @ ( mbox @ '#a' @ a1 ) @ ( mbox @ '#a' @ a2 ) ) ) ) ) ).

thf(con,conjecture,
    mlocal @ ( mbox @ '#b' @ ( mnot @ ( mdia @ '#a' @ ( mdia @ '#b' @ ( mbox @ '#c' @ ( mnot @ a0 ) ) ) ) ) ) ).

thf(axiom_knows_a_c_b,axiom,
    mlocal @ ( mbox @ '#a' @ ( mbox @ '#c' @ ( mor @ ( mbox @ '#b' @ b0 ) @ ( mor @ ( mbox @ '#b' @ b1 ) @ ( mbox @ '#b' @ b2 ) ) ) ) ) ).

thf(axiom_a0,axiom,
    mlocal @ a0 ).

