tff(array_type,type,
    array: $tType ).

tff(read_type,type,
    read: ( array * $int ) > $int ).

tff(write_type,type,
    write: ( array * $int * $int ) > array ).

tff(init_type,type,
    init: $int > array ).

tff(max,type,
    max: ( array * $int ) > $int ).

tff(sorted_type,type,
    sorted: ( array * $int ) > $o ).

tff(inRange_type,type,
    inRange: ( array * $int * $int ) > $o ).

tff(distinct_type,type,
    distinct: ( array * $int ) > $o ).

tff(rev_n,type,
    rev: ( array * $int ) > array ).

tff(a,axiom,
    ! [A: array,N: $int,W: $int] :
      ( ( ! [I: $int] :
            ( $lesseq(read(A,I),W)
           <= ( $greater(N,I)
              & $greatereq(I,0) ) )
        & ? [I: $int] :
            ( $greatereq(I,0)
            & ( read(A,I) = W )
            & $greater(N,I) ) )
     => ( max(A,N) = W ) ) ).

tff(ax1,axiom,
    ! [A: array,I: $int,V: $int] : ( read(write(A,I,V),I) = V ) ).

tff(c,conjecture,
    ! [A: array,B1: array,B2: array,N: $int] :
      ( ( ! [I: $int] :
            ( ( $greatereq(I,0)
              & ( read(B1,I) = read(A,$difference(N,$sum(I,1))) )
              & $greater(N,I) )
            | ( ( read(B1,I) = read(A,I) )
              & ( $greater(0,I)
                | $greatereq(I,N) ) ) )
        & ! [I: $int] :
            ( ( $greatereq(I,0)
              & ( read(B2,I) = read(A,$difference(N,$sum(I,1))) )
              & $greater(N,I) )
            | ( ( $greatereq(I,N)
                | $greater(0,I) )
              & ( read(B2,I) = read(A,I) ) ) ) )
     => ( B1 = B2 ) ) ).

tff(ax3,axiom,
    ! [V: $int,I: $int] : ( read(init(V),I) = V ) ).

tff(inRange,axiom,
    ! [A: array,R: $int,N: $int] :
      ( inRange(A,R,N)
    <=> ! [I: $int] :
          ( ( $greatereq(I,0)
            & $greater(N,I) )
         => ( $greatereq(read(A,I),0)
            & $greatereq(R,read(A,I)) ) ) ) ).

tff(ax2,axiom,
    ! [A: array,I: $int,J: $int,V: $int] :
      ( ( read(write(A,I,V),J) = read(A,J) )
      | ( I = J ) ) ).

tff(distinct,axiom,
    ! [A: array,N: $int] :
      ( ! [I: $int,J: $int] :
          ( ( $greater(N,J)
            & $greatereq(I,0)
            & $greatereq(J,0)
            & $greater(N,I) )
         => ( ( I = J )
           <= ( read(A,I) = read(A,J) ) ) )
    <=> distinct(A,N) ) ).

tff(ext,axiom,
    ! [A: array,B: array] :
      ( ! [I: $int] : ( read(A,I) = read(B,I) )
     => ( A = B ) ) ).

tff(rev_n1_proper,axiom,
    ! [A: array,B: array,N: $int] :
      ( ( rev(A,N) = B )
     <= ! [I: $int] :
          ( ( ( read(B,I) = read(A,$difference(N,$sum(I,1))) )
            & $greater(N,I)
            & $greatereq(I,0) )
          | ( ( read(B,I) = read(A,I) )
            & ( $greater(0,I)
              | $greatereq(I,N) ) ) ) ) ).

tff(sorted1,axiom,
    ! [A: array,N: $int] :
      ( ! [I: $int,J: $int] :
          ( ( $lesseq(0,I)
            & $less(I,N)
            & $less(I,J)
            & $less(J,N) )
         => $lesseq(read(A,I),read(A,J)) )
    <=> sorted(A,N) ) ).

