tff(array_type,type,
    array: $tType ).

tff(read_type,type,
    read: ( array * $int ) > $int ).

tff(write_type,type,
    write: ( array * $int * $int ) > array ).

tff(init_type,type,
    init: $int > array ).

tff(max,type,
    max: ( array * $int ) > $int ).

tff(sorted_type,type,
    sorted: ( array * $int ) > $o ).

tff(inRange_type,type,
    inRange: ( array * $int * $int ) > $o ).

tff(distinct_type,type,
    distinct: ( array * $int ) > $o ).

tff(rev_n,type,
    rev: ( array * $int ) > array ).

tff(rev_n1_proper,axiom,
    ! [A: array,B: array,N: $int] :
      ( ! [I: $int] :
          ( ( ( $greatereq(I,N)
              | $greater(0,I) )
            & ( read(B,I) = read(A,I) ) )
          | ( $greatereq(I,0)
            & $greater(N,I)
            & ( read(B,I) = read(A,$difference(N,$sum(I,1))) ) ) )
     => ( rev(A,N) = B ) ) ).

tff(sorted1,axiom,
    ! [A: array,N: $int] :
      ( sorted(A,N)
    <=> ! [I: $int,J: $int] :
          ( $lesseq(read(A,I),read(A,J))
         <= ( $lesseq(0,I)
            & $less(I,N)
            & $less(I,J)
            & $less(J,N) ) ) ) ).

tff(ax3,axiom,
    ! [V: $int,I: $int] : ( read(init(V),I) = V ) ).

tff(distinct,axiom,
    ! [A: array,N: $int] :
      ( distinct(A,N)
    <=> ! [I: $int,J: $int] :
          ( ( ( read(A,I) = read(A,J) )
           => ( I = J ) )
         <= ( $greatereq(J,0)
            & $greatereq(I,0)
            & $greater(N,J)
            & $greater(N,I) ) ) ) ).

tff(ext,axiom,
    ! [A: array,B: array] :
      ( ! [I: $int] : ( read(A,I) = read(B,I) )
     => ( A = B ) ) ).

tff(inRange,axiom,
    ! [A: array,R: $int,N: $int] :
      ( inRange(A,R,N)
    <=> ! [I: $int] :
          ( ( $greatereq(R,read(A,I))
            & $greatereq(read(A,I),0) )
         <= ( $greater(N,I)
            & $greatereq(I,0) ) ) ) ).

tff(ax2,axiom,
    ! [A: array,I: $int,J: $int,V: $int] :
      ( ( read(write(A,I,V),J) = read(A,J) )
      | ( I = J ) ) ).

tff(ax1,axiom,
    ! [A: array,I: $int,V: $int] : ( read(write(A,I,V),I) = V ) ).

tff(a,axiom,
    ! [A: array,N: $int,W: $int] :
      ( ( max(A,N) = W )
     <= ( ! [I: $int] :
            ( $lesseq(read(A,I),W)
           <= ( $greatereq(I,0)
              & $greater(N,I) ) )
        & ? [I: $int] :
            ( $greatereq(I,0)
            & ( read(A,I) = W )
            & $greater(N,I) ) ) ) ).

tff(c3,conjecture,
    ~ ! [A: array,N: $int] : ( read(rev(A,$sum(N,1)),0) = read(A,N) ) ).

