tff(array_type,type,
    array: $tType ).

tff(read_type,type,
    read: ( array * $int ) > $int ).

tff(write_type,type,
    write: ( array * $int * $int ) > array ).

tff(init_type,type,
    init: $int > array ).

tff(max,type,
    max: ( array * $int ) > $int ).

tff(sorted_type,type,
    sorted: ( array * $int ) > $o ).

tff(inRange_type,type,
    inRange: ( array * $int * $int ) > $o ).

tff(distinct_type,type,
    distinct: ( array * $int ) > $o ).

tff(rev_n,type,
    rev: ( array * $int ) > array ).

tff(distinct,axiom,
    ! [A: array,N: $int] :
      ( distinct(A,N)
    <=> ! [I: $int,J: $int] :
          ( ( ( read(A,I) = read(A,J) )
           => ( I = J ) )
         <= ( $greater(N,J)
            & $greatereq(J,0)
            & $greatereq(I,0)
            & $greater(N,I) ) ) ) ).

tff(ax1,axiom,
    ! [A: array,I: $int,V: $int] : ( read(write(A,I,V),I) = V ) ).

tff(inRange,axiom,
    ! [A: array,R: $int,N: $int] :
      ( ! [I: $int] :
          ( ( $greatereq(I,0)
            & $greater(N,I) )
         => ( $greatereq(R,read(A,I))
            & $greatereq(read(A,I),0) ) )
    <=> inRange(A,R,N) ) ).

tff(ax2,axiom,
    ! [A: array,I: $int,J: $int,V: $int] :
      ( ( I = J )
      | ( read(write(A,I,V),J) = read(A,J) ) ) ).

tff(c5,conjecture,
    ~ ! [M: $int] :
      ? [N: $int] : ~ sorted(rev(init(N),M),M) ).

tff(ext,axiom,
    ! [A: array,B: array] :
      ( ( A = B )
     <= ! [I: $int] : ( read(A,I) = read(B,I) ) ) ).

tff(a,axiom,
    ! [A: array,N: $int,W: $int] :
      ( ( ! [I: $int] :
            ( ( $greatereq(I,0)
              & $greater(N,I) )
           => $lesseq(read(A,I),W) )
        & ? [I: $int] :
            ( ( read(A,I) = W )
            & $greatereq(I,0)
            & $greater(N,I) ) )
     => ( max(A,N) = W ) ) ).

tff(ax3,axiom,
    ! [V: $int,I: $int] : ( read(init(V),I) = V ) ).

tff(sorted1,axiom,
    ! [A: array,N: $int] :
      ( ! [I: $int,J: $int] :
          ( ( $lesseq(0,I)
            & $less(I,N)
            & $less(I,J)
            & $less(J,N) )
         => $lesseq(read(A,I),read(A,J)) )
    <=> sorted(A,N) ) ).

tff(rev_n1_proper,axiom,
    ! [A: array,B: array,N: $int] :
      ( ! [I: $int] :
          ( ( ( read(B,I) = read(A,I) )
            & ( $greater(0,I)
              | $greatereq(I,N) ) )
          | ( $greatereq(I,0)
            & ( read(B,I) = read(A,$difference(N,$sum(I,1))) )
            & $greater(N,I) ) )
     => ( rev(A,N) = B ) ) ).

