tff(array_type,type,
    array: $tType ).

tff(read_type,type,
    read: ( array * $int ) > $int ).

tff(write_type,type,
    write: ( array * $int * $int ) > array ).

tff(init_type,type,
    init: $int > array ).

tff(max,type,
    max: ( array * $int ) > $int ).

tff(sorted_type,type,
    sorted: ( array * $int ) > $o ).

tff(inRange_type,type,
    inRange: ( array * $int * $int ) > $o ).

tff(distinct_type,type,
    distinct: ( array * $int ) > $o ).

tff(rev_n,type,
    rev: ( array * $int ) > array ).

tff(sorted1,axiom,
    ! [A: array,N: $int] :
      ( ! [I: $int,J: $int] :
          ( $lesseq(read(A,I),read(A,J))
         <= ( $less(J,N)
            & $less(I,J)
            & $less(I,N)
            & $lesseq(0,I) ) )
    <=> sorted(A,N) ) ).

tff(inRange,axiom,
    ! [A: array,R: $int,N: $int] :
      ( ! [I: $int] :
          ( ( $greatereq(I,0)
            & $greater(N,I) )
         => ( $greatereq(read(A,I),0)
            & $greatereq(R,read(A,I)) ) )
    <=> inRange(A,R,N) ) ).

tff(distinct,axiom,
    ! [A: array,N: $int] :
      ( ! [I: $int,J: $int] :
          ( ( $greater(N,I)
            & $greatereq(J,0)
            & $greatereq(I,0)
            & $greater(N,J) )
         => ( ( read(A,I) = read(A,J) )
           => ( I = J ) ) )
    <=> distinct(A,N) ) ).

tff(ax2,axiom,
    ! [A: array,I: $int,J: $int,V: $int] :
      ( ( read(write(A,I,V),J) = read(A,J) )
      | ( I = J ) ) ).

tff(ax1,axiom,
    ! [A: array,I: $int,V: $int] : ( read(write(A,I,V),I) = V ) ).

tff(ax3,axiom,
    ! [V: $int,I: $int] : ( read(init(V),I) = V ) ).

tff(ext,axiom,
    ! [A: array,B: array] :
      ( ( A = B )
     <= ! [I: $int] : ( read(A,I) = read(B,I) ) ) ).

tff(c6,conjecture,
    ~ ! [A: array,N: $int] :
        ( ( $greater(N,0)
          & sorted(A,N) )
       => distinct(A,N) ) ).

tff(rev_n1_proper,axiom,
    ! [A: array,B: array,N: $int] :
      ( ( rev(A,N) = B )
     <= ! [I: $int] :
          ( ( ( read(B,I) = read(A,I) )
            & ( $greatereq(I,N)
              | $greater(0,I) ) )
          | ( $greatereq(I,0)
            & ( read(B,I) = read(A,$difference(N,$sum(I,1))) )
            & $greater(N,I) ) ) ) ).

tff(a,axiom,
    ! [A: array,N: $int,W: $int] :
      ( ( max(A,N) = W )
     <= ( ? [I: $int] :
            ( $greatereq(I,0)
            & ( read(A,I) = W )
            & $greater(N,I) )
        & ! [I: $int] :
            ( $lesseq(read(A,I),W)
           <= ( $greater(N,I)
              & $greatereq(I,0) ) ) ) ) ).

