tff(list_type,type,
    list: $tType ).

tff(nil_type,type,
    nil: list ).

tff(cons_type,type,
    cons: ( $int * list ) > list ).

tff(head_type,type,
    head: list > $int ).

tff(tail_type,type,
    tail: list > list ).

tff(in,type,
    in: ( $int * list ) > $o ).

tff(inRange_type,type,
    inRange: ( $int * list ) > $o ).

tff(t,type,
    length: list > $int ).

tff(t_2,type,
    count: ( $int * list ) > $int ).

tff(t_5,type,
    append: ( list * list ) > list ).

tff(l2,axiom,
    ! [K: $int,L: list] : ( tail(cons(K,L)) = L ) ).

tff(l_1,axiom,
    ! [H: $int,T: list] : ( length(cons(H,T)) = $sum(1,length(T)) ) ).

tff(l_7,axiom,
    ! [I: $int,K: list,L: list] : ( append(cons(I,K),L) = cons(I,append(K,L)) ) ).

tff(in_conv,axiom,
    ! [X: $int,L: list] :
      ( in(X,L)
    <=> ( ? [H: $int,T: list] :
            ( ( X = H )
            & ( L = cons(H,T) ) )
        | ? [H: $int,T: list] :
            ( ( L = cons(H,T) )
            & in(X,T) ) ) ) ).

tff(a_4,axiom,
    ! [K: $int,H: $int,T: list,N: $int] :
      ( ( K = H )
     => ( count(K,cons(H,T)) = $sum(count(K,T),1) ) ) ).

tff(l,axiom,
    length(nil) = 0 ).

tff(a_3,axiom,
    ! [K: $int,H: $int,T: list,N: $int] :
      ( ( K != H )
     => ( count(K,cons(H,T)) = count(K,T) ) ) ).

tff(l_6,axiom,
    ! [L: list] : ( append(nil,L) = L ) ).

tff(l4,axiom,
    ! [K: $int,L: list] : ( cons(K,L) != nil ) ).

tff(a,axiom,
    ! [K: $int] : ( count(K,nil) = 0 ) ).

tff(c,conjecture,
    ~ ! [M: $int,N: $int,K: list,L: list,L1: list] :
        ( ( in(N,L)
          & ~ in(M,K)
          & ( L1 = append(L,cons(M,K)) ) )
       => ( count(N,L1) = count(N,L) ) ) ).

tff(l1,axiom,
    ! [K: $int,L: list] : ( head(cons(K,L)) = K ) ).

tff(l3,axiom,
    ! [L: list] :
      ( ( L = cons(head(L),tail(L)) )
      | ( L = nil ) ) ).

tff(inRange,axiom,
    ! [N: $int,L: list] :
      ( inRange(N,L)
    <=> ( ( L = nil )
        | ? [K: $int,T: list] :
            ( inRange(N,T)
            & $less(K,N)
            & $lesseq(0,K)
            & ( L = cons(K,T) ) ) ) ) ).

tff(a_8,axiom,
    ! [N: $int,L: list] :
      ( in(N,L)
    <=> $greater(count(N,L),0) ) ).

