tff(summation_type,type,
    summation: $int > $int ).

tff(ub_type,type,
    ub: ( $int * $int * $int ) > $o ).

tff(model_max_type,type,
    model_max: ( $int * $int * $int ) > $o ).

tff(model_ub_type,type,
    model_ub: ( $int * $int * $int ) > $o ).

tff(minsol_model_max_type,type,
    minsol_model_max: ( $int * $int * $int ) > $o ).

tff(minsol_model_ub_type,type,
    minsol_model_ub: ( $int * $int * $int ) > $o ).

tff(max_type,type,
    max: ( $int * $int ) > $int ).

tff(minsol_model_max,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( minsol_model_max(X,Y,N)
    <=> ( ! [Z: $int] :
            ( $lesseq(N,Z)
           <= model_max(X,Y,Z) )
        & model_max(X,Y,N) ) ) ).

tff(max_1,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = X )
      | ~ $lesseq(Y,X) ) ).

tff(summation_monotone,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(X,Y)
    <=> $lesseq(summation(X),summation(Y)) ) ).

tff(max_is_ub_1,conjecture,
    ! [X: $int,Y: $int,Z: $int] :
      ( minsol_model_max(X,Y,Z)
    <=> minsol_model_ub(X,Y,Z) ) ).

tff(ub,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ub(X,Y,Z)
    <=> ( $lesseq(Y,Z)
        & $lesseq(X,Z) ) ) ).

tff(model_max_1,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( model_max(X,Y,N)
    <=> ( N = max(X,Y) ) ) ).

tff(minsol_model_ub,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( ( model_ub(X,Y,N)
        & ! [Z: $int] :
            ( model_ub(X,Y,Z)
           => $lesseq(N,Z) ) )
    <=> minsol_model_ub(X,Y,N) ) ).

tff(max_2,axiom,
    ! [X: $int,Y: $int] :
      ( ~ $lesseq(X,Y)
      | ( max(X,Y) = Y ) ) ).

tff(model_ub_1,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( model_ub(X,Y,N)
    <=> ub(X,Y,N) ) ).

