tff(c_type,type,
    c: $int ).

tff(summation_type,type,
    summation: $int > $int ).

tff(ub_type,type,
    ub: ( $int * $int * $int ) > $o ).

tff(model_max_type,type,
    model_max: ( $int * $int * $int ) > $o ).

tff(model_ub_type,type,
    model_ub: ( $int * $int * $int ) > $o ).

tff(minsol_model_max_type,type,
    minsol_model_max: ( $int * $int * $int ) > $o ).

tff(minsol_model_ub_type,type,
    minsol_model_ub: ( $int * $int * $int ) > $o ).

tff(max_type,type,
    max: ( $int * $int ) > $int ).

tff(minsol_model_ub,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( minsol_model_ub(X,Y,N)
    <=> ( model_ub(X,Y,N)
        & ! [Z: $int] :
            ( model_ub(X,Y,Z)
           => $lesseq(N,Z) ) ) ) ).

tff(max_is_ub_1,conjecture,
    ! [X: $int,Y: $int,Z: $int] :
      ( minsol_model_ub(X,Y,Z)
    <=> minsol_model_max(X,Y,Z) ) ).

tff(summation_monotone,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(X,Y)
    <=> $lesseq(summation(X),summation(Y)) ) ).

tff(max_2,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = Y )
      | ~ $lesseq(X,Y) ) ).

tff(model_max_5,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( $lesseq($sum(c,summation(max(X,Y))),N)
    <=> model_max(X,Y,N) ) ).

tff(minsol_model_max,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( ( ! [Z: $int] :
            ( $lesseq(N,Z)
           <= model_max(X,Y,Z) )
        & model_max(X,Y,N) )
    <=> minsol_model_max(X,Y,N) ) ).

tff(model_ub_5,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( model_ub(X,Y,N)
    <=> ? [Z: $int] :
          ( $lesseq($sum(c,summation(Z)),N)
          & ub(X,Y,Z) ) ) ).

tff(ub,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(X,Z)
        & $lesseq(Y,Z) )
    <=> ub(X,Y,Z) ) ).

tff(max_1,axiom,
    ! [X: $int,Y: $int] :
      ( ~ $lesseq(Y,X)
      | ( max(X,Y) = X ) ) ).

