tff(queens_q_type,type,
    queens_q: $o ).

tff(queens_p_type,type,
    queens_p: $o ).

tff(q_type,type,
    q: $int > $int ).

tff(p_type,type,
    p: $int > $int ).

tff(n_type,type,
    n: $int ).

tff(perm_type,type,
    perm: $int > $int ).

tff(permutation_another_one,axiom,
    ! [J: $int,I: $int] : ( $difference(I,J) = $difference(perm(J),perm(I)) ) ).

tff(queens_p,axiom,
    ( ! [I: $int,J: $int] :
        ( ( $lesseq($sum(1,I),J)
          & $lesseq(J,n)
          & $lesseq(I,n)
          & $lesseq(1,I) )
       => ( ( $sum(p(I),I) != $sum(p(J),J) )
          & ( $difference(p(I),I) != $difference(p(J),J) )
          & ( p(I) != p(J) ) ) )
   <= queens_p ) ).

tff(permutation,axiom,
    ! [I: $int] : ( perm(I) = $difference($sum(1,n),I) ) ).

tff(queens_sym,conjecture,
    ( queens_q
   <= ( ! [I: $int] : ( q(I) = p(perm(I)) )
      & queens_p ) ) ).

tff(queens_q,axiom,
    ( ! [I: $int,J: $int] :
        ( ( ( q(I) != q(J) )
          & ( $difference(q(I),I) != $difference(q(J),J) )
          & ( $sum(q(I),I) != $sum(q(J),J) ) )
       <= ( $lesseq(I,n)
          & ( $lesseq($sum(1,perm(J)),perm(I))
          <=> $lesseq($sum(1,I),J) )
          & $lesseq(J,n)
          & $lesseq($sum(1,I),J)
          & $lesseq(1,I) ) )
   => queens_q ) ).

tff(permutation_range,axiom,
    ! [I: $int] :
      ( ( $lesseq(I,n)
        & $lesseq(1,I) )
     => ( $lesseq(perm(I),n)
        & $lesseq(1,perm(I)) ) ) ).

