tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(set1,type,
    set2: ( map_int_int * $int * $int ) > map_int_int ).

tff(t2tb,type,
    t2tb: map_int_int > uni ).

tff(tb2t,type,
    tb2t: uni > map_int_int ).

tff(t2tb1,type,
    t2tb1: $int > uni ).

tff(tb2t1,type,
    tb2t1: uni > $int ).

tff(const3,type,
    const: ( ty * ty * uni ) > uni ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(a,type,
    a1: $int ).

tff(separation,type,
    separation1: $int > $o ).

tff(inv,type,
    inv1: map_int_int > $o ).

tff(inv_l2,type,
    inv_l21: ( map_int_int * $int * $int ) > $o ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(bridgeL1,axiom,
    ! [I: $int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(inv_l2_def,axiom,
    ! [Mem: map_int_int,Fp: $int,L4: $int] :
      ( ( $lesseq(2,tb2t1(get(int,int,t2tb(Mem),t2tb1($difference(Fp,16)))))
        & inv1(Mem)
        & ( L4 = $difference(tb2t1(get(int,int,t2tb(Mem),t2tb1($difference(Fp,16)))),2) )
        & $lesseq(tb2t1(get(int,int,t2tb(Mem),t2tb1($difference(Fp,16)))),11) )
    <=> inv_l21(Mem,Fp,L4) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = false1 )
      | ( U = true1 ) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(select_neq1,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort1(A,A1)
     => ( ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) )
       <= sort1(A,A2) ) ) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(t2tb_sort,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb(X)) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(bridgeL,axiom,
    ! [I: map_int_int] : ( tb2t(t2tb(I)) = I ) ).

tff(select_neq,axiom,
    ! [M: map_int_int,A1: $int,A2: $int,B: $int] :
      ( ( A1 != A2 )
     => ( tb2t1(get(int,int,t2tb(set2(M,A1,B)),t2tb1(A2))) = tb2t1(get(int,int,t2tb(M),t2tb1(A2))) ) ) ).

tff(t2tb_sort1,axiom,
    ! [X: $int] : sort1(int,t2tb1(X)) ).

tff(select_eq1,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort1(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(wP_parameter_path_init_l2,conjecture,
    ! [Fp: $int,Mem: map_int_int] :
      ( ( inv1(Mem)
        & separation1(Fp) )
     => ! [L4: $int] :
          ( ! [L7: $int] :
              ( ! [R3: $int] :
                  ( ( R3 = 2 )
                 => ! [Mem1: map_int_int] :
                      ( ( Mem1 = set2(Mem,$difference(Fp,16),R3) )
                     => inv_l21(Mem1,Fp,L4) ) )
             <= ( L7 = 0 ) )
         <= ( L4 = 0 ) ) ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(ref(A),U)
     => ( U = mk_ref(A,contents(A,U)) ) ) ).

tff(separation_def,axiom,
    ! [Fp: $int] :
      ( $less($sum(a1,10),$difference(Fp,24))
    <=> separation1(Fp) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(select_eq,axiom,
    ! [M: map_int_int,A1: $int,A2: $int,B: $int] :
      ( ( tb2t1(get(int,int,t2tb(set2(M,A1,B)),t2tb1(A2))) = B )
     <= ( A1 = A2 ) ) ).

tff(inv_def,axiom,
    ! [Mem: map_int_int] :
      ( ( ( tb2t1(get(int,int,t2tb(Mem),t2tb1(a1))) = 0 )
        & ! [K: $int] :
            ( ( $lesseq(1,K)
              & $lesseq(K,10) )
           => $less(0,tb2t1(get(int,int,t2tb(Mem),t2tb1($sum(a1,K))))) ) )
    <=> inv1(Mem) ) ).

