tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(option,type,
    option: ty > ty ).

tff(none,type,
    none: ty > uni ).

tff(some,type,
    some: ( ty * uni ) > uni ).

tff(match_option,type,
    match_option: ( ty * ty * uni * uni * uni ) > uni ).

tff(some_proj_1,type,
    some_proj_1: ( ty * uni ) > uni ).

tff(fib,type,
    fib: $int > $int ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const,type,
    const: ( ty * ty * uni ) > uni ).

tff(map_int_lpoption_intrp,type,
    map_int_lpoption_intrp: $tType ).

tff(inv,type,
    inv: map_int_lpoption_intrp > $o ).

tff(t2tb,type,
    t2tb: map_int_lpoption_intrp > uni ).

tff(tb2t,type,
    tb2t: uni > map_int_lpoption_intrp ).

tff(option_int,type,
    option_int: $tType ).

tff(t2tb1,type,
    t2tb1: option_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > option_int ).

tff(t2tb2,type,
    t2tb2: $int > uni ).

tff(tb2t2,type,
    tb2t2: uni > $int ).

tff(const1,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( ( get(B,A,const(B,A,B1),A1) = B1 )
     <= sort(B,B1) ) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( sort(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(const_sort,axiom,
    ! [A: ty,B: ty,X: uni] : sort(map(A,B),const(B,A,X)) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(true_False,axiom,
    true != false ).

tff(get_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort(B,get(B,A,X,X1)) ).

tff(t2tb_sort,axiom,
    ! [X: map_int_lpoption_intrp] : sort(map(int,option(int)),t2tb(X)) ).

tff(match_option_sort,axiom,
    ! [A: ty,A1: ty,X: uni,X1: uni,X2: uni] : sort(A1,match_option(A1,A,X,X1,X2)) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) )
     <= sort(B,B1) ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = false )
      | ( U = true ) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(match_option_None,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni] :
      ( ( match_option(A1,A,none(A),Z,Z1) = Z )
     <= sort(A1,Z) ) ).

tff(fib1,axiom,
    fib(1) = 1 ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_bool(A,true,Z,Z1) = Z ) ) ).

tff(none_Some,axiom,
    ! [A: ty,V: uni] : ( none(A) != some(A,V) ) ).

tff(inv_def,axiom,
    ! [T: map_int_lpoption_intrp] :
      ( ! [X: $int,Y: $int] :
          ( ( Y = fib(X) )
         <= ( tb2t1(get(option(int),int,t2tb(T),t2tb2(X))) = tb2t1(some(int,t2tb2(Y))) ) )
    <=> inv(T) ) ).

tff(t2tb_sort1,axiom,
    ! [X: option_int] : sort(option(int),t2tb1(X)) ).

tff(fib0,axiom,
    fib(0) = 0 ).

tff(option_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( ( U = some(A,some_proj_1(A,U)) )
        | ( U = none(A) ) )
     <= sort(option(A),U) ) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort(ref(A),U) ) ).

tff(some_proj_1_sort,axiom,
    ! [A: ty,X: uni] : sort(A,some_proj_1(A,X)) ).

tff(bridgeL1,axiom,
    ! [I: option_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(wP_parameter_memo_fibo,conjecture,
    ! [N: $int,Table: map_int_lpoption_intrp] :
      ( ( inv(Table)
        & $lesseq(0,N) )
     => ( ( tb2t1(get(option(int),int,t2tb(Table),t2tb2(N))) = tb2t1(none(int)) )
       => ( ! [Table1: map_int_lpoption_intrp] :
              ( ! [Table2: map_int_lpoption_intrp] :
                  ( ( ( fib(N) = fib(N) )
                    & inv(Table2) )
                 <= ( Table2 = tb2t(set(option(int),int,t2tb(Table1),t2tb2(N),some(int,t2tb2(fib(N))))) ) )
             <= inv(Table1) )
         <= ( $lesseq(0,N)
            & inv(Table) ) ) ) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort(A,A1)
     => ( sort(A,A2)
       => ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) ) ) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(none_sort,axiom,
    ! [A: ty] : sort(option(A),none(A)) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(bridgeL2,axiom,
    ! [I: $int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(fibn,axiom,
    ! [N: $int] :
      ( $lesseq(2,N)
     => ( fib(N) = $sum(fib($difference(N,1)),fib($difference(N,2))) ) ) ).

tff(some_sort,axiom,
    ! [A: ty,X: uni] : sort(option(A),some(A,X)) ).

tff(match_option_Some,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni,U: uni] :
      ( ( match_option(A1,A,some(A,U),Z,Z1) = Z1 )
     <= sort(A1,Z1) ) ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

tff(bridgeL,axiom,
    ! [I: map_int_lpoption_intrp] : ( tb2t(t2tb(I)) = I ) ).

tff(set_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort(map(A,B),set(B,A,X,X1,X2)) ).

tff(t2tb_sort2,axiom,
    ! [X: $int] : sort(int,t2tb2(X)) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) )
     <= $lesseq(X,Y) ) ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(some_proj_1_def,axiom,
    ! [A: ty,U: uni] :
      ( sort(A,U)
     => ( some_proj_1(A,some(A,U)) = U ) ) ).

