tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(array_int,type,
    array_int: $tType ).

tff(appear_twice,type,
    appear_twice1: ( array_int * $int * $int ) > $o ).

tff(t2tb1,type,
    t2tb1: array_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > array_int ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(t2tb2,type,
    t2tb2: map_int_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > map_int_int ).

tff(t2tb3,type,
    t2tb3: bool1 > uni ).

tff(tb2t3,type,
    tb2t3: uni > bool1 ).

tff(map_int_bool,type,
    map_int_bool: $tType ).

tff(t2tb4,type,
    t2tb4: map_int_bool > uni ).

tff(tb2t4,type,
    tb2t4: uni > map_int_bool ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(t2tb_sort4,axiom,
    ! [X: map_int_bool] : sort1(map(int,bool),t2tb4(X)) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(t2tb_sort3,axiom,
    ! [X: bool1] : sort1(bool,t2tb3(X)) ).

tff(bridgeL1,axiom,
    ! [I: array_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(wP_parameter_two_equal_elements,conjecture,
    ! [A: $int,A1: map_int_int,N: $int] :
      ( ( $lesseq(0,A)
        & $lesseq(2,N)
        & ! [I: $int] :
            ( ( $lesseq(0,tb2t(get(int,int,t2tb2(A1),t2tb(I))))
              & $less(tb2t(get(int,int,t2tb2(A1),t2tb(I))),N) )
           <= ( $lesseq(0,I)
              & $less(I,A) ) )
        & ? [V1: $int] :
            ( ? [V2: $int] :
                ( ( V2 != V1 )
                & appear_twice1(tb2t1(mk_array1(int,A,t2tb2(A1))),V2,$sum(N,2)) )
            & appear_twice1(tb2t1(mk_array1(int,A,t2tb2(A1))),V1,$sum(N,2)) )
        & ( A = $sum(N,2) ) )
     => ( $lesseq(0,N)
       => ( $lesseq(0,N)
         => ( $lesseq(0,$sum(N,1))
           => ! [V2: $int,V1: $int,Deja_vu: map_int_bool] :
                ( ( ( ( V1 = $uminus(1) )
                   => ( V2 = $uminus(1) ) )
                  & ! [V: $int] :
                      ( ( ( ( tb2t3(get(bool,int,t2tb4(Deja_vu),t2tb(V))) != true1 )
                          & ! [J: $int] :
                              ( ( $less(J,$sum($sum(N,1),1))
                                & $lesseq(0,J) )
                             => ( tb2t(get(int,int,t2tb2(A1),t2tb(J))) != V ) ) )
                        | ( ( tb2t3(get(bool,int,t2tb4(Deja_vu),t2tb(V))) = true1 )
                          & ? [J: $int] :
                              ( $lesseq(0,J)
                              & $less(J,$sum($sum(N,1),1))
                              & ( tb2t(get(int,int,t2tb2(A1),t2tb(J))) = V ) ) ) )
                     <= ( $lesseq(0,V)
                        & $less(V,N) ) )
                  & ( ! [V: $int] :
                        ( ( $lesseq(0,V)
                          & $less(V,N) )
                       => ~ appear_twice1(tb2t1(mk_array1(int,A,t2tb2(A1))),V,$sum($sum(N,1),1)) )
                   <= ( V1 = $uminus(1) ) )
                  & ( ! [V: $int] :
                        ( ( $less(V,N)
                          & $lesseq(0,V) )
                       => ( ~ appear_twice1(tb2t1(mk_array1(int,A,t2tb2(A1))),V,$sum($sum(N,1),1))
                         <= ( V != V1 ) ) )
                   <= ( V2 = $uminus(1) ) )
                  & ( ( V2 != $uminus(1) )
                   => ( ( V2 != V1 )
                      & appear_twice1(tb2t1(mk_array1(int,A,t2tb2(A1))),V2,$sum($sum(N,1),1)) ) )
                  & ( ( V1 != $uminus(1) )
                   => appear_twice1(tb2t1(mk_array1(int,A,t2tb2(A1))),V1,$sum($sum(N,1),1)) ) )
               => appear_twice1(tb2t1(mk_array1(int,A,t2tb2(A1))),V1,$sum(N,2)) ) ) ) ) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort1(A,A1)
     => ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) ) ) ) ).

tff(bridgeR3,axiom,
    ! [J: uni] :
      ( ( t2tb3(tb2t3(J)) = J )
     <= sort1(bool,J) ) ).

tff(appear_twice_def,axiom,
    ! [A: array_int,V: $int,U: $int] :
      ( ? [I: $int] :
          ( $less(I,U)
          & ? [J: $int] :
              ( $lesseq(0,J)
              & $less(J,U)
              & ( tb2t(get2(int,t2tb1(A),J)) = V )
              & ( J != I ) )
          & ( tb2t(get2(int,t2tb1(A),I)) = V )
          & $lesseq(0,I) )
    <=> appear_twice1(A,V,U) ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) ) ) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort1(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(bridgeL2,axiom,
    ! [I: map_int_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(bridgeL4,axiom,
    ! [I: map_int_bool] : ( tb2t4(t2tb4(I)) = I ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(t2tb_sort2,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb2(X)) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(bridgeR4,axiom,
    ! [J: uni] :
      ( sort1(map(int,bool),J)
     => ( t2tb4(tb2t4(J)) = J ) ) ).

tff(bridgeL3,axiom,
    ! [I: bool1] : ( tb2t3(t2tb3(I)) = I ) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort1(A,U) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(t2tb_sort1,axiom,
    ! [X: array_int] : sort1(array(int),t2tb1(X)) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort1(ref(A),U) ) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

