tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(elt6,type,
    elt6: $tType ).

tff(elt7,type,
    elt7: ty ).

tff(le3,type,
    le4: ( elt6 * elt6 ) > $o ).

tff(array_elt3,type,
    array_elt3: $tType ).

tff(sorted_sub3,type,
    sorted_sub4: ( array_elt3 * $int * $int ) > $o ).

tff(t2tb10,type,
    t2tb10: array_elt3 > uni ).

tff(tb2t10,type,
    tb2t10: uni > array_elt3 ).

tff(t2tb11,type,
    t2tb11: elt6 > uni ).

tff(tb2t11,type,
    tb2t11: uni > elt6 ).

tff(sorted3,type,
    sorted4: array_elt3 > $o ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(occ,type,
    occ1: ( ty * uni * uni * $int * $int ) > $int ).

tff(permut,type,
    permut2: ( ty * uni * uni * $int * $int ) > $o ).

tff(map_eq_sub,type,
    map_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq_sub,type,
    array_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq,type,
    array_eq: ( ty * uni * uni ) > $o ).

tff(exchange,type,
    exchange2: ( ty * uni * uni * $int * $int * $int * $int ) > $o ).

tff(exchange1,type,
    exchange3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut1,type,
    permut3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_sub,type,
    permut_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_all,type,
    permut_all: ( ty * uni * uni ) > $o ).

tff(abs,type,
    abs: $int > $int ).

tff(div,type,
    div: ( $int * $int ) > $int ).

tff(mod,type,
    mod: ( $int * $int ) > $int ).

tff(min,type,
    min: ( $int * $int ) > $int ).

tff(max,type,
    max: ( $int * $int ) > $int ).

tff(map_int_elt3,type,
    map_int_elt3: $tType ).

tff(t2tb12,type,
    t2tb12: map_int_elt3 > uni ).

tff(tb2t12,type,
    tb2t12: uni > map_int_elt3 ).

tff(occ_exists,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort1(A,V)
     => ( ? [I: $int] :
            ( ( get(A,int,M,t2tb(I)) = V )
            & $less(I,U)
            & $lesseq(L,I) )
       <= $less(0,occ1(A,V,M,L,U)) ) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(bridgeR11,axiom,
    ! [J: uni] :
      ( sort1(elt7,J)
     => ( t2tb11(tb2t11(J)) = J ) ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $less(0,X)
        & $lesseq(0,Z)
        & $lesseq(0,Y) )
     => ( mod($sum($product(X,Y),Z),X) = mod(Z,X) ) ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(mod(X,Y),0)
     <= ( $lesseq(X,0)
        & ( Y != 0 ) ) ) ).

tff(mk_ref_sort4,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(permut_exists,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int] :
      ( ( ( $lesseq(L,I)
          & $less(I,U) )
       => ? [J: $int] :
            ( $less(J,U)
            & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
            & $lesseq(L,J) ) )
     <= permut2(A,A1,A2,L,U) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,Y)
        & $lesseq($uminus(Y),X) )
    <=> $lesseq(abs(X),Y) ) ).

tff(occ_append,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,Mid: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = $sum(occ1(A,V,M,L,Mid),occ1(A,V,M,Mid,U)) )
     <= ( $lesseq(L,Mid)
        & $lesseq(Mid,U) ) ) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(ref_inversion4,axiom,
    ! [A: ty,U: uni] :
      ( sort1(ref(A),U)
     => ( U = mk_ref(A,contents(A,U)) ) ) ).

tff(max_x,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = X )
     <= $lesseq(Y,X) ) ).

tff(max_is_ge,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(Y,max(X,Y))
      & $lesseq(X,max(X,Y)) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => ( X = $sum($product(Y,div(X,Y)),mod(X,Y)) ) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(permut_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( permut3(A,A1,A2,L,U)
    <=> ( $lesseq(0,L)
        & $lesseq(L,length1(A,A1))
        & $lesseq(U,length1(A,A1))
        & permut2(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(0,U)
        & ( length1(A,A1) = length1(A,A2) ) ) ) ).

tff(bridgeL11,axiom,
    ! [I: elt6] : ( tb2t11(t2tb11(I)) = I ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(0,div(X,Y))
     <= ( $less(0,Y)
        & $lesseq(0,X) ) ) ).

tff(bridgeL10,axiom,
    ! [I: array_elt3] : ( tb2t10(t2tb10(I)) = I ) ).

tff(occ_right_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $less(L,U)
     => ( ( get(A,int,M,t2tb($difference(U,1))) = V )
       => ( occ1(A,V,M,L,U) = $sum(1,occ1(A,V,M,L,$difference(U,1))) ) ) ) ).

tff(contents_sort4,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(total4,axiom,
    ! [X: elt6,Y: elt6] :
      ( le4(X,Y)
      | le4(Y,X) ) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & ( Y != 0 ) )
     => $lesseq(0,mod(X,Y)) ) ).

tff(sorted_sub_def3,axiom,
    ! [A: array_elt3,L: $int,U: $int] :
      ( ! [I1: $int,I2: $int] :
          ( ( $less(I2,U)
            & $lesseq(I1,I2)
            & $lesseq(L,I1) )
         => le4(tb2t11(get2(elt7,t2tb10(A),I1)),tb2t11(get2(elt7,t2tb10(A),I2))) )
    <=> sorted_sub4(A,L,U) ) ).

tff(exchange_set,axiom,
    ! [A: ty,A1: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( ( $lesseq(L,J)
          & $less(J,U) )
       => exchange2(A,A1,set(A,int,set(A,int,A1,t2tb(I),get(A,int,A1,t2tb(J))),t2tb(J),get(A,int,A1,t2tb(I))),L,U,I,J) )
     <= ( $lesseq(L,I)
        & $less(I,U) ) ) ).

tff(permut_all_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( ( length1(A,A1) = length1(A,A2) )
        & permut2(A,elts(A,A1),elts(A,A2),0,length1(A,A1)) )
    <=> permut_all(A,A1,A2) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div(X,1) = X ) ).

tff(min_y,axiom,
    ! [X: $int,Y: $int] :
      ( ( min(X,Y) = Y )
     <= $lesseq(Y,X) ) ).

tff(t2tb_sort15,axiom,
    ! [X: map_int_elt3] : sort1(map(int,elt7),t2tb12(X)) ).

tff(permut_def,axiom,
    ! [A: ty,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( permut2(A,M1,M2,L,U)
       <= ! [V: uni] :
            ( sort1(A,V)
           => ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) ) )
      & ( permut2(A,M1,M2,L,U)
       => ! [V: uni] : ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) ) ) ).

tff(max_y,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = Y )
     <= $lesseq(X,Y) ) ).

tff(match_bool_sort4,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(sorted_def3,axiom,
    ! [A: array_elt3] :
      ( sorted4(A)
    <=> ! [I1: $int,I2: $int] :
          ( le4(tb2t11(get2(elt7,t2tb10(A),I1)),tb2t11(get2(elt7,t2tb10(A),I2)))
         <= ( $lesseq(I1,I2)
            & $less(I2,length1(elt7,t2tb10(A)))
            & $lesseq(0,I1) ) ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,true1,Z,Z1) = Z )
     <= sort1(A,Z) ) ).

tff(bridgeR10,axiom,
    ! [J: uni] : ( t2tb10(tb2t10(J)) = J ) ).

tff(occ_right_no_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort1(A,V)
     => ( ( ( get(A,int,M,t2tb($difference(U,1))) != V )
         => ( occ1(A,V,M,L,U) = occ1(A,V,M,L,$difference(U,1)) ) )
       <= $less(L,U) ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(array_eq_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( map_eq_sub1(A,elts(A,A1),elts(A,A2),0,length1(A,A1))
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> array_eq(A,A1,A2) ) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( sort1(map(int,A),U1)
     => ( elts(A,mk_array1(A,U,U1)) = U1 ) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(min_is_le,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(min(X,Y),Y)
      & $lesseq(min(X,Y),X) ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(X,Y)
        & $lesseq(0,X) )
     => ( mod(X,Y) = X ) ) ).

tff(refl4,axiom,
    ! [X: elt6] : le4(X,X) ).

tff(min_is_some,axiom,
    ! [X: $int,Y: $int] :
      ( ( min(X,Y) = X )
      | ( min(X,Y) = Y ) ) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & $less(0,Y) )
     => ( $lesseq(0,div(X,Y))
        & $lesseq(div(X,Y),X) ) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(occ_pos,axiom,
    ! [A: ty,M: uni,L: $int,U: $int,I: $int] :
      ( ( $less(I,U)
        & $lesseq(L,I) )
     => $less(0,occ1(A,get(A,int,M,t2tb(I)),M,L,U)) ) ).

tff(set_sort9,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( $lesseq(0,X)
       => ( abs(X) = X ) )
      & ( ~ $lesseq(0,X)
       => ( abs(X) = $uminus(X) ) ) ) ).

tff(occ_neq,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ( occ1(A,V,M,L,U) = 0 )
       <= ! [I: $int] :
            ( ( get(A,int,M,t2tb(I)) != V )
           <= ( $less(I,U)
              & $lesseq(L,I) ) ) )
     <= sort1(A,V) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(exchange_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int,J: $int] :
      ( exchange2(A,A1,A2,L,U,I,J)
    <=> ( $lesseq(L,I)
        & $less(I,U)
        & ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(J)) )
        & ! [K: $int] :
            ( ( $less(K,U)
              & $lesseq(L,K) )
           => ( ( ( get(A,int,A1,t2tb(K)) = get(A,int,A2,t2tb(K)) )
               <= ( K != J ) )
             <= ( K != I ) ) )
        & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
        & $less(J,U)
        & $lesseq(L,J) ) ) ).

tff(permut_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( permut3(A,A1,A2,L,U)
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),U,length1(A,A1))
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),0,L) )
    <=> permut_sub1(A,A1,A2,L,U) ) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( div(X,Y) = 0 )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) )
     <= $lesseq(X,Y) ) ).

tff(t2tb_sort13,axiom,
    ! [X: array_elt3] : sort1(array(elt7),t2tb10(X)) ).

tff(elts_sort4,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(const_sort4,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(exchange_permut_all,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( permut_all(A,A1,A2)
     <= exchange3(A,A1,A2,I,J) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = false1 )
      | ( U = true1 ) ) ).

tff(min_x,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(X,Y)
     => ( min(X,Y) = X ) ) ).

tff(max_is_some,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = Y )
      | ( max(X,Y) = X ) ) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod(X,1) = 0 ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs(X)) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(permut_sub_weakening,axiom,
    ! [A: ty,A1: uni,A2: uni,L1: $int,U1: $int,L2: $int,U2: $int] :
      ( ( ( permut_sub1(A,A1,A2,L2,U2)
         <= ( $lesseq(U1,U2)
            & $lesseq(U2,length1(A,A1)) ) )
       <= ( $lesseq(0,L2)
          & $lesseq(L2,L1) ) )
     <= permut_sub1(A,A1,A2,L1,U1) ) ).

tff(array_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( $lesseq(0,L)
        & $lesseq(L,length1(A,A1))
        & $lesseq(0,U)
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length1(A,A1))
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> array_eq_sub1(A,A1,A2,L,U) ) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(div(X,Y),0)
     <= ( $less(0,Y)
        & $lesseq(X,0) ) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(make_sort4,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(occ_eq,axiom,
    ! [A: ty,V: uni,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) )
     <= ! [I: $int] :
          ( ( $lesseq(L,I)
            & $less(I,U) )
         => ( get(A,int,M1,t2tb(I)) = get(A,int,M2,t2tb(I)) ) ) ) ).

tff(occ_empty,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(U,L)
     => ( occ1(A,V,M,L,U) = 0 ) ) ).

tff(min_sym,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(Y,X)
     => ( min(X,Y) = min(Y,X) ) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => ( $less(mod(X,Y),abs(Y))
        & $less($uminus(abs(Y)),mod(X,Y)) ) ) ).

tff(occ_bounds,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(L,U)
     => ( $lesseq(0,occ1(A,V,M,L,U))
        & $lesseq(occ1(A,V,M,L,U),$difference(U,L)) ) ) ).

tff(trans4,axiom,
    ! [X: elt6,Y: elt6,Z: elt6] :
      ( ( le4(Y,Z)
       => le4(X,Z) )
     <= le4(X,Y) ) ).

tff(get_sort9,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(t2tb_sort12,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(max_sym,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = max(Y,X) )
     <= $lesseq(Y,X) ) ).

tff(wP_parameter_find_run,conjecture,
    ! [A: $int,A1: map_int_elt3,Lo: $int] :
      ( sorted_sub4(tb2t10(mk_array1(elt7,A,t2tb12(A1))),Lo,$sum(Lo,1))
     <= ( $less(Lo,A)
        & $lesseq(0,Lo)
        & $lesseq(0,A) ) ) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => $lesseq(abs($product(div(X,Y),Y)),abs(X)) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) ) )
     <= sort1(A,A1) ) ).

tff(map_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( map_eq_sub1(A,A1,A2,L,U)
    <=> ! [I: $int] :
          ( ( $less(I,U)
            & $lesseq(L,I) )
         => ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(I)) ) ) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( ( ( A1 = A2 )
       => ( get(B,A,set(B,A,M,A1,B1),A2) = B1 ) )
     <= sort1(B,B1) ) ).

tff(exchange_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( ( ( length1(A,A1) = length1(A,A2) )
        & exchange2(A,elts(A,A1),elts(A,A2),0,length1(A,A1),I,J) )
    <=> exchange3(A,A1,A2,I,J) ) ).

tff(bridgeR12,axiom,
    ! [J: uni] :
      ( ( t2tb12(tb2t12(J)) = J )
     <= sort1(map(int,elt7),J) ) ).

tff(exchange_permut_sub,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int,L: $int,U: $int] :
      ( ( ( ( $lesseq(0,L)
           => ( permut_sub1(A,A1,A2,L,U)
             <= $lesseq(U,length1(A,A1)) ) )
         <= ( $lesseq(L,J)
            & $less(J,U) ) )
       <= ( $less(I,U)
          & $lesseq(L,I) ) )
     <= exchange3(A,A1,A2,I,J) ) ).

tff(get_sort8,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(mk_array_sort4,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
        & $lesseq(0,Y)
        & $less(0,X) )
     => ( div($sum($product(X,Y),Z),X) = $sum(Y,div(Z,X)) ) ) ).

tff(set_sort8,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(t2tb_sort14,axiom,
    ! [X: elt6] : sort1(elt7,t2tb11(X)) ).

tff(bridgeL12,axiom,
    ! [I: map_int_elt3] : ( tb2t12(t2tb12(I)) = I ) ).

tff(permut_trans,axiom,
    ! [A: ty,A1: uni,A2: uni,A3: uni,L: $int,U: $int] :
      ( ( permut2(A,A1,A3,L,U)
       <= permut2(A,A2,A3,L,U) )
     <= permut2(A,A1,A2,L,U) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,false1,Z,Z1) = Z1 )
     <= sort1(A,Z1) ) ).

tff(contents_def4,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort1(A,U) ) ).

