tff('Array',type,
    'Array[Int,Int]': $tType ).

tff(select,type,
    'select:(Array[Int,Int]*Int)>Int': ( 'Array[Int,Int]' * $int ) > $int ).

tff(store,type,
    'store:(Array[Int,Int]*Int*Int)>Array[Int,Int]': ( 'Array[Int,Int]' * $int * $int ) > 'Array[Int,Int]' ).

tff(const,type,
    'const:(Int)>Array[Int,Int]': $int > 'Array[Int,Int]' ).

tff(length,type,
    length: 'Array[Int,Int]' > $int ).

tff(div2,type,
    div2: $int > $int ).

tff(sorted,type,
    sorted: ( 'Array[Int,Int]' * $int * $int ) > $o ).

tff(formula_006,axiom,
    ! [A: 'Array[Int,Int]',L: $int,U: $int] :
      ( ! [I: $int,J: $int] :
          ( $lesseq('select:(Array[Int,Int]*Int)>Int'(A,I),'select:(Array[Int,Int]*Int)>Int'(A,J))
         <= ( $less(I,J)
            & $lesseq(J,U)
            & $lesseq(L,I) ) )
    <=> sorted(A,L,U) ) ).

tff(formula_003,axiom,
    ! [I: $int,E: $int] : ( 'select:(Array[Int,Int]*Int)>Int'('const:(Int)>Array[Int,Int]'(E),I) = E ) ).

tff(formula_005,axiom,
    ! [A: 'Array[Int,Int]'] : $greatereq(length(A),0) ).

tff(formula_007,conjecture,
    ! [L: $int,U: $int,A: 'Array[Int,Int]',E: $int] :
      ( ( $lesseq(0,L)
        & $less(U,length(A))
        & sorted(A,0,$difference(length(A),1)) )
     => ( ( $greater(L,U)
         => $true )
        & ( ? [M_1: $int] :
              ( ( $true
               <= ( 'select:(Array[Int,Int]*Int)>Int'(A,M_1) = E ) )
              & ( ( 'select:(Array[Int,Int]*Int)>Int'(A,M_1) != E )
               => ( ( ~ $less('select:(Array[Int,Int]*Int)>Int'(A,M_1),E)
                   => ? [U_3: $int] :
                        ( $less(U_3,length(A))
                        & sorted(A,0,$difference(length(A),1))
                        & $lesseq(0,L)
                        & ( U_3 = $difference(M_1,1) ) ) )
                  & ( ? [L_2: $int] :
                        ( $less(U,length(A))
                        & sorted(A,0,$difference(length(A),1))
                        & $lesseq(0,L_2)
                        & ( L_2 = $sum(M_1,1) ) )
                   <= $less('select:(Array[Int,Int]*Int)>Int'(A,M_1),E) ) ) )
              & ( M_1 = div2($sum(L,U)) ) )
         <= ~ $greater(L,U) ) ) ) ).

tff(formula,axiom,
    ! [A: 'Array[Int,Int]',I: $int,E: $int] : ( 'select:(Array[Int,Int]*Int)>Int'('store:(Array[Int,Int]*Int*Int)>Array[Int,Int]'(A,I,E),I) = E ) ).

tff(formula_001,axiom,
    ! [A: 'Array[Int,Int]',I: $int,J: $int,E: $int] :
      ( ( 'select:(Array[Int,Int]*Int)>Int'('store:(Array[Int,Int]*Int*Int)>Array[Int,Int]'(A,I,E),J) = 'select:(Array[Int,Int]*Int)>Int'(A,J) )
     <= ( I != J ) ) ).

tff(formula_004,axiom,
    ! [A: $int,Res: $int] :
      ( ( div2(A) = Res )
    <=> ( $greater($product(2,$sum(Res,1)),A)
        & $lesseq($product(2,Res),A) ) ) ).

tff(formula_002,axiom,
    ! [A: 'Array[Int,Int]',B: 'Array[Int,Int]'] :
      ( ( A = B )
     <= ! [I: $int] : ( 'select:(Array[Int,Int]*Int)>Int'(A,I) = 'select:(Array[Int,Int]*Int)>Int'(B,I) ) ) ).

