tff('Tree',type,
    'Tree': $tType ).

tff(empty,type,
    'empty:Tree': 'Tree' ).

tff(left,type,
    'left:(Tree)>Tree': 'Tree' > 'Tree' ).

tff(val,type,
    'val:(Tree)>Int': 'Tree' > $int ).

tff(node,type,
    'node:(Int*Tree*Tree)>Tree': ( $int * 'Tree' * 'Tree' ) > 'Tree' ).

tff(right,type,
    'right:(Tree)>Tree': 'Tree' > 'Tree' ).

tff(searchtree,type,
    searchtree: 'Tree' > $o ).

tff(in,type,
    in: ( $int * 'Tree' ) > $o ).

tff(formula_003,axiom,
    ! [X_1_0: $int,X_1_1: 'Tree',X_1_2: 'Tree'] : ( 'right:(Tree)>Tree'('node:(Int*Tree*Tree)>Tree'(X_1_0,X_1_1,X_1_2)) = X_1_2 ) ).

tff(formula_006,axiom,
    ! [T: 'Tree'] :
      ( searchtree(T)
    <=> ( ( ( T = 'empty:Tree' )
         => $true )
        & ( ( T != 'empty:Tree' )
         => ( searchtree('right:(Tree)>Tree'(T))
            & ! [V: $int] :
                ( in(V,'left:(Tree)>Tree'(T))
               => $lesseq(V,'val:(Tree)>Int'(T)) )
            & ! [V: $int] :
                ( $greater(V,'val:(Tree)>Int'(T))
               <= in(V,'right:(Tree)>Tree'(T)) )
            & searchtree('left:(Tree)>Tree'(T)) ) ) ) ) ).

tff(formula_005,axiom,
    ! [V: $int,T: 'Tree'] :
      ( in(V,T)
    <=> ( ( ( T = 'empty:Tree' )
         => $false )
        & ( ( T != 'empty:Tree' )
         => ( ( V = 'val:(Tree)>Int'(T) )
            | in(V,'left:(Tree)>Tree'(T))
            | in(V,'right:(Tree)>Tree'(T)) ) ) ) ) ).

tff(formula,axiom,
    ! [X: 'Tree'] :
      ( ( X = 'node:(Int*Tree*Tree)>Tree'('val:(Tree)>Int'(X),'left:(Tree)>Tree'(X),'right:(Tree)>Tree'(X)) )
      | ( X = 'empty:Tree' ) ) ).

tff(formula_007,conjecture,
    ! [T: 'Tree',V: $int] :
      ( ( ( ( ( ( ( ( ? [T_3: 'Tree'] :
                        ( ( T_3 = 'left:(Tree)>Tree'(T) )
                        & in(V,T_3) )
                   <= $less(V,'val:(Tree)>Int'(T)) )
                  & ( ~ $less(V,'val:(Tree)>Int'(T))
                   => ? [T_5: 'Tree'] :
                        ( ( T_5 = 'right:(Tree)>Tree'(T) )
                        & in(V,T_5) ) ) )
               <= ( V != 'val:(Tree)>Int'(T) ) )
              & ( $true
               <= ( V = 'val:(Tree)>Int'(T) ) ) )
           <= ( T != 'empty:Tree' ) )
          & ( $false
           <= ( T = 'empty:Tree' ) ) )
      <=> in(V,T) )
     <= searchtree(T) ) ).

tff(formula_002,axiom,
    ! [X_1_0: $int,X_1_1: 'Tree',X_1_2: 'Tree'] : ( 'left:(Tree)>Tree'('node:(Int*Tree*Tree)>Tree'(X_1_0,X_1_1,X_1_2)) = X_1_1 ) ).

tff(formula_001,axiom,
    ! [X_1_0: $int,X_1_1: 'Tree',X_1_2: 'Tree'] : ( 'val:(Tree)>Int'('node:(Int*Tree*Tree)>Tree'(X_1_0,X_1_1,X_1_2)) = X_1_0 ) ).

tff(formula_004,axiom,
    ! [X_1_0: $int,X_1_1: 'Tree',X_1_2: 'Tree'] : ( 'empty:Tree' != 'node:(Int*Tree*Tree)>Tree'(X_1_0,X_1_1,X_1_2) ) ).

