include('Axioms/GRP004-0.ax').
cnf(intersection_commutative,axiom,
    intersection(X,Y) = intersection(Y,X) ).

cnf(inverse_product_lemma,axiom,
    multiply(inverse(Y),inverse(X)) = inverse(multiply(X,Y)) ).

cnf(multiply_intersection1,axiom,
    multiply(X,intersection(Y,Z)) = intersection(multiply(X,Y),multiply(X,Z)) ).

cnf(union_commutative,axiom,
    union(Y,X) = union(X,Y) ).

cnf(inverse_of_identity,axiom,
    identity = inverse(identity) ).

cnf(positive_part,axiom,
    union(X,identity) = positive_part(X) ).

cnf(negative_part,axiom,
    negative_part(X) = intersection(X,identity) ).

cnf(union_associative,axiom,
    union(union(X,Y),Z) = union(X,union(Y,Z)) ).

cnf(multiply_union2,axiom,
    union(multiply(Y,X),multiply(Z,X)) = multiply(union(Y,Z),X) ).

cnf(multiply_intersection2,axiom,
    intersection(multiply(Y,X),multiply(Z,X)) = multiply(intersection(Y,Z),X) ).

cnf(union_intersection_absorbtion,axiom,
    union(intersection(X,Y),Y) = Y ).

cnf(multiply_union1,axiom,
    union(multiply(X,Y),multiply(X,Z)) = multiply(X,union(Y,Z)) ).

cnf(intersection_idempotent,axiom,
    X = intersection(X,X) ).

cnf(intersection_associative,axiom,
    intersection(X,intersection(Y,Z)) = intersection(intersection(X,Y),Z) ).

cnf(intersection_union_absorbtion,axiom,
    intersection(union(X,Y),Y) = Y ).

cnf(union_idempotent,axiom,
    X = union(X,X) ).

cnf(inverse_involution,axiom,
    X = inverse(inverse(X)) ).

cnf(prove_product,negated_conjecture,
    a != multiply(positive_part(a),negative_part(a)) ).

