cnf(ifeq_axiom_001,axiom,
    ifeq(A,A,B,C) = B ).

cnf(additive_identity,axiom,
    A = addition(A,zero) ).

cnf(complement,axiom,
    antidomain(domain(X0)) = c(X0) ).

cnf(additive_associativity,axiom,
    addition(addition(A,B),C) = addition(A,addition(B,C)) ).

cnf(order,axiom,
    true = ifeq2(addition(A,B),B,leq(A,B),true) ).

cnf(codomain1,axiom,
    multiplication(X0,coantidomain(X0)) = zero ).

cnf(right_annihilation,axiom,
    multiplication(A,zero) = zero ).

cnf(ifeq_axiom,axiom,
    ifeq2(A,A,B,C) = B ).

cnf(backward_box,axiom,
    backward_box(X0,X1) = c(backward_diamond(X0,c(X1))) ).

cnf(multiplicative_left_identity,axiom,
    multiplication(one,A) = A ).

cnf(right_distributivity,axiom,
    multiplication(A,addition(B,C)) = addition(multiplication(A,B),multiplication(A,C)) ).

cnf(multiplicative_right_identity,axiom,
    multiplication(A,one) = A ).

cnf(left_annihilation,axiom,
    multiplication(zero,A) = zero ).

cnf(additive_idempotence,axiom,
    A = addition(A,A) ).

cnf(goals,negated_conjecture,
    addition(domain(sK2_goals_X0),backward_box(sK1_goals_X1,forward_diamond(sK1_goals_X1,domain(sK2_goals_X0)))) != backward_box(sK1_goals_X1,forward_diamond(sK1_goals_X1,domain(sK2_goals_X0))) ).

cnf(codomain4,axiom,
    coantidomain(coantidomain(X0)) = codomain(X0) ).

cnf(multiplicative_associativity,axiom,
    multiplication(A,multiplication(B,C)) = multiplication(multiplication(A,B),C) ).

cnf(domain_difference,axiom,
    multiplication(domain(X0),antidomain(X1)) = domain_difference(X0,X1) ).

cnf(forward_diamond,axiom,
    domain(multiplication(X0,domain(X1))) = forward_diamond(X0,X1) ).

cnf(order_1,axiom,
    B = ifeq(leq(A,B),true,addition(A,B),B) ).

cnf(domain3,axiom,
    one = addition(antidomain(antidomain(X0)),antidomain(X0)) ).

cnf(backward_diamond,axiom,
    backward_diamond(X0,X1) = codomain(multiplication(codomain(X1),X0)) ).

cnf(codomain2,axiom,
    addition(coantidomain(multiplication(X0,X1)),coantidomain(multiplication(coantidomain(coantidomain(X0)),X1))) = coantidomain(multiplication(coantidomain(coantidomain(X0)),X1)) ).

cnf(domain4,axiom,
    domain(X0) = antidomain(antidomain(X0)) ).

cnf(forward_box,axiom,
    c(forward_diamond(X0,c(X1))) = forward_box(X0,X1) ).

cnf(domain1,axiom,
    zero = multiplication(antidomain(X0),X0) ).

cnf(additive_commutativity,axiom,
    addition(A,B) = addition(B,A) ).

cnf(codomain3,axiom,
    addition(coantidomain(coantidomain(X0)),coantidomain(X0)) = one ).

cnf(left_distributivity,axiom,
    addition(multiplication(A,C),multiplication(B,C)) = multiplication(addition(A,B),C) ).

cnf(domain2,axiom,
    addition(antidomain(multiplication(X0,X1)),antidomain(multiplication(X0,antidomain(antidomain(X1))))) = antidomain(multiplication(X0,antidomain(antidomain(X1)))) ).

