fof(day1_once,axiom,
    ? [X] : day1(X) ).

fof(truth_once,axiom,
    ? [X] : truthday(X) ).

fof(tuesday_follows_monday,axiom,
    tuesday = consecutive(monday) ).

fof(statement2,axiom,
    ! [X] :
      ( ( truthday(X)
      <=> ( day2(saturday)
          | day2(sunday)
          | day2(thursday) ) )
     <= day2(X) ) ).

fof(thursday_follows_wednesday,axiom,
    thursday = consecutive(wednesday) ).

fof(day3_unique,axiom,
    ! [X,Y] :
      ( ( day3(X)
        & day3(Y) )
     => Y = X ) ).

fof(sunday_follows_saturday,axiom,
    consecutive(saturday) = sunday ).

fof(monday_follows_sunday,axiom,
    monday = consecutive(sunday) ).

fof(uniquenames,axiom,
    ( tuesday != monday
    & wednesday != monday
    & monday != thursday
    & monday != friday
    & friday != tuesday
    & tuesday != saturday
    & wednesday != thursday
    & saturday != wednesday
    & sunday != wednesday
    & thursday != friday
    & thursday != sunday
    & friday != sunday
    & sunday != saturday
    & saturday != friday
    & thursday != saturday
    & friday != wednesday
    & tuesday != sunday
    & tuesday != thursday
    & wednesday != tuesday
    & sunday != monday
    & saturday != monday ) ).

fof(day2_once,axiom,
    ? [X] : day2(X) ).

fof(saturday_follows_friday,axiom,
    consecutive(friday) = saturday ).

fof(day3_once,axiom,
    ? [X] : day3(X) ).

fof(day1_unique,axiom,
    ! [X,Y] :
      ( Y = X
     <= ( day1(X)
        & day1(Y) ) ) ).

fof(truth_unique,axiom,
    ! [X,Y] :
      ( X = Y
     <= ( truthday(Y)
        & truthday(X) ) ) ).

fof(tuesday_leo_tells_truths,conjecture,
    truthday(tuesday) ).

fof(friday_follows_thursday,axiom,
    friday = consecutive(thursday) ).

fof(day2_follows_day1,axiom,
    ! [X] :
      ( day2(consecutive(X))
    <=> day1(X) ) ).

fof(days_of_week,axiom,
    ! [X] :
      ( thursday = X
      | sunday = X
      | saturday = X
      | friday = X
      | wednesday = X
      | tuesday = X
      | monday = X ) ).

fof(wednesday_follows_tuesday,axiom,
    wednesday = consecutive(tuesday) ).

fof(statement1,axiom,
    ! [X] :
      ( ( truthday(X)
      <=> ( ~ truthday(monday)
          & ~ truthday(tuesday) ) )
     <= day1(X) ) ).

fof(day3_follows_day2,axiom,
    ! [X] :
      ( day3(consecutive(X))
    <=> day2(X) ) ).

fof(statement3,axiom,
    ! [X] :
      ( day3(X)
     => ( ( ~ truthday(wednesday)
          & ~ truthday(friday) )
      <=> truthday(X) ) ) ).

fof(day2_unique,axiom,
    ! [X,Y] :
      ( ( day2(Y)
        & day2(X) )
     => Y = X ) ).

