fof(commutativity_of_union,axiom,
    ! [B,C] : union(B,C) = union(C,B) ).

fof(equal_defn,axiom,
    ! [B,C] :
      ( C = B
    <=> ( subset(C,B)
        & subset(B,C) ) ) ).

fof(union_distributes_over_intersection,axiom,
    ! [B,C,D] : intersection(union(B,C),union(B,D)) = union(B,intersection(C,D)) ).

fof(union_defn,axiom,
    ! [B,C,D] :
      ( member(D,union(B,C))
    <=> ( member(D,C)
        | member(D,B) ) ) ).

fof(associativity_of_intersection,axiom,
    ! [B,C,D] : intersection(B,intersection(C,D)) = intersection(intersection(B,C),D) ).

fof(commutativity_of_intersection,axiom,
    ! [B,C] : intersection(C,B) = intersection(B,C) ).

fof(associativity_of_union,axiom,
    ! [B,C,D] : union(union(B,C),D) = union(B,union(C,D)) ).

fof(subset_defn,axiom,
    ! [B,C] :
      ( ! [D] :
          ( member(D,B)
         => member(D,C) )
    <=> subset(B,C) ) ).

fof(reflexivity_of_subset,axiom,
    ! [B] : subset(B,B) ).

fof(idempotency_of_intersection,axiom,
    ! [B] : B = intersection(B,B) ).

fof(prove_th72,conjecture,
    ! [B,C,D] : union(union(intersection(B,C),intersection(C,D)),intersection(D,B)) = intersection(intersection(union(B,C),union(C,D)),union(D,B)) ).

fof(union_intersection,axiom,
    ! [B,C] : B = union(B,intersection(B,C)) ).

fof(equal_member_defn,axiom,
    ! [B,C] :
      ( B = C
    <=> ! [D] :
          ( member(D,C)
        <=> member(D,B) ) ) ).

fof(intersection_defn,axiom,
    ! [B,C,D] :
      ( member(D,intersection(B,C))
    <=> ( member(D,B)
        & member(D,C) ) ) ).

