fof(prove_th119,conjecture,
    ! [B,C] :
      ( not_equal(intersection(B,C),empty_set)
    <=> intersect(B,C) ) ).

fof(not_equal_defn,axiom,
    ! [B,C] :
      ( not_equal(B,C)
    <=> C != B ) ).

fof(symmetry_of_intersect,axiom,
    ! [B,C] :
      ( intersect(C,B)
     <= intersect(B,C) ) ).

fof(empty_set_defn,axiom,
    ! [B] : ~ member(B,empty_set) ).

fof(intersect_defn,axiom,
    ! [B,C] :
      ( intersect(B,C)
    <=> ? [D] :
          ( member(D,B)
          & member(D,C) ) ) ).

fof(commutativity_of_intersection,axiom,
    ! [B,C] : intersection(C,B) = intersection(B,C) ).

fof(equal_member_defn,axiom,
    ! [B,C] :
      ( ! [D] :
          ( member(D,B)
        <=> member(D,C) )
    <=> B = C ) ).

fof(empty_defn,axiom,
    ! [B] :
      ( ! [C] : ~ member(C,B)
    <=> empty(B) ) ).

fof(intersection_defn,axiom,
    ! [B,C,D] :
      ( ( member(D,B)
        & member(D,C) )
    <=> member(D,intersection(B,C)) ) ).

