fof(t7_xboole_1,lemma,
    ! [A,B] : subset(A,set_union2(A,B)) ).

fof(t8_xboole_1,lemma,
    ! [A,B,C] :
      ( ( subset(C,B)
        & subset(A,B) )
     => subset(set_union2(A,C),B) ) ).

fof(t37_xboole_1,lemma,
    ! [A,B] :
      ( empty_set = set_difference(A,B)
    <=> subset(A,B) ) ).

fof(dt_k4_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => relation(relation_inverse(A)) ) ).

fof(t43_subset_1,lemma,
    ! [A,B] :
      ( element(B,powerset(A))
     => ! [C] :
          ( element(C,powerset(A))
         => ( subset(B,subset_complement(A,C))
          <=> disjoint(B,C) ) ) ) ).

fof(t2_xboole_1,lemma,
    ! [A] : subset(empty_set,A) ).

fof(l1_zfmisc_1,lemma,
    ! [A] : singleton(A) != empty_set ).

fof(t4_subset,axiom,
    ! [A,B,C] :
      ( element(A,C)
     <= ( element(B,powerset(C))
        & in(A,B) ) ) ).

fof(dt_k2_tarski,axiom,
    $true ).

fof(d4_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation_dom(A) = B
        <=> ! [C] :
              ( ? [D] : in(ordered_pair(C,D),A)
            <=> in(C,B) ) ) ) ).

fof(t65_zfmisc_1,lemma,
    ! [A,B] :
      ( ~ in(B,A)
    <=> set_difference(A,singleton(B)) = A ) ).

fof(fc3_xboole_0,axiom,
    ! [A,B] :
      ( ~ empty(A)
     => ~ empty(set_union2(B,A)) ) ).

fof(t56_relat_1,lemma,
    ! [A] :
      ( ( ! [B,C] : ~ in(ordered_pair(B,C),A)
       => empty_set = A )
     <= relation(A) ) ).

fof(t39_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,singleton(B))
    <=> ( singleton(B) = A
        | empty_set = A ) ) ).

fof(l23_zfmisc_1,lemma,
    ! [A,B] :
      ( set_union2(singleton(A),B) = B
     <= in(A,B) ) ).

fof(t1_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,C)
     <= ( subset(A,B)
        & subset(B,C) ) ) ).

fof(d2_subset_1,axiom,
    ! [A,B] :
      ( ( ( element(B,A)
        <=> in(B,A) )
       <= ~ empty(A) )
      & ( empty(A)
       => ( element(B,A)
        <=> empty(B) ) ) ) ).

fof(t69_enumset1,lemma,
    ! [A] : unordered_pair(A,A) = singleton(A) ).

fof(dt_k1_zfmisc_1,axiom,
    $true ).

fof(fc3_subset_1,axiom,
    ! [A,B] : ~ empty(unordered_pair(A,B)) ).

fof(l25_zfmisc_1,lemma,
    ! [A,B] :
      ~ ( in(A,B)
        & disjoint(singleton(A),B) ) ).

fof(dt_k2_relat_1,axiom,
    $true ).

fof(t2_boole,axiom,
    ! [A] : set_intersection2(A,empty_set) = empty_set ).

fof(t47_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation(B)
         => ( relation_rng(A) = relation_rng(relation_composition(B,A))
           <= subset(relation_dom(A),relation_rng(B)) ) ) ) ).

fof(rc1_relat_1,axiom,
    ? [A] :
      ( empty(A)
      & relation(A) ) ).

fof(t2_subset,axiom,
    ! [A,B] :
      ( ( empty(B)
        | in(A,B) )
     <= element(A,B) ) ).

fof(t9_zfmisc_1,lemma,
    ! [A,B,C] :
      ( B = C
     <= unordered_pair(B,C) = singleton(A) ) ).

fof(t9_tarski,axiom,
    ! [A] :
    ? [B] :
      ( in(A,B)
      & ! [C,D] :
          ( ( in(C,B)
            & subset(D,C) )
         => in(D,B) )
      & ! [C] :
          ~ ( subset(C,B)
            & ~ are_equipotent(C,B)
            & ~ in(C,B) )
      & ! [C] :
          ~ ( in(C,B)
            & ! [D] :
                ~ ( in(D,B)
                  & ! [E] :
                      ( in(E,D)
                     <= subset(E,C) ) ) ) ) ).

fof(t1_zfmisc_1,lemma,
    singleton(empty_set) = powerset(empty_set) ).

fof(dt_k3_tarski,axiom,
    $true ).

fof(t45_xboole_1,lemma,
    ! [A,B] :
      ( set_union2(A,set_difference(B,A)) = B
     <= subset(A,B) ) ).

fof(t20_relat_1,lemma,
    ! [A,B,C] :
      ( ( in(ordered_pair(A,B),C)
       => ( in(B,relation_rng(C))
          & in(A,relation_dom(C)) ) )
     <= relation(C) ) ).

fof(commutativity_k3_xboole_0,axiom,
    ! [A,B] : set_intersection2(B,A) = set_intersection2(A,B) ).

fof(d7_xboole_0,axiom,
    ! [A,B] :
      ( disjoint(A,B)
    <=> set_intersection2(A,B) = empty_set ) ).

fof(t48_setfam_1,lemma,
    ! [A,B] :
      ( ( union_of_subsets(A,complements_of_subsets(A,B)) = subset_difference(A,cast_to_subset(A),meet_of_subsets(A,B))
       <= B != empty_set )
     <= element(B,powerset(powerset(A))) ) ).

fof(t119_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( subset(cartesian_product2(A,C),cartesian_product2(B,D))
     <= ( subset(C,D)
        & subset(A,B) ) ) ).

fof(t46_setfam_1,lemma,
    ! [A,B] :
      ( ~ ( B != empty_set
          & empty_set = complements_of_subsets(A,B) )
     <= element(B,powerset(powerset(A))) ) ).

fof(d1_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( C = A
        <=> in(C,B) )
    <=> singleton(A) = B ) ).

fof(d10_xboole_0,axiom,
    ! [A,B] :
      ( ( subset(A,B)
        & subset(B,A) )
    <=> B = A ) ).

fof(t46_zfmisc_1,lemma,
    ! [A,B] :
      ( in(A,B)
     => B = set_union2(singleton(A),B) ) ).

fof(rc1_subset_1,axiom,
    ! [A] :
      ( ? [B] :
          ( ~ empty(B)
          & element(B,powerset(A)) )
     <= ~ empty(A) ) ).

fof(dt_k1_xboole_0,axiom,
    $true ).

fof(dt_m1_subset_1,axiom,
    $true ).

fof(t3_subset,axiom,
    ! [A,B] :
      ( element(A,powerset(B))
    <=> subset(A,B) ) ).

fof(d7_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( ( ! [C,D] :
                ( in(ordered_pair(C,D),B)
              <=> in(ordered_pair(D,C),A) )
          <=> B = relation_inverse(A) )
         <= relation(B) ) ) ).

fof(involutiveness_k7_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => complements_of_subsets(A,complements_of_subsets(A,B)) = B ) ).

fof(dt_k6_setfam_1,axiom,
    ! [A,B] :
      ( element(meet_of_subsets(A,B),powerset(A))
     <= element(B,powerset(powerset(A))) ) ).

fof(t83_xboole_1,lemma,
    ! [A,B] :
      ( set_difference(A,B) = A
    <=> disjoint(A,B) ) ).

fof(t6_boole,axiom,
    ! [A] :
      ( empty_set = A
     <= empty(A) ) ).

fof(dt_k5_relat_1,axiom,
    ! [A,B] :
      ( ( relation(A)
        & relation(B) )
     => relation(relation_composition(A,B)) ) ).

fof(t47_setfam_1,lemma,
    ! [A,B] :
      ( ( subset_difference(A,cast_to_subset(A),union_of_subsets(A,B)) = meet_of_subsets(A,complements_of_subsets(A,B))
       <= B != empty_set )
     <= element(B,powerset(powerset(A))) ) ).

fof(dt_k7_setfam_1,axiom,
    ! [A,B] :
      ( element(complements_of_subsets(A,B),powerset(powerset(A)))
     <= element(B,powerset(powerset(A))) ) ).

fof(t3_boole,axiom,
    ! [A] : set_difference(A,empty_set) = A ).

fof(dt_k3_subset_1,axiom,
    ! [A,B] :
      ( element(subset_complement(A,B),powerset(A))
     <= element(B,powerset(A)) ) ).

fof(t19_xboole_1,lemma,
    ! [A,B,C] :
      ( ( subset(A,C)
        & subset(A,B) )
     => subset(A,set_intersection2(B,C)) ) ).

fof(d2_zfmisc_1,axiom,
    ! [A,B,C] :
      ( C = cartesian_product2(A,B)
    <=> ! [D] :
          ( ? [E,F] :
              ( ordered_pair(E,F) = D
              & in(F,B)
              & in(E,A) )
        <=> in(D,C) ) ) ).

fof(t8_zfmisc_1,lemma,
    ! [A,B,C] :
      ( singleton(A) = unordered_pair(B,C)
     => B = A ) ).

fof(t92_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(A,union(B))
     <= in(A,B) ) ).

fof(fc2_relat_1,axiom,
    ! [A,B] :
      ( relation(set_union2(A,B))
     <= ( relation(A)
        & relation(B) ) ) ).

fof(t17_xboole_1,lemma,
    ! [A,B] : subset(set_intersection2(A,B),A) ).

fof(t33_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( A = C
        & B = D )
     <= ordered_pair(C,D) = ordered_pair(A,B) ) ).

fof(t3_xboole_0,lemma,
    ! [A,B] :
      ( ~ ( ~ disjoint(A,B)
          & ! [C] :
              ~ ( in(C,B)
                & in(C,A) ) )
      & ~ ( disjoint(A,B)
          & ? [C] :
              ( in(C,A)
              & in(C,B) ) ) ) ).

fof(idempotence_k3_xboole_0,axiom,
    ! [A,B] : A = set_intersection2(A,A) ).

fof(t44_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation(B)
         => subset(relation_dom(relation_composition(A,B)),relation_dom(A)) ) ) ).

fof(t48_xboole_1,lemma,
    ! [A,B] : set_difference(A,set_difference(A,B)) = set_intersection2(A,B) ).

fof(t3_xboole_1,lemma,
    ! [A] :
      ( subset(A,empty_set)
     => empty_set = A ) ).

fof(t50_subset_1,lemma,
    ! [A] :
      ( ! [B] :
          ( ! [C] :
              ( element(C,A)
             => ( ~ in(C,B)
               => in(C,subset_complement(A,B)) ) )
         <= element(B,powerset(A)) )
     <= empty_set != A ) ).

fof(fc4_relat_1,axiom,
    ( empty(empty_set)
    & relation(empty_set) ) ).

fof(dt_k4_tarski,axiom,
    $true ).

fof(t10_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ~ ( A != C
        & A != D
        & unordered_pair(A,B) = unordered_pair(C,D) ) ).

fof(antisymmetry_r2_hidden,axiom,
    ! [A,B] :
      ( ~ in(B,A)
     <= in(A,B) ) ).

fof(d1_zfmisc_1,axiom,
    ! [A,B] :
      ( powerset(A) = B
    <=> ! [C] :
          ( subset(C,A)
        <=> in(C,B) ) ) ).

fof(t37_relat_1,lemma,
    ! [A] :
      ( ( relation_dom(relation_inverse(A)) = relation_rng(A)
        & relation_dom(A) = relation_rng(relation_inverse(A)) )
     <= relation(A) ) ).

fof(d8_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation(B)
         => ! [C] :
              ( ( ! [D,E] :
                    ( ? [F] :
                        ( in(ordered_pair(F,E),B)
                        & in(ordered_pair(D,F),A) )
                  <=> in(ordered_pair(D,E),C) )
              <=> relation_composition(A,B) = C )
             <= relation(C) ) ) ) ).

fof(l28_zfmisc_1,lemma,
    ! [A,B] :
      ( disjoint(singleton(A),B)
     <= ~ in(A,B) ) ).

fof(d2_tarski,axiom,
    ! [A,B,C] :
      ( ! [D] :
          ( ( D = A
            | D = B )
        <=> in(D,C) )
    <=> C = unordered_pair(A,B) ) ).

fof(dt_k3_relat_1,axiom,
    $true ).

fof(t6_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),singleton(B))
     => B = A ) ).

fof(t37_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),B)
    <=> in(A,B) ) ).

fof(redefinition_k6_subset_1,axiom,
    ! [A,B,C] :
      ( subset_difference(A,B,C) = set_difference(B,C)
     <= ( element(C,powerset(A))
        & element(B,powerset(A)) ) ) ).

fof(t38_zfmisc_1,lemma,
    ! [A,B,C] :
      ( ( in(B,C)
        & in(A,C) )
    <=> subset(unordered_pair(A,B),C) ) ).

fof(involutiveness_k3_subset_1,axiom,
    ! [A,B] :
      ( element(B,powerset(A))
     => subset_complement(A,subset_complement(A,B)) = B ) ).

fof(d4_xboole_0,axiom,
    ! [A,B,C] :
      ( ! [D] :
          ( ( in(D,A)
            & ~ in(D,B) )
        <=> in(D,C) )
    <=> C = set_difference(A,B) ) ).

fof(t60_relat_1,conjecture,
    ( empty_set = relation_rng(empty_set)
    & relation_dom(empty_set) = empty_set ) ).

fof(idempotence_k2_xboole_0,axiom,
    ! [A,B] : A = set_union2(A,A) ).

fof(d5_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation_rng(A) = B
        <=> ! [C] :
              ( in(C,B)
            <=> ? [D] : in(ordered_pair(D,C),A) ) ) ) ).

fof(t4_xboole_0,lemma,
    ! [A,B] :
      ( ~ ( disjoint(A,B)
          & ? [C] : in(C,set_intersection2(A,B)) )
      & ~ ( ~ disjoint(A,B)
          & ! [C] : ~ in(C,set_intersection2(A,B)) ) ) ).

fof(t33_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,B)
     => subset(set_difference(A,C),set_difference(B,C)) ) ).

fof(t36_xboole_1,lemma,
    ! [A,B] : subset(set_difference(A,B),A) ).

fof(d3_xboole_0,axiom,
    ! [A,B,C] :
      ( ! [D] :
          ( ( in(D,B)
            & in(D,A) )
        <=> in(D,C) )
    <=> set_intersection2(A,B) = C ) ).

fof(rc2_relat_1,axiom,
    ? [A] :
      ( ~ empty(A)
      & relation(A) ) ).

fof(l71_subset_1,lemma,
    ! [A,B] :
      ( element(A,powerset(B))
     <= ! [C] :
          ( in(C,A)
         => in(C,B) ) ) ).

fof(redefinition_k5_setfam_1,axiom,
    ! [A,B] :
      ( union(B) = union_of_subsets(A,B)
     <= element(B,powerset(powerset(A))) ) ).

fof(existence_m1_subset_1,axiom,
    ! [A] :
    ? [B] : element(B,A) ).

fof(dt_k6_subset_1,axiom,
    ! [A,B,C] :
      ( ( element(B,powerset(A))
        & element(C,powerset(A)) )
     => element(subset_difference(A,B,C),powerset(A)) ) ).

fof(t4_boole,axiom,
    ! [A] : set_difference(empty_set,A) = empty_set ).

fof(t25_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( ( subset(A,B)
           => ( subset(relation_rng(A),relation_rng(B))
              & subset(relation_dom(A),relation_dom(B)) ) )
         <= relation(B) )
     <= relation(A) ) ).

fof(t21_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => subset(A,cartesian_product2(relation_dom(A),relation_rng(A))) ) ).

fof(dt_k5_setfam_1,axiom,
    ! [A,B] :
      ( element(B,powerset(powerset(A)))
     => element(union_of_subsets(A,B),powerset(A)) ) ).

fof(t99_zfmisc_1,lemma,
    ! [A] : A = union(powerset(A)) ).

fof(t8_boole,axiom,
    ! [A,B] :
      ~ ( empty(A)
        & empty(B)
        & A != B ) ).

fof(symmetry_r1_xboole_0,axiom,
    ! [A,B] :
      ( disjoint(B,A)
     <= disjoint(A,B) ) ).

fof(d8_setfam_1,axiom,
    ! [A,B] :
      ( ! [C] :
          ( ( C = complements_of_subsets(A,B)
          <=> ! [D] :
                ( element(D,powerset(A))
               => ( in(D,C)
                <=> in(subset_complement(A,D),B) ) ) )
         <= element(C,powerset(powerset(A))) )
     <= element(B,powerset(powerset(A))) ) ).

fof(t2_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( in(C,B)
        <=> in(C,A) )
     => B = A ) ).

fof(d5_tarski,axiom,
    ! [A,B] : unordered_pair(unordered_pair(A,B),singleton(A)) = ordered_pair(A,B) ).

fof(d1_setfam_1,axiom,
    ! [A,B] :
      ( ( empty_set = A
       => ( set_meet(A) = B
        <=> B = empty_set ) )
      & ( A != empty_set
       => ( ! [C] :
              ( in(C,B)
            <=> ! [D] :
                  ( in(C,D)
                 <= in(D,A) ) )
        <=> set_meet(A) = B ) ) ) ).

fof(t12_xboole_1,lemma,
    ! [A,B] :
      ( B = set_union2(A,B)
     <= subset(A,B) ) ).

fof(d8_xboole_0,axiom,
    ! [A,B] :
      ( proper_subset(A,B)
    <=> ( B != A
        & subset(A,B) ) ) ).

fof(t30_relat_1,lemma,
    ! [A,B,C] :
      ( relation(C)
     => ( in(ordered_pair(A,B),C)
       => ( in(A,relation_field(C))
          & in(B,relation_field(C)) ) ) ) ).

fof(t7_boole,axiom,
    ! [A,B] :
      ~ ( empty(B)
        & in(A,B) ) ).

fof(l3_subset_1,lemma,
    ! [A,B] :
      ( ! [C] :
          ( in(C,A)
         <= in(C,B) )
     <= element(B,powerset(A)) ) ).

fof(fc1_xboole_0,axiom,
    empty(empty_set) ).

fof(t1_boole,axiom,
    ! [A] : A = set_union2(A,empty_set) ).

fof(t1_subset,axiom,
    ! [A,B] :
      ( element(A,B)
     <= in(A,B) ) ).

fof(rc1_xboole_0,axiom,
    ? [A] : empty(A) ).

fof(t45_relat_1,lemma,
    ! [A] :
      ( relation(A)
     => ! [B] :
          ( relation(B)
         => subset(relation_rng(relation_composition(A,B)),relation_rng(B)) ) ) ).

fof(l55_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( in(B,D)
        & in(A,C) )
    <=> in(ordered_pair(A,B),cartesian_product2(C,D)) ) ).

fof(involutiveness_k4_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => A = relation_inverse(relation_inverse(A)) ) ).

fof(l50_zfmisc_1,lemma,
    ! [A,B] :
      ( in(A,B)
     => subset(A,union(B)) ) ).

fof(irreflexivity_r2_xboole_0,axiom,
    ! [A,B] : ~ proper_subset(A,A) ).

fof(rc2_xboole_0,axiom,
    ? [A] : ~ empty(A) ).

fof(fc2_subset_1,axiom,
    ! [A] : ~ empty(singleton(A)) ).

fof(fc1_subset_1,axiom,
    ! [A] : ~ empty(powerset(A)) ).

fof(t40_xboole_1,lemma,
    ! [A,B] : set_difference(set_union2(A,B),B) = set_difference(A,B) ).

fof(t54_subset_1,lemma,
    ! [A,B,C] :
      ( element(C,powerset(A))
     => ~ ( in(B,C)
          & in(B,subset_complement(A,C)) ) ) ).

fof(reflexivity_r1_tarski,axiom,
    ! [A,B] : subset(A,A) ).

fof(dt_k1_tarski,axiom,
    $true ).

fof(fc5_relat_1,axiom,
    ! [A] :
      ( ( relation(A)
        & ~ empty(A) )
     => ~ empty(relation_dom(A)) ) ).

fof(t60_xboole_1,lemma,
    ! [A,B] :
      ~ ( subset(A,B)
        & proper_subset(B,A) ) ).

fof(commutativity_k2_tarski,axiom,
    ! [A,B] : unordered_pair(A,B) = unordered_pair(B,A) ).

fof(t26_xboole_1,lemma,
    ! [A,B,C] :
      ( subset(A,B)
     => subset(set_intersection2(A,C),set_intersection2(B,C)) ) ).

fof(t136_zfmisc_1,lemma,
    ! [A] :
    ? [B] :
      ( in(A,B)
      & ! [C,D] :
          ( ( in(C,B)
            & subset(D,C) )
         => in(D,B) )
      & ! [C] :
          ~ ( subset(C,B)
            & ~ in(C,B)
            & ~ are_equipotent(C,B) )
      & ! [C] :
          ( in(powerset(C),B)
         <= in(C,B) ) ) ).

fof(d4_subset_1,axiom,
    ! [A] : A = cast_to_subset(A) ).

fof(l4_zfmisc_1,lemma,
    ! [A,B] :
      ( ( A = empty_set
        | singleton(B) = A )
    <=> subset(A,singleton(B)) ) ).

fof(l2_zfmisc_1,lemma,
    ! [A,B] :
      ( subset(singleton(A),B)
    <=> in(A,B) ) ).

fof(dt_k2_zfmisc_1,axiom,
    $true ).

fof(d5_subset_1,axiom,
    ! [A,B] :
      ( subset_complement(A,B) = set_difference(A,B)
     <= element(B,powerset(A)) ) ).

fof(dt_k1_relat_1,axiom,
    $true ).

fof(t5_subset,axiom,
    ! [A,B,C] :
      ~ ( in(A,B)
        & element(B,powerset(C))
        & empty(C) ) ).

fof(fc4_subset_1,axiom,
    ! [A,B] :
      ( ~ empty(cartesian_product2(A,B))
     <= ( ~ empty(A)
        & ~ empty(B) ) ) ).

fof(t28_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
     => A = set_intersection2(A,B) ) ).

fof(d1_xboole_0,axiom,
    ! [A] :
      ( empty_set = A
    <=> ! [B] : ~ in(B,A) ) ).

fof(fc1_zfmisc_1,axiom,
    ! [A,B] : ~ empty(ordered_pair(A,B)) ).

fof(commutativity_k2_xboole_0,axiom,
    ! [A,B] : set_union2(B,A) = set_union2(A,B) ).

fof(t118_zfmisc_1,lemma,
    ! [A,B,C] :
      ( ( subset(cartesian_product2(A,C),cartesian_product2(B,C))
        & subset(cartesian_product2(C,A),cartesian_product2(C,B)) )
     <= subset(A,B) ) ).

fof(fc6_relat_1,axiom,
    ! [A] :
      ( ( relation(A)
        & ~ empty(A) )
     => ~ empty(relation_rng(A)) ) ).

fof(fc2_xboole_0,axiom,
    ! [A,B] :
      ( ~ empty(A)
     => ~ empty(set_union2(A,B)) ) ).

fof(rc2_subset_1,axiom,
    ! [A] :
    ? [B] :
      ( element(B,powerset(A))
      & empty(B) ) ).

fof(t39_xboole_1,lemma,
    ! [A,B] : set_union2(A,set_difference(B,A)) = set_union2(A,B) ).

fof(redefinition_k6_setfam_1,axiom,
    ! [A,B] :
      ( meet_of_subsets(A,B) = set_meet(B)
     <= element(B,powerset(powerset(A))) ) ).

fof(dt_k2_xboole_0,axiom,
    $true ).

fof(dt_k3_xboole_0,axiom,
    $true ).

fof(cc1_relat_1,axiom,
    ! [A] :
      ( relation(A)
     <= empty(A) ) ).

fof(d6_relat_1,axiom,
    ! [A] :
      ( relation(A)
     => relation_field(A) = set_union2(relation_dom(A),relation_rng(A)) ) ).

fof(t46_relat_1,lemma,
    ! [A] :
      ( ! [B] :
          ( ( relation_dom(A) = relation_dom(relation_composition(A,B))
           <= subset(relation_rng(A),relation_dom(B)) )
         <= relation(B) )
     <= relation(A) ) ).

fof(dt_k2_subset_1,axiom,
    ! [A] : element(cast_to_subset(A),powerset(A)) ).

fof(dt_k1_setfam_1,axiom,
    $true ).

fof(d4_tarski,axiom,
    ! [A,B] :
      ( B = union(A)
    <=> ! [C] :
          ( ? [D] :
              ( in(C,D)
              & in(D,A) )
        <=> in(C,B) ) ) ).

fof(dt_k4_xboole_0,axiom,
    $true ).

fof(antisymmetry_r2_xboole_0,axiom,
    ! [A,B] :
      ( proper_subset(A,B)
     => ~ proper_subset(B,A) ) ).

fof(d1_relat_1,axiom,
    ! [A] :
      ( relation(A)
    <=> ! [B] :
          ~ ( in(B,A)
            & ! [C,D] : B != ordered_pair(C,D) ) ) ).

fof(t106_zfmisc_1,lemma,
    ! [A,B,C,D] :
      ( ( in(A,C)
        & in(B,D) )
    <=> in(ordered_pair(A,B),cartesian_product2(C,D)) ) ).

fof(l3_zfmisc_1,lemma,
    ! [A,B,C] :
      ( subset(A,B)
     => ( in(C,A)
        | subset(A,set_difference(B,singleton(C))) ) ) ).

fof(t63_xboole_1,lemma,
    ! [A,B,C] :
      ( ( disjoint(B,C)
        & subset(A,B) )
     => disjoint(A,C) ) ).

fof(d2_xboole_0,axiom,
    ! [A,B,C] :
      ( ! [D] :
          ( ( in(D,B)
            | in(D,A) )
        <=> in(D,C) )
    <=> set_union2(A,B) = C ) ).

fof(l32_xboole_1,lemma,
    ! [A,B] :
      ( subset(A,B)
    <=> empty_set = set_difference(A,B) ) ).

fof(d3_tarski,axiom,
    ! [A,B] :
      ( ! [C] :
          ( in(C,B)
         <= in(C,A) )
    <=> subset(A,B) ) ).

