fof(assumption4,axiom,
    ( colinear(c,d,i,r)
    & colinear(a,f,i,s) ) ).

fof(goal3,axiom,
    ( line_equal(s,r)
   => goal ) ).

fof(symmetry_of_point_equal,axiom,
    ! [A,B] :
      ( point_equal(B,A)
     <= point_equal(A,B) ) ).

fof(transitivity_of_point_equal,axiom,
    ! [A,B,C] :
      ( ( point_equal(A,B)
        & point_equal(B,C) )
     => point_equal(A,C) ) ).

fof(pcon,axiom,
    ! [A,B,C] :
      ( incident(A,C)
     <= ( point_equal(A,B)
        & incident(B,C) ) ) ).

fof(assumption2,axiom,
    ( colinear(c,e,g,o)
    & colinear(b,f,g,n) ) ).

fof(assumption3,axiom,
    ( colinear(b,d,h,p)
    & colinear(a,e,h,q) ) ).

fof(symmetry_of_line_equal,axiom,
    ! [A,B] :
      ( line_equal(A,B)
     => line_equal(B,A) ) ).

fof(line,axiom,
    ! [A,B] :
      ( ? [C] :
          ( incident(A,C)
          & incident(B,C) )
     <= ( point_equal(B,B)
        & point_equal(A,A) ) ) ).

fof(assumption1,axiom,
    ( colinear(d,e,f,m)
    & colinear(a,b,c,l) ) ).

fof(lcon,axiom,
    ! [A,B,C] :
      ( incident(A,C)
     <= ( line_equal(B,C)
        & incident(A,B) ) ) ).

fof(colinearity_elimination1,axiom,
    ! [A,B,C,D] :
      ( incident(A,D)
     <= colinear(A,B,C,D) ) ).

fof(goal4,axiom,
    ! [A] :
      ( goal
     <= ( incident(h,A)
        & incident(i,A)
        & incident(g,A)
        & line_equal(A,A) ) ) ).

fof(transitivity_of_line_equal,axiom,
    ! [A,B,C] :
      ( ( line_equal(A,B)
        & line_equal(B,C) )
     => line_equal(A,C) ) ).

fof(point,axiom,
    ! [A,B,C] :
      ( ? [A] :
          ( incident(A,B)
          & incident(A,C) )
     <= ( line_equal(C,C)
        & line_equal(B,B) ) ) ).

fof(reflexivity_of_point_equal,axiom,
    ! [A,B] :
      ( point_equal(A,A)
     <= incident(A,B) ) ).

fof(goal1,axiom,
    ( goal
   <= line_equal(n,o) ) ).

fof(colinearity_elimination2,axiom,
    ! [A,B,C,D] :
      ( colinear(A,B,C,D)
     => incident(B,D) ) ).

fof(reflexivity_of_line_equal,axiom,
    ! [A,B] :
      ( incident(A,B)
     => line_equal(B,B) ) ).

fof(pappus1,axiom,
    ! [A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q] :
      ( ( ? [R] : colinear(G,H,I,R)
        | incident(A,K)
        | incident(B,K)
        | incident(C,K)
        | incident(E,J)
        | incident(F,J)
        | incident(D,J) )
     <= ( colinear(D,E,F,K)
        & colinear(B,D,H,N)
        & colinear(A,F,I,Q)
        & colinear(C,D,I,P)
        & colinear(A,E,H,O)
        & colinear(C,E,G,M)
        & colinear(B,F,G,L)
        & colinear(A,B,C,J) ) ) ).

fof(goal2,axiom,
    ( line_equal(p,q)
   => goal ) ).

fof(unique,axiom,
    ! [A,B,C,D] :
      ( ( line_equal(A,B)
        | point_equal(C,D) )
     <= ( incident(C,B)
        & incident(D,B)
        & incident(D,A)
        & incident(C,A) ) ) ).

fof(goal_to_be_proved,conjecture,
    goal ).

fof(colinearity_elimination3,axiom,
    ! [A,B,C,D] :
      ( colinear(A,B,C,D)
     => incident(C,D) ) ).

