fof(ax17,axiom,
    ! [U,V] :
      ( instrumentality(U,V)
     => artifact(U,V) ) ).

fof(ax1,axiom,
    ! [U,V] :
      ( male(U,V)
     <= man(U,V) ) ).

fof(ax14,axiom,
    ! [U,V] :
      ( entity(U,V)
     => thing(U,V) ) ).

fof(ax26,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     => nonexistent(U,V) ) ).

fof(ax4,axiom,
    ! [U,V] :
      ( organism(U,V)
     => living(U,V) ) ).

fof(ax25,axiom,
    ! [U,V] :
      ( unisex(U,V)
     <= eventuality(U,V) ) ).

fof(ax13,axiom,
    ! [U,V] :
      ( entity(U,V)
     => specific(U,V) ) ).

fof(ax5,axiom,
    ! [U,V] :
      ( organism(U,V)
     => impartial(U,V) ) ).

fof(ax18,axiom,
    ! [U,V] :
      ( instrumentality(U,V)
     <= weaponry(U,V) ) ).

fof(ax36,axiom,
    ! [U,V] :
      ( ~ living(U,V)
     <= nonliving(U,V) ) ).

fof(ax31,axiom,
    ! [U,V] :
      ( event(U,V)
     <= act(U,V) ) ).

fof(ax2,axiom,
    ! [U,V] :
      ( animate(U,V)
     <= human_person(U,V) ) ).

fof(ax20,axiom,
    ! [U,V] :
      ( weapon(U,V)
     <= cannon(U,V) ) ).

fof(ax9,axiom,
    ! [U,V] :
      ( unisex(U,V)
     <= object(U,V) ) ).

fof(ax21,axiom,
    ! [U,V] :
      ( event(U,V)
     <= fire(U,V) ) ).

fof(ax12,axiom,
    ! [U,V] :
      ( existent(U,V)
     <= entity(U,V) ) ).

fof(ax39,axiom,
    ! [U,V,W,X] :
      ( W != X
     <= ( nonreflexive(U,V)
        & agent(U,V,W)
        & patient(U,V,X) ) ) ).

fof(ax28,axiom,
    ! [U,V] :
      ( singleton(U,V)
     <= thing(U,V) ) ).

fof(ax33,axiom,
    ! [U,V] :
      ( action(U,V)
     <= shot(U,V) ) ).

fof(ax37,axiom,
    ! [U,V] :
      ( singleton(U,V)
     => ~ multiple(U,V) ) ).

fof(ax32,axiom,
    ! [U,V] :
      ( action(U,V)
     => act(U,V) ) ).

fof(ax24,axiom,
    ! [U,V] :
      ( group(U,V)
     => set(U,V) ) ).

fof(ax3,axiom,
    ! [U,V] :
      ( human_person(U,V)
     => human(U,V) ) ).

fof(ax7,axiom,
    ! [U,V] :
      ( organism(U,V)
     <= human_person(U,V) ) ).

fof(ax19,axiom,
    ! [U,V] :
      ( weapon(U,V)
     => weaponry(U,V) ) ).

fof(ax16,axiom,
    ! [U,V] :
      ( artifact(U,V)
     => object(U,V) ) ).

fof(ax15,axiom,
    ! [U,V] :
      ( entity(U,V)
     <= object(U,V) ) ).

fof(ax34,axiom,
    ! [U,V] :
      ( animate(U,V)
     => ~ nonliving(U,V) ) ).

fof(ax29,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     => thing(U,V) ) ).

fof(ax10,axiom,
    ! [U,V] :
      ( object(U,V)
     => impartial(U,V) ) ).

fof(ax41,axiom,
    ! [U] :
      ~ ? [V] : member(U,V,V) ).

fof(ax6,axiom,
    ! [U,V] :
      ( organism(U,V)
     => entity(U,V) ) ).

fof(ax11,axiom,
    ! [U,V] :
      ( object(U,V)
     => nonliving(U,V) ) ).

fof(ax22,axiom,
    ! [U,V] :
      ( six(U,V)
     => group(U,V) ) ).

fof(ax27,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     => specific(U,V) ) ).

fof(co1,conjecture,
    ~ ? [U] :
        ( ? [V,W] :
            ( male(U,V)
            & six(U,W)
            & ! [X2] :
                ( shot(U,X2)
               <= member(U,X2,W) )
            & group(U,W)
            & ! [X,Y,Z] :
                ( ( cannon(U,Y)
                  & member(U,Z,W)
                  & of(U,Y,V)
                  & man(U,X) )
               => ? [X1] :
                    ( present(U,X1)
                    & nonreflexive(U,X1)
                    & fire(U,X1)
                    & from_loc(U,X1,Y)
                    & patient(U,X1,Z)
                    & agent(U,X1,X)
                    & event(U,X1) ) ) )
        & actual_world(U) ) ).

fof(ax8,axiom,
    ! [U,V] :
      ( human_person(U,V)
     <= man(U,V) ) ).

fof(ax35,axiom,
    ! [U,V] :
      ( ~ nonexistent(U,V)
     <= existent(U,V) ) ).

fof(ax30,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     <= event(U,V) ) ).

fof(ax23,axiom,
    ! [U,V] :
      ( multiple(U,V)
     <= set(U,V) ) ).

fof(ax40,axiom,
    ! [U,V] :
      ( six(U,V)
    <=> ? [W] :
          ( ? [X] :
              ( X != W
              & ? [Y] :
                  ( member(U,Y,V)
                  & X != Y
                  & ? [Z] :
                      ( ? [X1] :
                          ( ? [X2] :
                              ( X2 != X1
                              & X2 != Z
                              & Y != X2
                              & X2 != W
                              & ! [X3] :
                                  ( member(U,X3,V)
                                 => ( X2 = X3
                                    | X3 = Y
                                    | X3 = X
                                    | X3 = W
                                    | X3 = Z
                                    | X1 = X3 ) )
                              & X != X2
                              & member(U,X2,V) )
                          & X1 != W
                          & X1 != X
                          & X1 != Y
                          & Z != X1
                          & member(U,X1,V) )
                      & W != Z
                      & X != Z
                      & Y != Z
                      & member(U,Z,V) )
                  & W != Y )
              & member(U,X,V) )
          & member(U,W,V) ) ) ).

fof(ax38,axiom,
    ! [U,V] :
      ( ~ male(U,V)
     <= unisex(U,V) ) ).

