fof(ax46,axiom,
    ! [U,V,W,X] :
      ( ( nonreflexive(U,V)
        & patient(U,V,X)
        & agent(U,V,W) )
     => X != W ) ).

fof(ax2,axiom,
    ! [U,V] :
      ( animate(U,V)
     <= human_person(U,V) ) ).

fof(ax29,axiom,
    ! [U,V] :
      ( event(U,V)
     <= cry(U,V) ) ).

fof(ax27,axiom,
    ! [U,V] :
      ( action(U,V)
     => act(U,V) ) ).

fof(ax11,axiom,
    ! [U,V] :
      ( object(U,V)
     => nonliving(U,V) ) ).

fof(ax28,axiom,
    ! [U,V] :
      ( revenge(U,V)
     => action(U,V) ) ).

fof(ax39,axiom,
    ! [U,V] :
      ( animate(U,V)
     => ~ nonliving(U,V) ) ).

fof(ax33,axiom,
    ! [U,V] :
      ( specific(U,V)
     <= eventuality(U,V) ) ).

fof(ax41,axiom,
    ! [U,V] :
      ( ~ living(U,V)
     <= nonliving(U,V) ) ).

fof(ax37,axiom,
    ! [U,V] :
      ( event(U,V)
     <= sound(U,V) ) ).

fof(ax38,axiom,
    ! [U,V] :
      ( scream(U,V)
     => sound(U,V) ) ).

fof(ax35,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     => thing(U,V) ) ).

fof(ax1,axiom,
    ! [U,V] :
      ( male(U,V)
     <= man(U,V) ) ).

fof(ax16,axiom,
    ! [U,V] :
      ( artifact(U,V)
     => object(U,V) ) ).

fof(ax7,axiom,
    ! [U,V] :
      ( organism(U,V)
     <= human_person(U,V) ) ).

fof(ax24,axiom,
    ! [U,V] :
      ( group(U,V)
     => set(U,V) ) ).

fof(ax44,axiom,
    ! [U,V] :
      ( ? [W] :
          ( ? [X] :
              ( X != W
              & ? [Y] :
                  ( member(U,Y,V)
                  & W != Y
                  & ? [Z] :
                      ( member(U,Z,V)
                      & X != Z
                      & W != Z
                      & ? [X1] :
                          ( X1 != Y
                          & X != X1
                          & ? [X2] :
                              ( X2 != Z
                              & W != X2
                              & ! [X3] :
                                  ( member(U,X3,V)
                                 => ( X3 = X2
                                    | Z = X3
                                    | X3 = Y
                                    | X = X3
                                    | W = X3
                                    | X1 = X3 ) )
                              & X2 != X
                              & Y != X2
                              & X1 != X2
                              & member(U,X2,V) )
                          & X1 != W
                          & X1 != Z
                          & member(U,X1,V) )
                      & Y != Z )
                  & X != Y )
              & member(U,X,V) )
          & member(U,W,V) )
    <=> six(U,V) ) ).

fof(ax30,axiom,
    ! [U,V] :
      ( event(U,V)
     <= scream(U,V) ) ).

fof(ax23,axiom,
    ! [U,V] :
      ( set(U,V)
     => multiple(U,V) ) ).

fof(ax40,axiom,
    ! [U,V] :
      ( existent(U,V)
     => ~ nonexistent(U,V) ) ).

fof(ax14,axiom,
    ! [U,V] :
      ( thing(U,V)
     <= entity(U,V) ) ).

fof(ax6,axiom,
    ! [U,V] :
      ( organism(U,V)
     => entity(U,V) ) ).

fof(ax45,axiom,
    ! [U] :
      ~ ? [V] : member(U,V,V) ).

fof(ax10,axiom,
    ! [U,V] :
      ( impartial(U,V)
     <= object(U,V) ) ).

fof(ax8,axiom,
    ! [U,V] :
      ( man(U,V)
     => human_person(U,V) ) ).

fof(ax9,axiom,
    ! [U,V] :
      ( unisex(U,V)
     <= object(U,V) ) ).

fof(ax42,axiom,
    ! [U,V] :
      ( ~ multiple(U,V)
     <= singleton(U,V) ) ).

fof(ax25,axiom,
    ! [U,V] :
      ( shot(U,V)
     => action(U,V) ) ).

fof(ax18,axiom,
    ! [U,V] :
      ( weaponry(U,V)
     => instrumentality(U,V) ) ).

fof(ax43,axiom,
    ! [U,V] :
      ( ~ male(U,V)
     <= unisex(U,V) ) ).

fof(ax4,axiom,
    ! [U,V] :
      ( living(U,V)
     <= organism(U,V) ) ).

fof(ax36,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     <= event(U,V) ) ).

fof(ax19,axiom,
    ! [U,V] :
      ( weapon(U,V)
     => weaponry(U,V) ) ).

fof(co1,conjecture,
    ~ ? [U] :
        ( ? [V,W,X,Y,Z,X1] :
            ( male(U,X)
            & man(U,V)
            & of(U,W,V)
            & cannon(U,W)
            & ! [X2] :
                ( ? [X3] :
                    ( present(U,X3)
                    & nonreflexive(U,X3)
                    & fire(U,X3)
                    & from_loc(U,X3,W)
                    & patient(U,X3,X2)
                    & agent(U,X3,V)
                    & event(U,X3) )
               <= member(U,X2,X) )
            & group(U,X)
            & revenge(U,Z)
            & event(U,X1)
            & agent(U,X1,X)
            & nonreflexive(U,X1)
            & of(U,X1,Z)
            & scream(U,X1)
            & present(U,X1)
            & patient(U,X1,Y)
            & cry(U,Y)
            & ! [X4] :
                ( member(U,X4,X)
               => shot(U,X4) )
            & six(U,X)
            & male(U,V) )
        & actual_world(U) ) ).

fof(ax31,axiom,
    ! [U,V] :
      ( unisex(U,V)
     <= eventuality(U,V) ) ).

fof(ax13,axiom,
    ! [U,V] :
      ( specific(U,V)
     <= entity(U,V) ) ).

fof(ax22,axiom,
    ! [U,V] :
      ( six(U,V)
     => group(U,V) ) ).

fof(ax5,axiom,
    ! [U,V] :
      ( impartial(U,V)
     <= organism(U,V) ) ).

fof(ax21,axiom,
    ! [U,V] :
      ( event(U,V)
     <= fire(U,V) ) ).

fof(ax26,axiom,
    ! [U,V] :
      ( act(U,V)
     => event(U,V) ) ).

fof(ax20,axiom,
    ! [U,V] :
      ( weapon(U,V)
     <= cannon(U,V) ) ).

fof(ax34,axiom,
    ! [U,V] :
      ( singleton(U,V)
     <= thing(U,V) ) ).

fof(ax3,axiom,
    ! [U,V] :
      ( human_person(U,V)
     => human(U,V) ) ).

fof(ax17,axiom,
    ! [U,V] :
      ( instrumentality(U,V)
     => artifact(U,V) ) ).

fof(ax12,axiom,
    ! [U,V] :
      ( entity(U,V)
     => existent(U,V) ) ).

fof(ax32,axiom,
    ! [U,V] :
      ( nonexistent(U,V)
     <= eventuality(U,V) ) ).

fof(ax15,axiom,
    ! [U,V] :
      ( object(U,V)
     => entity(U,V) ) ).

