fof(ax33,axiom,
    ! [U,V] :
      ( specific(U,V)
     <= eventuality(U,V) ) ).

fof(ax23,axiom,
    ! [U,V] :
      ( set(U,V)
     => multiple(U,V) ) ).

fof(ax37,axiom,
    ! [U,V] :
      ( event(U,V)
     <= sound(U,V) ) ).

fof(ax43,axiom,
    ! [U,V] :
      ( unisex(U,V)
     => ~ male(U,V) ) ).

fof(ax31,axiom,
    ! [U,V] :
      ( unisex(U,V)
     <= eventuality(U,V) ) ).

fof(ax28,axiom,
    ! [U,V] :
      ( action(U,V)
     <= revenge(U,V) ) ).

fof(ax32,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     => nonexistent(U,V) ) ).

fof(ax40,axiom,
    ! [U,V] :
      ( existent(U,V)
     => ~ nonexistent(U,V) ) ).

fof(ax29,axiom,
    ! [U,V] :
      ( event(U,V)
     <= cry(U,V) ) ).

fof(ax42,axiom,
    ! [U,V] :
      ( singleton(U,V)
     => ~ multiple(U,V) ) ).

fof(ax41,axiom,
    ! [U,V] :
      ( nonliving(U,V)
     => ~ living(U,V) ) ).

fof(ax10,axiom,
    ! [U,V] :
      ( object(U,V)
     => impartial(U,V) ) ).

fof(ax35,axiom,
    ! [U,V] :
      ( thing(U,V)
     <= eventuality(U,V) ) ).

fof(ax27,axiom,
    ! [U,V] :
      ( act(U,V)
     <= action(U,V) ) ).

fof(ax9,axiom,
    ! [U,V] :
      ( unisex(U,V)
     <= object(U,V) ) ).

fof(ax11,axiom,
    ! [U,V] :
      ( object(U,V)
     => nonliving(U,V) ) ).

fof(ax18,axiom,
    ! [U,V] :
      ( weaponry(U,V)
     => instrumentality(U,V) ) ).

fof(ax24,axiom,
    ! [U,V] :
      ( group(U,V)
     => set(U,V) ) ).

fof(ax26,axiom,
    ! [U,V] :
      ( event(U,V)
     <= act(U,V) ) ).

fof(ax30,axiom,
    ! [U,V] :
      ( event(U,V)
     <= scream(U,V) ) ).

fof(ax13,axiom,
    ! [U,V] :
      ( specific(U,V)
     <= entity(U,V) ) ).

fof(ax45,axiom,
    ! [U] :
      ~ ? [V] : member(U,V,V) ).

fof(ax12,axiom,
    ! [U,V] :
      ( existent(U,V)
     <= entity(U,V) ) ).

fof(ax15,axiom,
    ! [U,V] :
      ( object(U,V)
     => entity(U,V) ) ).

fof(ax5,axiom,
    ! [U,V] :
      ( impartial(U,V)
     <= organism(U,V) ) ).

fof(ax3,axiom,
    ! [U,V] :
      ( human(U,V)
     <= human_person(U,V) ) ).

fof(ax16,axiom,
    ! [U,V] :
      ( object(U,V)
     <= artifact(U,V) ) ).

fof(ax39,axiom,
    ! [U,V] :
      ( ~ nonliving(U,V)
     <= animate(U,V) ) ).

fof(ax2,axiom,
    ! [U,V] :
      ( human_person(U,V)
     => animate(U,V) ) ).

fof(co1,conjecture,
    ~ ? [U] :
        ( actual_world(U)
        & ? [V,W,X,Y,Z,X1] :
            ( male(U,V)
            & man(U,V)
            & of(U,W,V)
            & ! [X4] :
                ( shot(U,X4)
               <= member(U,X4,X) )
            & cry(U,Y)
            & revenge(U,Z)
            & patient(U,X1,Y)
            & of(U,X1,Z)
            & scream(U,X1)
            & nonreflexive(U,X1)
            & present(U,X1)
            & agent(U,X1,V)
            & event(U,X1)
            & group(U,X)
            & six(U,X)
            & ! [X2] :
                ( ? [X3] :
                    ( patient(U,X3,X2)
                    & present(U,X3)
                    & from_loc(U,X3,W)
                    & fire(U,X3)
                    & nonreflexive(U,X3)
                    & agent(U,X3,V)
                    & event(U,X3) )
               <= member(U,X2,X) )
            & cannon(U,W) ) ) ).

fof(ax25,axiom,
    ! [U,V] :
      ( shot(U,V)
     => action(U,V) ) ).

fof(ax7,axiom,
    ! [U,V] :
      ( human_person(U,V)
     => organism(U,V) ) ).

fof(ax17,axiom,
    ! [U,V] :
      ( artifact(U,V)
     <= instrumentality(U,V) ) ).

fof(ax20,axiom,
    ! [U,V] :
      ( weapon(U,V)
     <= cannon(U,V) ) ).

fof(ax36,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     <= event(U,V) ) ).

fof(ax34,axiom,
    ! [U,V] :
      ( singleton(U,V)
     <= thing(U,V) ) ).

fof(ax8,axiom,
    ! [U,V] :
      ( man(U,V)
     => human_person(U,V) ) ).

fof(ax4,axiom,
    ! [U,V] :
      ( organism(U,V)
     => living(U,V) ) ).

fof(ax21,axiom,
    ! [U,V] :
      ( fire(U,V)
     => event(U,V) ) ).

fof(ax19,axiom,
    ! [U,V] :
      ( weaponry(U,V)
     <= weapon(U,V) ) ).

fof(ax46,axiom,
    ! [U,V,W,X] :
      ( W != X
     <= ( agent(U,V,W)
        & patient(U,V,X)
        & nonreflexive(U,V) ) ) ).

fof(ax22,axiom,
    ! [U,V] :
      ( six(U,V)
     => group(U,V) ) ).

fof(ax38,axiom,
    ! [U,V] :
      ( sound(U,V)
     <= scream(U,V) ) ).

fof(ax6,axiom,
    ! [U,V] :
      ( organism(U,V)
     => entity(U,V) ) ).

fof(ax14,axiom,
    ! [U,V] :
      ( entity(U,V)
     => thing(U,V) ) ).

fof(ax1,axiom,
    ! [U,V] :
      ( man(U,V)
     => male(U,V) ) ).

fof(ax44,axiom,
    ! [U,V] :
      ( six(U,V)
    <=> ? [W] :
          ( member(U,W,V)
          & ? [X] :
              ( member(U,X,V)
              & ? [Y] :
                  ( ? [Z] :
                      ( member(U,Z,V)
                      & Z != Y
                      & Z != W
                      & ? [X1] :
                          ( member(U,X1,V)
                          & Z != X1
                          & W != X1
                          & ? [X2] :
                              ( member(U,X2,V)
                              & X1 != X2
                              & X != X2
                              & ! [X3] :
                                  ( ( X3 = X2
                                    | X3 = X1
                                    | Z = X3
                                    | X = X3
                                    | W = X3
                                    | Y = X3 )
                                 <= member(U,X3,V) )
                              & W != X2
                              & Y != X2
                              & X2 != Z )
                          & X1 != X
                          & Y != X1 )
                      & X != Z )
                  & W != Y
                  & Y != X
                  & member(U,Y,V) )
              & X != W ) ) ) ).

