fof(ax16,axiom,
    ! [U,V] :
      ( artifact(U,V)
     => object(U,V) ) ).

fof(ax46,axiom,
    ! [U,V,W,X] :
      ( W != X
     <= ( agent(U,V,W)
        & patient(U,V,X)
        & nonreflexive(U,V) ) ) ).

fof(ax5,axiom,
    ! [U,V] :
      ( organism(U,V)
     => impartial(U,V) ) ).

fof(ax45,axiom,
    ! [U] :
      ~ ? [V] : member(U,V,V) ).

fof(ax40,axiom,
    ! [U,V] :
      ( existent(U,V)
     => ~ nonexistent(U,V) ) ).

fof(ax41,axiom,
    ! [U,V] :
      ( nonliving(U,V)
     => ~ living(U,V) ) ).

fof(ax13,axiom,
    ! [U,V] :
      ( specific(U,V)
     <= entity(U,V) ) ).

fof(ax21,axiom,
    ! [U,V] :
      ( fire(U,V)
     => event(U,V) ) ).

fof(ax14,axiom,
    ! [U,V] :
      ( thing(U,V)
     <= entity(U,V) ) ).

fof(ax19,axiom,
    ! [U,V] :
      ( weapon(U,V)
     => weaponry(U,V) ) ).

fof(ax23,axiom,
    ! [U,V] :
      ( set(U,V)
     => multiple(U,V) ) ).

fof(ax22,axiom,
    ! [U,V] :
      ( six(U,V)
     => group(U,V) ) ).

fof(ax30,axiom,
    ! [U,V] :
      ( event(U,V)
     <= scream(U,V) ) ).

fof(ax7,axiom,
    ! [U,V] :
      ( organism(U,V)
     <= human_person(U,V) ) ).

fof(ax3,axiom,
    ! [U,V] :
      ( human(U,V)
     <= human_person(U,V) ) ).

fof(ax25,axiom,
    ! [U,V] :
      ( shot(U,V)
     => action(U,V) ) ).

fof(ax17,axiom,
    ! [U,V] :
      ( artifact(U,V)
     <= instrumentality(U,V) ) ).

fof(ax42,axiom,
    ! [U,V] :
      ( ~ multiple(U,V)
     <= singleton(U,V) ) ).

fof(ax33,axiom,
    ! [U,V] :
      ( specific(U,V)
     <= eventuality(U,V) ) ).

fof(ax36,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     <= event(U,V) ) ).

fof(ax12,axiom,
    ! [U,V] :
      ( existent(U,V)
     <= entity(U,V) ) ).

fof(ax39,axiom,
    ! [U,V] :
      ( ~ nonliving(U,V)
     <= animate(U,V) ) ).

fof(co1,conjecture,
    ~ ( ? [U] :
          ( ? [V,W,X] :
              ( of(U,W,V)
              & group(U,X)
              & ! [X1] :
                  ( member(U,X1,X)
                 => shot(U,X1) )
              & six(U,X)
              & ! [Y] :
                  ( member(U,Y,X)
                 => ? [Z] :
                      ( agent(U,Z,V)
                      & patient(U,Z,Y)
                      & present(U,Z)
                      & nonreflexive(U,Z)
                      & from_loc(U,Z,W)
                      & fire(U,Z)
                      & event(U,Z) ) )
              & cannon(U,W)
              & man(U,V)
              & male(U,V) )
          & actual_world(U) )
      & ~ ? [X2] :
            ( actual_world(X2)
            & ? [X3,V,W,X,X4,X5,X6] :
                ( male(X2,X3)
                & ! [Y] :
                    ( ? [Z] :
                        ( event(X2,Z)
                        & agent(X2,Z,V)
                        & nonreflexive(X2,Z)
                        & from_loc(X2,Z,W)
                        & fire(X2,Z)
                        & present(X2,Z)
                        & patient(X2,Z,Y) )
                   <= member(X2,Y,X) )
                & group(X2,X)
                & ! [X1] :
                    ( shot(X2,X1)
                   <= member(X2,X1,X) )
                & revenge(X2,X4)
                & event(X2,X6)
                & patient(X2,X6,X5)
                & present(X2,X6)
                & nonreflexive(X2,X6)
                & scream(X2,X6)
                & of(X2,X6,X4)
                & agent(X2,X6,X3)
                & cry(X2,X5)
                & six(X2,X)
                & cannon(X2,W)
                & of(X2,W,V)
                & man(X2,V)
                & male(X2,V) ) ) ) ).

fof(ax1,axiom,
    ! [U,V] :
      ( man(U,V)
     => male(U,V) ) ).

fof(ax15,axiom,
    ! [U,V] :
      ( entity(U,V)
     <= object(U,V) ) ).

fof(ax24,axiom,
    ! [U,V] :
      ( set(U,V)
     <= group(U,V) ) ).

fof(ax37,axiom,
    ! [U,V] :
      ( sound(U,V)
     => event(U,V) ) ).

fof(ax34,axiom,
    ! [U,V] :
      ( thing(U,V)
     => singleton(U,V) ) ).

fof(ax18,axiom,
    ! [U,V] :
      ( instrumentality(U,V)
     <= weaponry(U,V) ) ).

fof(ax11,axiom,
    ! [U,V] :
      ( nonliving(U,V)
     <= object(U,V) ) ).

fof(ax35,axiom,
    ! [U,V] :
      ( thing(U,V)
     <= eventuality(U,V) ) ).

fof(ax43,axiom,
    ! [U,V] :
      ( ~ male(U,V)
     <= unisex(U,V) ) ).

fof(ax4,axiom,
    ! [U,V] :
      ( organism(U,V)
     => living(U,V) ) ).

fof(ax28,axiom,
    ! [U,V] :
      ( revenge(U,V)
     => action(U,V) ) ).

fof(ax2,axiom,
    ! [U,V] :
      ( animate(U,V)
     <= human_person(U,V) ) ).

fof(ax31,axiom,
    ! [U,V] :
      ( eventuality(U,V)
     => unisex(U,V) ) ).

fof(ax38,axiom,
    ! [U,V] :
      ( sound(U,V)
     <= scream(U,V) ) ).

fof(ax10,axiom,
    ! [U,V] :
      ( impartial(U,V)
     <= object(U,V) ) ).

fof(ax6,axiom,
    ! [U,V] :
      ( organism(U,V)
     => entity(U,V) ) ).

fof(ax29,axiom,
    ! [U,V] :
      ( cry(U,V)
     => event(U,V) ) ).

fof(ax44,axiom,
    ! [U,V] :
      ( ? [W] :
          ( ? [X] :
              ( ? [Y] :
                  ( member(U,Y,V)
                  & ? [Z] :
                      ( Y != Z
                      & Z != W
                      & ? [X1] :
                          ( X1 != Z
                          & Y != X1
                          & W != X1
                          & ? [X2] :
                              ( member(U,X2,V)
                              & X1 != X2
                              & Y != X2
                              & X != X2
                              & ! [X3] :
                                  ( member(U,X3,V)
                                 => ( X1 = X3
                                    | X3 = Y
                                    | W = X3
                                    | X3 = X
                                    | X3 = Z
                                    | X3 = X2 ) )
                              & X2 != W
                              & Z != X2 )
                          & X != X1
                          & member(U,X1,V) )
                      & Z != X
                      & member(U,Z,V) )
                  & W != Y
                  & Y != X )
              & W != X
              & member(U,X,V) )
          & member(U,W,V) )
    <=> six(U,V) ) ).

fof(ax32,axiom,
    ! [U,V] :
      ( nonexistent(U,V)
     <= eventuality(U,V) ) ).

fof(ax8,axiom,
    ! [U,V] :
      ( man(U,V)
     => human_person(U,V) ) ).

fof(ax9,axiom,
    ! [U,V] :
      ( object(U,V)
     => unisex(U,V) ) ).

fof(ax26,axiom,
    ! [U,V] :
      ( event(U,V)
     <= act(U,V) ) ).

fof(ax20,axiom,
    ! [U,V] :
      ( cannon(U,V)
     => weapon(U,V) ) ).

fof(ax27,axiom,
    ! [U,V] :
      ( action(U,V)
     => act(U,V) ) ).

