fof(n0_n2,axiom,
    n0 != n2 ).

fof(sum_symmetry,axiom,
    ! [X,Y] : sum(X,Y) = sum(Y,X) ).

fof(product_identity,axiom,
    ! [X] : product(X,n1) = X ).

fof(exponent_n1,axiom,
    ! [X] : n1 = exponent(n1,X) ).

fof(exponent_sum_product,axiom,
    ! [X,Y,Z] : product(exponent(X,Y),exponent(X,Z)) = exponent(X,sum(Y,Z)) ).

fof(wilkie,conjecture,
    ! [C,P,Q,R,S,A,B] :
      ( product(exponent(sum(exponent(P,A),exponent(Q,A)),B),exponent(sum(exponent(R,B),exponent(S,B)),A)) = product(exponent(sum(exponent(P,B),exponent(Q,B)),A),exponent(sum(exponent(R,A),exponent(S,A)),B))
     <= ( C = product(A,A)
        & sum(n1,product(A,C)) = R
        & S = sum(sum(n1,C),product(C,C))
        & lemmas(C,P,Q,R,S,B)
        & sum(P,C) = Q
        & P = sum(n1,A) ) ) ).

fof(n0_n1,axiom,
    n0 != n1 ).

fof(n1_n2,axiom,
    n1 != n2 ).

fof(product_associativity,axiom,
    ! [X,Y,Z] : product(product(X,Y),Z) = product(X,product(Y,Z)) ).

fof(sum_associativity,axiom,
    ! [X,Y,Z] : sum(sum(X,Y),Z) = sum(X,sum(Y,Z)) ).

fof(lemmas,axiom,
    ! [C,P,Q,R,S,B] :
      ( ( B != n0
        & n2 != B
        & ! [X] : product(n0,X) != B
        & ! [X] : Q != product(P,X)
        & ! [X] : S != product(R,X)
        & sum(n2,n0) != n1
        & C != n0
        & n0 != sum(n1,C)
        & sum(n2,n0) != sum(n1,n0)
        & sum(n1,n0) != C
        & C != sum(n1,C)
        & sum(n0,n0) != C
        & C != sum(n2,n0)
        & sum(n1,n0) != product(C,n0)
        & sum(n0,n0) != n0
        & n0 != sum(n2,n0)
        & n0 != sum(n1,n0)
        & product(C,n0) != n1
        & n1 != sum(n1,C)
        & n1 != C
        & n1 != sum(n0,n0)
        & sum(n1,n0) != n1
        & ! [X] : product(S,X) != R
        & ! [X] : product(Q,X) != P
        & n1 != B
        & sum(n1,n1) = n2 )
    <=> lemmas(C,P,Q,R,S,B) ) ).

fof(exponent_identity,axiom,
    ! [X] : X = exponent(X,n1) ).

fof(exponent_exponent,axiom,
    ! [X,Y,Z] : exponent(exponent(X,Y),Z) = exponent(X,product(Y,Z)) ).

fof(exponent_product_distribution,axiom,
    ! [X,Y,Z] : product(exponent(X,Z),exponent(Y,Z)) = exponent(product(X,Y),Z) ).

fof(sum_product_distribution,axiom,
    ! [X,Y,Z] : product(X,sum(Y,Z)) = sum(product(X,Y),product(X,Z)) ).

fof(product_symmetry,axiom,
    ! [X,Y] : product(Y,X) = product(X,Y) ).

