include('Axioms/LCL013^0.ax').
thf(a1,type,
    a1: $i > $i > $o ).

thf(a2,type,
    a2: $i > $i > $o ).

thf(a3,type,
    a3: $i > $i > $o ).

thf(jan,type,
    jan: mu ).

thf(piotr,type,
    piotr: mu ).

thf(cola,type,
    cola: mu ).

thf(pepsi,type,
    pepsi: mu ).

thf(beer,type,
    beer: mu ).

thf(likes,type,
    likes: mu > mu > $i > $o ).

thf(very_much_likes,type,
    very_much_likes: mu > mu > $i > $o ).

thf(possibly_likes,type,
    possibly_likes: mu > mu > $i > $o ).

thf(subrel,type,
    subrel: ( $i > $i > $o ) > ( $i > $i > $o ) > $o ).

thf(subrel_def,definition,
    ( subrel
    = ( ^ [R1: $i > $i > $o,R2: $i > $i > $o] :
        ! [X: $i,Y: $i] :
          ( ( R1 @ X @ Y )
         => ( R2 @ X @ Y ) ) ) ) ).

thf(cond4s,type,
    cond4s: ( $i > $i > $o ) > ( $i > $i > $o ) > $o ).

thf(cond4s_def,definition,
    ( cond4s
    = ( ^ [R1: $i > $i > $o,R2: $i > $i > $o] :
        ! [U: $i,V: $i,W: $i] :
          ( ( ( R1 @ U @ V )
            & ( R2 @ V @ W ) )
         => ( R2 @ U @ W ) ) ) ) ).

thf(axiom_I_a1_a3,axiom,
    subrel @ a1 @ a3 ).

thf(axiom_a2_3,axiom,
    mvalid @ ( mbox @ a1 @ ( likes @ piotr @ beer ) ) ).

thf(axioms_Is_a2_a2,axiom,
    cond4s @ a2 @ a2 ).

thf(axiom_user_communication_1,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] :
          ( mforall_ind
          @ ^ [Y: mu] : ( mimplies @ ( mbox @ a3 @ ( very_much_likes @ X @ Y ) ) @ ( very_much_likes @ X @ Y ) ) ) ) ) ).

thf(axiom_user_communication_4,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] :
          ( mforall_ind
          @ ^ [Y: mu] : ( mimplies @ ( mdia @ a2 @ ( likes @ X @ Y ) ) @ ( possibly_likes @ X @ Y ) ) ) ) ) ).

thf(axiom_a2_2,axiom,
    mvalid @ ( mbox @ a1 @ ( likes @ piotr @ cola ) ) ).

thf(axioms_D_a1,axiom,
    mserial @ a1 ).

thf(axioms_B_a3,axiom,
    msymmetric @ a3 ).

thf(axiom_a3_2,axiom,
    mvalid @ ( mdia @ a3 @ ( likes @ piotr @ pepsi ) ) ).

thf(axiom_user_communication_5,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] :
          ( mforall_ind
          @ ^ [Y: mu] : ( mimplies @ ( mdia @ a3 @ ( likes @ X @ Y ) ) @ ( possibly_likes @ X @ Y ) ) ) ) ) ).

thf(axiom_a1_1,axiom,
    mvalid @ ( mbox @ a1 @ ( likes @ jan @ cola ) ) ).

thf(axiom_a1_4,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] : ( mbox @ a1 @ ( mimplies @ ( mdia @ a1 @ ( likes @ X @ cola ) ) @ ( likes @ X @ pepsi ) ) ) ) ) ).

thf(axiom_user_communication_3,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] :
          ( mforall_ind
          @ ^ [Y: mu] : ( mimplies @ ( mdia @ a1 @ ( likes @ X @ Y ) ) @ ( possibly_likes @ X @ Y ) ) ) ) ) ).

thf(axioms_D_a3,axiom,
    mserial @ a3 ).

thf(axioms_B_a1,axiom,
    msymmetric @ a1 ).

thf(axiom_a2_4,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] : ( mbox @ a2 @ ( mimplies @ ( likes @ X @ pepsi ) @ ( likes @ X @ cola ) ) ) ) ) ).

thf(axioms_Is_a2_a1,axiom,
    cond4s @ a2 @ a1 ).

thf(axiom_a1_3,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] : ( mbox @ a1 @ ( mimplies @ ( mdia @ a1 @ ( likes @ X @ pepsi ) ) @ ( likes @ X @ cola ) ) ) ) ) ).

thf(axioms_Is_a3_a3,axiom,
    cond4s @ a3 @ a3 ).

thf(axiom_user_communication_2,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] :
          ( mforall_ind
          @ ^ [Y: mu] : ( mimplies @ ( mdia @ a3 @ ( very_much_likes @ X @ Y ) ) @ ( likes @ X @ Y ) ) ) ) ) ).

thf(axioms_Is_a3_a1,axiom,
    cond4s @ a1 @ a1 ).

thf(axioms_Is_a1_a1,axiom,
    cond4s @ a1 @ a1 ).

thf(axioms_Is_a1_a2,axiom,
    cond4s @ a1 @ a2 ).

thf(axiom_a3_4,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] :
          ( mforall_ind
          @ ^ [Y: mu] : ( mbox @ a3 @ ( mimplies @ ( mand @ ( likes @ X @ Y ) @ ( mand @ ( mbox @ a1 @ ( likes @ X @ Y ) ) @ ( mbox @ a2 @ ( likes @ X @ Y ) ) ) ) @ ( very_much_likes @ X @ Y ) ) ) ) ) ) ).

thf(axiom_a2_5,axiom,
    ( mvalid
    @ ( mforall_ind
      @ ^ [X: mu] : ( mbox @ a2 @ ( mimplies @ ( likes @ X @ cola ) @ ( likes @ X @ pepsi ) ) ) ) ) ).

thf(axiom_a2_1,axiom,
    mvalid @ ( mbox @ a2 @ ( likes @ jan @ pepsi ) ) ).

thf(axioms_Is_a1_a3,axiom,
    cond4s @ a1 @ a3 ).

thf(axiom_a3_1,axiom,
    mvalid @ ( mbox @ a3 @ ( likes @ jan @ cola ) ) ).

thf(axiom_I_a2_a3,axiom,
    subrel @ a2 @ a3 ).

thf(axioms_5_a2,axiom,
    meuclidean @ a2 ).

thf(axiom_a1_2,axiom,
    mvalid @ ( mbox @ a1 @ ( likes @ piotr @ pepsi ) ) ).

thf(axioms_B_a2,axiom,
    msymmetric @ a2 ).

thf(axioms_Is_a2_a3,axiom,
    cond4s @ a2 @ a3 ).

thf(axioms_5_a1,axiom,
    meuclidean @ a1 ).

thf(axioms_Is_a3_a2,axiom,
    cond4s @ a2 @ a2 ).

thf(axiom_a3_3,axiom,
    mvalid @ ( mdia @ a1 @ ( likes @ piotr @ beer ) ) ).

thf(axioms_D_a2,axiom,
    mserial @ a2 ).

thf(conj,conjecture,
    ( mvalid
    @ ( mexists_ind
      @ ^ [X: mu] :
          ( mexists_ind
          @ ^ [Y: mu] : ( very_much_likes @ X @ Y ) ) ) ) ).

thf(axioms_5_a3,axiom,
    meuclidean @ a3 ).

thf(axiom_I_a1_a2,axiom,
    subrel @ a1 @ a2 ).

