thf(numbers,type,
    num: $tType ).

thf(attribute_THFTYPE_i,type,
    attribute_THFTYPE_i: $i ).

thf(domain_THFTYPE_IIiioIiioI,type,
    domain_THFTYPE_IIiioIiioI: ( $i > $i > $o ) > $i > $i > $o ).

thf(domain_THFTYPE_IiiioI,type,
    domain_THFTYPE_IiiioI: $i > $i > $i > $o ).

thf(equal_THFTYPE_i,type,
    equal_THFTYPE_i: $i ).

thf(holdsDuring_THFTYPE_IiooI,type,
    holdsDuring_THFTYPE_IiooI: $i > $o > $o ).

thf(instance_THFTYPE_IIiioIioI,type,
    instance_THFTYPE_IIiioIioI: ( $i > $i > $o ) > $i > $o ).

thf(instance_THFTYPE_IIiooIioI,type,
    instance_THFTYPE_IIiooIioI: ( $i > $o > $o ) > $i > $o ).

thf(instance_THFTYPE_IiioI,type,
    instance_THFTYPE_IiioI: $i > $i > $o ).

thf(lAnna_THFTYPE_i,type,
    lAnna_THFTYPE_i: $i ).

thf(lAsymmetricRelation_THFTYPE_i,type,
    lAsymmetricRelation_THFTYPE_i: $i ).

thf(lBen_THFTYPE_i,type,
    lBen_THFTYPE_i: $i ).

thf(lBill_THFTYPE_i,type,
    lBill_THFTYPE_i: $i ).

thf(lBinaryPredicate_THFTYPE_i,type,
    lBinaryPredicate_THFTYPE_i: $i ).

thf(lBob_THFTYPE_i,type,
    lBob_THFTYPE_i: $i ).

thf(lMary_THFTYPE_i,type,
    lMary_THFTYPE_i: $i ).

thf(lOrganism_THFTYPE_i,type,
    lOrganism_THFTYPE_i: $i ).

thf(lSue_THFTYPE_i,type,
    lSue_THFTYPE_i: $i ).

thf(likes_THFTYPE_IiioI,type,
    likes_THFTYPE_IiioI: $i > $i > $o ).

thf(n1_THFTYPE_i,type,
    n1_THFTYPE_i: $i ).

thf(n2_THFTYPE_i,type,
    n2_THFTYPE_i: $i ).

thf(parent_THFTYPE_IiioI,type,
    parent_THFTYPE_IiioI: $i > $i > $o ).

thf(range_THFTYPE_IiioI,type,
    range_THFTYPE_IiioI: $i > $i > $o ).

thf(subclass_THFTYPE_IiioI,type,
    subclass_THFTYPE_IiioI: $i > $i > $o ).

thf(subrelation_THFTYPE_IIioIIioIoI,type,
    subrelation_THFTYPE_IIioIIioIoI: ( $i > $o ) > ( $i > $o ) > $o ).

thf(subrelation_THFTYPE_IiioI,type,
    subrelation_THFTYPE_IiioI: $i > $i > $o ).

thf(ax_031,axiom,
    instance_THFTYPE_IIiioIioI @ parent_THFTYPE_IiioI @ lAsymmetricRelation_THFTYPE_i ).

thf(ax_040,axiom,
    instance_THFTYPE_IIiioIioI @ subclass_THFTYPE_IiioI @ lBinaryPredicate_THFTYPE_i ).

thf(ax_037,axiom,
    domain_THFTYPE_IIiioIiioI @ parent_THFTYPE_IiioI @ n2_THFTYPE_i @ lOrganism_THFTYPE_i ).

thf(ax_027,axiom,
    parent_THFTYPE_IiioI @ lSue_THFTYPE_i @ lBen_THFTYPE_i ).

thf(ax_018,axiom,
    likes_THFTYPE_IiioI @ lMary_THFTYPE_i @ lBill_THFTYPE_i ).

thf(ax_030,axiom,
    ! [NUMBER: $i,PRED1: $i,CLASS1: $i,PRED2: $i] :
      ( ( domain_THFTYPE_IiiioI @ PRED1 @ NUMBER @ CLASS1 )
     <= ( ( subrelation_THFTYPE_IiioI @ PRED1 @ PRED2 )
        & ( domain_THFTYPE_IiiioI @ PRED2 @ NUMBER @ CLASS1 ) ) ) ).

thf(ax_029,axiom,
    parent_THFTYPE_IiioI @ lSue_THFTYPE_i @ lBen_THFTYPE_i ).

thf(ax,axiom,
    likes_THFTYPE_IiioI @ lSue_THFTYPE_i @ lBill_THFTYPE_i ).

thf(ax_014,axiom,
    ! [REL2: $i > $o,ROW: $i,REL1: $i > $o] :
      ( ( REL2 @ ROW )
     <= ( ( REL1 @ ROW )
        & ( subrelation_THFTYPE_IIioIIioIoI @ REL1 @ REL2 ) ) ) ).

thf(ax_017,axiom,
    likes_THFTYPE_IiioI @ lMary_THFTYPE_i @ lBill_THFTYPE_i ).

thf(ax_026,axiom,
    (~) @ ( parent_THFTYPE_IiioI @ lBob_THFTYPE_i @ lAnna_THFTYPE_i ) ).

thf(ax_034,axiom,
    instance_THFTYPE_IIiioIioI @ parent_THFTYPE_IiioI @ lBinaryPredicate_THFTYPE_i ).

thf(ax_003,axiom,
    (~) @ ( likes_THFTYPE_IiioI @ lSue_THFTYPE_i @ lMary_THFTYPE_i ) ).

thf(ax_010,axiom,
    (~) @ ( parent_THFTYPE_IiioI @ lBob_THFTYPE_i @ lBen_THFTYPE_i ) ).

thf(ax_015,axiom,
    ! [ORGANISM: $i] :
      ( ? [PARENT: $i] : ( parent_THFTYPE_IiioI @ ORGANISM @ PARENT )
     <= ( instance_THFTYPE_IiioI @ ORGANISM @ lOrganism_THFTYPE_i ) ) ).

thf(ax_038,axiom,
    instance_THFTYPE_IIiioIioI @ subrelation_THFTYPE_IiioI @ lBinaryPredicate_THFTYPE_i ).

thf(ax_041,axiom,
    instance_THFTYPE_IiioI @ attribute_THFTYPE_i @ lAsymmetricRelation_THFTYPE_i ).

thf(ax_036,axiom,
    instance_THFTYPE_IIiooIioI @ holdsDuring_THFTYPE_IiooI @ lAsymmetricRelation_THFTYPE_i ).

thf(ax_023,axiom,
    ! [CLASS: $i,CHILD: $i,PARENT: $i] :
      ( ( ( subclass_THFTYPE_IiioI @ CLASS @ lOrganism_THFTYPE_i )
        & ( instance_THFTYPE_IiioI @ PARENT @ CLASS )
        & ( parent_THFTYPE_IiioI @ CHILD @ PARENT ) )
     => ( instance_THFTYPE_IiioI @ CHILD @ CLASS ) ) ).

thf(ax_013,axiom,
    parent_THFTYPE_IiioI @ lSue_THFTYPE_i @ lAnna_THFTYPE_i ).

thf(ax_022,axiom,
    likes_THFTYPE_IiioI @ lBob_THFTYPE_i @ lBill_THFTYPE_i ).

thf(ax_039,axiom,
    instance_THFTYPE_IiioI @ equal_THFTYPE_i @ lBinaryPredicate_THFTYPE_i ).

thf(ax_021,axiom,
    likes_THFTYPE_IiioI @ lBob_THFTYPE_i @ lBill_THFTYPE_i ).

thf(ax_007,axiom,
    parent_THFTYPE_IiioI @ lMary_THFTYPE_i @ lBen_THFTYPE_i ).

thf(ax_020,axiom,
    ! [CLASS1: $i,REL: $i,CLASS2: $i] :
      ( ( ( range_THFTYPE_IiioI @ REL @ CLASS2 )
        & ( range_THFTYPE_IiioI @ REL @ CLASS1 ) )
     => ( ( subclass_THFTYPE_IiioI @ CLASS1 @ CLASS2 )
        | ( subclass_THFTYPE_IiioI @ CLASS2 @ CLASS1 ) ) ) ).

thf(con,conjecture,
    ? [Q: $i > $i > $o,R: $i > $i > $o,Y: $i] :
      ( ( R @ Y @ lBill_THFTYPE_i )
      & ( Q @ Y @ lAnna_THFTYPE_i )
      & ( (~)
        @ ! [A: $i,B: $i] : ( Q @ A @ B ) )
      & ( (~)
        @ ! [A: $i,B: $i] : ( R @ A @ B ) ) ) ).

thf(ax_005,axiom,
    parent_THFTYPE_IiioI @ lMary_THFTYPE_i @ lAnna_THFTYPE_i ).

thf(ax_032,axiom,
    instance_THFTYPE_IIiioIioI @ range_THFTYPE_IiioI @ lAsymmetricRelation_THFTYPE_i ).

thf(ax_025,axiom,
    (~) @ ( parent_THFTYPE_IiioI @ lBob_THFTYPE_i @ lAnna_THFTYPE_i ) ).

thf(ax_012,axiom,
    parent_THFTYPE_IiioI @ lSue_THFTYPE_i @ lAnna_THFTYPE_i ).

thf(ax_043,axiom,
    instance_THFTYPE_IIiooIioI @ holdsDuring_THFTYPE_IiooI @ lBinaryPredicate_THFTYPE_i ).

thf(ax_009,axiom,
    ! [CLASS1: $i,CLASS2: $i] :
      ( ( CLASS1 = CLASS2 )
     => ! [THING: $i] :
          ( ( instance_THFTYPE_IiioI @ THING @ CLASS2 )
        <=> ( instance_THFTYPE_IiioI @ THING @ CLASS1 ) ) ) ).

thf(ax_002,axiom,
    (~) @ ( likes_THFTYPE_IiioI @ lSue_THFTYPE_i @ lMary_THFTYPE_i ) ).

thf(ax_042,axiom,
    instance_THFTYPE_IIiioIioI @ instance_THFTYPE_IiioI @ lBinaryPredicate_THFTYPE_i ).

thf(ax_019,axiom,
    ! [THING2: $i,THING1: $i] :
      ( ! [CLASS: $i] :
          ( ( instance_THFTYPE_IiioI @ THING1 @ CLASS )
        <=> ( instance_THFTYPE_IiioI @ THING2 @ CLASS ) )
     <= ( THING1 = THING2 ) ) ).

thf(ax_035,axiom,
    domain_THFTYPE_IIiioIiioI @ parent_THFTYPE_IiioI @ n1_THFTYPE_i @ lOrganism_THFTYPE_i ).

thf(ax_011,axiom,
    (~) @ ( parent_THFTYPE_IiioI @ lBob_THFTYPE_i @ lBen_THFTYPE_i ) ).

thf(ax_033,axiom,
    instance_THFTYPE_IIiioIioI @ range_THFTYPE_IiioI @ lBinaryPredicate_THFTYPE_i ).

thf(ax_016,axiom,
    ! [TIME: $i,SITUATION: $o] :
      ( ( (~) @ ( holdsDuring_THFTYPE_IiooI @ TIME @ SITUATION ) )
     <= ( holdsDuring_THFTYPE_IiooI @ TIME @ ( (~) @ SITUATION ) ) ) ).

thf(ax_001,axiom,
    likes_THFTYPE_IiioI @ lSue_THFTYPE_i @ lBill_THFTYPE_i ).

thf(ax_008,axiom,
    parent_THFTYPE_IiioI @ lMary_THFTYPE_i @ lBen_THFTYPE_i ).

thf(ax_024,axiom,
    ! [REL2: $i,CLASS1: $i,REL1: $i] :
      ( ( ( range_THFTYPE_IiioI @ REL2 @ CLASS1 )
        & ( subrelation_THFTYPE_IiioI @ REL1 @ REL2 ) )
     => ( range_THFTYPE_IiioI @ REL1 @ CLASS1 ) ) ).

thf(ax_028,axiom,
    ! [NUMBER: $i,CLASS1: $i,REL: $i,CLASS2: $i] :
      ( ( ( domain_THFTYPE_IiiioI @ REL @ NUMBER @ CLASS1 )
        & ( domain_THFTYPE_IiiioI @ REL @ NUMBER @ CLASS2 ) )
     => ( ( subclass_THFTYPE_IiioI @ CLASS1 @ CLASS2 )
        | ( subclass_THFTYPE_IiioI @ CLASS2 @ CLASS1 ) ) ) ).

thf(ax_006,axiom,
    ! [X: $i,Y: $i,Z: $i] :
      ( ( ( instance_THFTYPE_IiioI @ Z @ X )
        & ( subclass_THFTYPE_IiioI @ X @ Y ) )
     => ( instance_THFTYPE_IiioI @ Z @ Y ) ) ).

thf(ax_004,axiom,
    parent_THFTYPE_IiioI @ lMary_THFTYPE_i @ lAnna_THFTYPE_i ).

