include('Axioms/LCL015^0.ax').
include('Axioms/LCL013^5.ax').
include('Axioms/LCL015^1.ax').
thf(teach_type,type,
    teach: mu > mu > $i > $o ).

thf(sue_type,type,
    sue: mu ).

thf(psych_type,type,
    psych: mu ).

thf(mary_type,type,
    mary: mu ).

thf(math_type,type,
    math: mu ).

thf(john_type,type,
    john: mu ).

thf(cs_type,type,
    cs: mu ).

thf(existence_of_john_ax,axiom,
    ! [V: $i] : ( exists_in_world @ john @ V ) ).

thf(existence_of_math_ax,axiom,
    ! [V: $i] : ( exists_in_world @ math @ V ) ).

thf(existence_of_sue_ax,axiom,
    ! [V: $i] : ( exists_in_world @ sue @ V ) ).

thf(query,conjecture,
    ( mvalid
    @ ( mbox_s4
      @ ( mexists_ind
        @ ^ [X: mu] : ( teach @ X @ cs ) ) ) ) ).

thf(db,axiom,
    ( mvalid
    @ ( mbox_s4
      @ ( mand @ ( teach @ john @ math )
        @ ( mand
          @ ( mexists_ind
            @ ^ [X: mu] : ( teach @ X @ cs ) )
          @ ( mand @ ( teach @ mary @ psych ) @ ( teach @ sue @ psych ) ) ) ) ) ) ).

thf(existence_of_psych_ax,axiom,
    ! [V: $i] : ( exists_in_world @ psych @ V ) ).

thf(existence_of_cs_ax,axiom,
    ! [V: $i] : ( exists_in_world @ cs @ V ) ).

thf(existence_of_mary_ax,axiom,
    ! [V: $i] : ( exists_in_world @ mary @ V ) ).

