thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(eiw_di_type,type,
    eiw_di: $i > mworld > $o ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] :
          ( ( eiw_di @ X @ W )
         => ( A @ X @ W ) ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] :
          ( ( eiw_di @ X @ W )
          & ( A @ X @ W ) ) ) ) ).

thf(chevy_decl,type,
    chevy: $i > mworld > $o ).

thf(dirty_decl,type,
    dirty: $i > mworld > $o ).

thf(barrel_decl,type,
    barrel: $i > $i > mworld > $o ).

thf(hollywood_decl,type,
    hollywood: $i > mworld > $o ).

thf(city_decl,type,
    city: $i > mworld > $o ).

thf(in_decl,type,
    in: $i > $i > mworld > $o ).

thf(young_decl,type,
    young: $i > mworld > $o ).

thf(old_decl,type,
    old: $i > mworld > $o ).

thf(down_decl,type,
    down: $i > $i > mworld > $o ).

thf(way_decl,type,
    way: $i > mworld > $o ).

thf(qmltpeq_decl,type,
    qmltpeq: $i > $i > mworld > $o ).

thf(seat_decl,type,
    seat: $i > mworld > $o ).

thf(white_decl,type,
    white: $i > mworld > $o ).

thf(car_decl,type,
    car: $i > mworld > $o ).

thf(furniture_decl,type,
    furniture: $i > mworld > $o ).

thf(street_decl,type,
    street: $i > mworld > $o ).

thf(fellow_decl,type,
    fellow: $i > mworld > $o ).

thf(front_decl,type,
    front: $i > mworld > $o ).

thf(man_decl,type,
    man: $i > mworld > $o ).

thf(event_decl,type,
    event: $i > mworld > $o ).

thf(lonely_decl,type,
    lonely: $i > mworld > $o ).

thf(barrel_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( barrel @ A @ C ) ) ) @ ( mbox @ ( barrel @ B @ C ) ) ) ) ) ) ) ) ) ) ) ).

thf(man_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( man @ A ) ) ) @ ( mbox @ ( man @ B ) ) ) ) ) ) ) ) ) ).

thf(transitivity,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [Y: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [Z: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ X @ Y ) ) @ ( mbox @ ( qmltpeq @ Y @ Z ) ) ) @ ( mbox @ ( qmltpeq @ X @ Z ) ) ) ) ) ) ) ) ) ) ) ).

thf(down_substitution_2,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( down @ C @ A ) ) ) @ ( mbox @ ( down @ C @ B ) ) ) ) ) ) ) ) ) ) ) ).

thf(hollywood_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( hollywood @ A ) ) ) @ ( mbox @ ( hollywood @ B ) ) ) ) ) ) ) ) ) ).

thf(old_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( old @ A ) ) ) @ ( mbox @ ( old @ B ) ) ) ) ) ) ) ) ) ).

thf(in_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( in @ A @ C ) ) ) @ ( mbox @ ( in @ B @ C ) ) ) ) ) ) ) ) ) ) ) ).

thf(white_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( white @ A ) ) ) @ ( mbox @ ( white @ B ) ) ) ) ) ) ) ) ) ).

thf(street_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( street @ A ) ) ) @ ( mbox @ ( street @ B ) ) ) ) ) ) ) ) ) ).

thf(seat_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( seat @ A ) ) ) @ ( mbox @ ( seat @ B ) ) ) ) ) ) ) ) ) ).

thf(mrel_transitive,axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( ( mrel @ W @ V )
        & ( mrel @ V @ U ) )
     => ( mrel @ W @ U ) ) ).

thf(fellow_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( fellow @ A ) ) ) @ ( mbox @ ( fellow @ B ) ) ) ) ) ) ) ) ) ).

thf(lonely_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( lonely @ A ) ) ) @ ( mbox @ ( lonely @ B ) ) ) ) ) ) ) ) ) ).

thf(reflexivity,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] : ( mbox @ ( qmltpeq @ X @ X ) ) ) ) ) ).

thf(in_substitution_2,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( in @ C @ A ) ) ) @ ( mbox @ ( in @ C @ B ) ) ) ) ) ) ) ) ) ) ) ).

thf(furniture_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( furniture @ A ) ) ) @ ( mbox @ ( furniture @ B ) ) ) ) ) ) ) ) ) ).

thf(down_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( down @ A @ C ) ) ) @ ( mbox @ ( down @ B @ C ) ) ) ) ) ) ) ) ) ) ) ).

thf(dirty_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( dirty @ A ) ) ) @ ( mbox @ ( dirty @ B ) ) ) ) ) ) ) ) ) ).

thf(chevy_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( chevy @ A ) ) ) @ ( mbox @ ( chevy @ B ) ) ) ) ) ) ) ) ) ).

thf(front_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( front @ A ) ) ) @ ( mbox @ ( front @ B ) ) ) ) ) ) ) ) ) ).

thf(symmetry,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [Y: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ X @ Y ) ) @ ( mbox @ ( qmltpeq @ Y @ X ) ) ) ) ) ) ) ) ) ).

thf(co1,conjecture,
    ( mlocal
    @ ( mand
      @ ( mbox
        @ ( mimplies
          @ ( mexists_di
            @ ^ [U: $i] :
                ( mexists_di
                @ ^ [V: $i] :
                    ( mexists_di
                    @ ^ [W: $i] :
                        ( mexists_di
                        @ ^ [X: $i] :
                            ( mexists_di
                            @ ^ [Y: $i] :
                                ( mexists_di
                                @ ^ [Z: $i] :
                                    ( mexists_di
                                    @ ^ [X1: $i] :
                                        ( mexists_di
                                        @ ^ [X2: $i] :
                                            ( mexists_di
                                            @ ^ [X3: $i] : ( mand @ ( mbox @ ( hollywood @ U ) ) @ ( mand @ ( mbox @ ( city @ U ) ) @ ( mand @ ( mbox @ ( event @ V ) ) @ ( mand @ ( mbox @ ( street @ W ) ) @ ( mand @ ( mbox @ ( way @ W ) ) @ ( mand @ ( mbox @ ( lonely @ W ) ) @ ( mand @ ( mbox @ ( chevy @ X ) ) @ ( mand @ ( mbox @ ( car @ X ) ) @ ( mand @ ( mbox @ ( white @ X ) ) @ ( mand @ ( mbox @ ( dirty @ X ) ) @ ( mand @ ( mbox @ ( old @ X ) ) @ ( mand @ ( mbox @ ( barrel @ V @ X ) ) @ ( mand @ ( mbox @ ( down @ V @ W ) ) @ ( mand @ ( mbox @ ( in @ V @ U ) ) @ ( mand @ ( mbox @ ( seat @ X1 ) ) @ ( mand @ ( mbox @ ( furniture @ X1 ) ) @ ( mand @ ( mbox @ ( front @ X1 ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ Y @ Z ) ) ) ) @ ( mand @ ( mbox @ ( fellow @ Y ) ) @ ( mand @ ( mbox @ ( man @ Y ) ) @ ( mand @ ( mbox @ ( young @ Y ) ) @ ( mand @ ( mbox @ ( fellow @ Z ) ) @ ( mand @ ( mbox @ ( man @ Z ) ) @ ( mand @ ( mbox @ ( young @ Z ) ) @ ( mand @ ( mbox @ ( qmltpeq @ Y @ X2 ) ) @ ( mand @ ( mbox @ ( in @ X2 @ X1 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ Z @ X3 ) ) @ ( mbox @ ( in @ X3 @ X1 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
          @ ( mexists_di
            @ ^ [X4: $i] :
                ( mexists_di
                @ ^ [X5: $i] :
                    ( mexists_di
                    @ ^ [X6: $i] :
                        ( mexists_di
                        @ ^ [X7: $i] :
                            ( mexists_di
                            @ ^ [X8: $i] :
                                ( mexists_di
                                @ ^ [X9: $i] :
                                    ( mexists_di
                                    @ ^ [X10: $i] :
                                        ( mexists_di
                                        @ ^ [X11: $i] :
                                            ( mexists_di
                                            @ ^ [X12: $i] : ( mand @ ( mbox @ ( hollywood @ X4 ) ) @ ( mand @ ( mbox @ ( city @ X4 ) ) @ ( mand @ ( mbox @ ( event @ X5 ) ) @ ( mand @ ( mbox @ ( chevy @ X6 ) ) @ ( mand @ ( mbox @ ( car @ X6 ) ) @ ( mand @ ( mbox @ ( white @ X6 ) ) @ ( mand @ ( mbox @ ( dirty @ X6 ) ) @ ( mand @ ( mbox @ ( old @ X6 ) ) @ ( mand @ ( mbox @ ( street @ X7 ) ) @ ( mand @ ( mbox @ ( way @ X7 ) ) @ ( mand @ ( mbox @ ( lonely @ X7 ) ) @ ( mand @ ( mbox @ ( barrel @ X5 @ X6 ) ) @ ( mand @ ( mbox @ ( down @ X5 @ X7 ) ) @ ( mand @ ( mbox @ ( in @ X5 @ X4 ) ) @ ( mand @ ( mbox @ ( seat @ X10 ) ) @ ( mand @ ( mbox @ ( furniture @ X10 ) ) @ ( mand @ ( mbox @ ( front @ X10 ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ X8 @ X9 ) ) ) ) @ ( mand @ ( mbox @ ( fellow @ X8 ) ) @ ( mand @ ( mbox @ ( man @ X8 ) ) @ ( mand @ ( mbox @ ( young @ X8 ) ) @ ( mand @ ( mbox @ ( fellow @ X9 ) ) @ ( mand @ ( mbox @ ( man @ X9 ) ) @ ( mand @ ( mbox @ ( young @ X9 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ X8 @ X11 ) ) @ ( mand @ ( mbox @ ( in @ X11 @ X10 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ X9 @ X12 ) ) @ ( mbox @ ( in @ X12 @ X10 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
      @ ( mbox
        @ ( mimplies
          @ ( mexists_di
            @ ^ [X13: $i] :
                ( mexists_di
                @ ^ [X14: $i] :
                    ( mexists_di
                    @ ^ [X15: $i] :
                        ( mexists_di
                        @ ^ [X16: $i] :
                            ( mexists_di
                            @ ^ [X17: $i] :
                                ( mexists_di
                                @ ^ [X18: $i] :
                                    ( mexists_di
                                    @ ^ [X19: $i] :
                                        ( mexists_di
                                        @ ^ [X20: $i] :
                                            ( mexists_di
                                            @ ^ [X21: $i] : ( mand @ ( mbox @ ( hollywood @ X13 ) ) @ ( mand @ ( mbox @ ( city @ X13 ) ) @ ( mand @ ( mbox @ ( event @ X14 ) ) @ ( mand @ ( mbox @ ( chevy @ X15 ) ) @ ( mand @ ( mbox @ ( car @ X15 ) ) @ ( mand @ ( mbox @ ( white @ X15 ) ) @ ( mand @ ( mbox @ ( dirty @ X15 ) ) @ ( mand @ ( mbox @ ( old @ X15 ) ) @ ( mand @ ( mbox @ ( street @ X16 ) ) @ ( mand @ ( mbox @ ( way @ X16 ) ) @ ( mand @ ( mbox @ ( lonely @ X16 ) ) @ ( mand @ ( mbox @ ( barrel @ X14 @ X15 ) ) @ ( mand @ ( mbox @ ( down @ X14 @ X16 ) ) @ ( mand @ ( mbox @ ( in @ X14 @ X13 ) ) @ ( mand @ ( mbox @ ( seat @ X19 ) ) @ ( mand @ ( mbox @ ( furniture @ X19 ) ) @ ( mand @ ( mbox @ ( front @ X19 ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ X17 @ X18 ) ) ) ) @ ( mand @ ( mbox @ ( fellow @ X17 ) ) @ ( mand @ ( mbox @ ( man @ X17 ) ) @ ( mand @ ( mbox @ ( young @ X17 ) ) @ ( mand @ ( mbox @ ( fellow @ X18 ) ) @ ( mand @ ( mbox @ ( man @ X18 ) ) @ ( mand @ ( mbox @ ( young @ X18 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ X17 @ X20 ) ) @ ( mand @ ( mbox @ ( in @ X20 @ X19 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ X18 @ X21 ) ) @ ( mbox @ ( in @ X21 @ X19 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
          @ ( mexists_di
            @ ^ [X22: $i] :
                ( mexists_di
                @ ^ [X23: $i] :
                    ( mexists_di
                    @ ^ [X24: $i] :
                        ( mexists_di
                        @ ^ [X25: $i] :
                            ( mexists_di
                            @ ^ [X26: $i] :
                                ( mexists_di
                                @ ^ [X27: $i] :
                                    ( mexists_di
                                    @ ^ [X28: $i] :
                                        ( mexists_di
                                        @ ^ [X29: $i] :
                                            ( mexists_di
                                            @ ^ [X30: $i] : ( mand @ ( mbox @ ( hollywood @ X22 ) ) @ ( mand @ ( mbox @ ( city @ X22 ) ) @ ( mand @ ( mbox @ ( event @ X23 ) ) @ ( mand @ ( mbox @ ( street @ X24 ) ) @ ( mand @ ( mbox @ ( way @ X24 ) ) @ ( mand @ ( mbox @ ( lonely @ X24 ) ) @ ( mand @ ( mbox @ ( chevy @ X25 ) ) @ ( mand @ ( mbox @ ( car @ X25 ) ) @ ( mand @ ( mbox @ ( white @ X25 ) ) @ ( mand @ ( mbox @ ( dirty @ X25 ) ) @ ( mand @ ( mbox @ ( old @ X25 ) ) @ ( mand @ ( mbox @ ( barrel @ X23 @ X25 ) ) @ ( mand @ ( mbox @ ( down @ X23 @ X24 ) ) @ ( mand @ ( mbox @ ( in @ X23 @ X22 ) ) @ ( mand @ ( mbox @ ( seat @ X28 ) ) @ ( mand @ ( mbox @ ( furniture @ X28 ) ) @ ( mand @ ( mbox @ ( front @ X28 ) ) @ ( mand @ ( mbox @ ( mnot @ ( mbox @ ( qmltpeq @ X26 @ X27 ) ) ) ) @ ( mand @ ( mbox @ ( fellow @ X26 ) ) @ ( mand @ ( mbox @ ( man @ X26 ) ) @ ( mand @ ( mbox @ ( young @ X26 ) ) @ ( mand @ ( mbox @ ( fellow @ X27 ) ) @ ( mand @ ( mbox @ ( man @ X27 ) ) @ ( mand @ ( mbox @ ( young @ X27 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ X26 @ X29 ) ) @ ( mand @ ( mbox @ ( in @ X29 @ X28 ) ) @ ( mand @ ( mbox @ ( qmltpeq @ X27 @ X30 ) ) @ ( mbox @ ( in @ X30 @ X28 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(barrel_substitution_2,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( barrel @ C @ A ) ) ) @ ( mbox @ ( barrel @ C @ B ) ) ) ) ) ) ) ) ) ) ) ).

thf(young_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( young @ A ) ) ) @ ( mbox @ ( young @ B ) ) ) ) ) ) ) ) ) ).

thf(city_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( city @ A ) ) ) @ ( mbox @ ( city @ B ) ) ) ) ) ) ) ) ) ).

thf(mrel_reflexive,axiom,
    ! [W: mworld] : ( mrel @ W @ W ) ).

thf(car_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( car @ A ) ) ) @ ( mbox @ ( car @ B ) ) ) ) ) ) ) ) ) ).

thf(eiw_di_nonempty,axiom,
    ! [W: mworld] :
    ? [X: $i] : ( eiw_di @ X @ W ) ).

thf(way_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( way @ A ) ) ) @ ( mbox @ ( way @ B ) ) ) ) ) ) ) ) ) ).

thf(event_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( event @ A ) ) ) @ ( mbox @ ( event @ B ) ) ) ) ) ) ) ) ) ).

