thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(eiw_di_type,type,
    eiw_di: $i > mworld > $o ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] :
          ( ( eiw_di @ X @ W )
         => ( A @ X @ W ) ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] :
          ( ( eiw_di @ X @ W )
          & ( A @ X @ W ) ) ) ) ).

thf(qmltpeq_decl,type,
    qmltpeq: $i > $i > mworld > $o ).

thf(member_decl,type,
    member: $i > $i > mworld > $o ).

thf(subset_decl,type,
    subset: $i > $i > mworld > $o ).

thf(union_decl,type,
    union: $i > $i > $i ).

thf(transitivity,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [Y: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [Z: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ X @ Y ) ) @ ( mbox @ ( qmltpeq @ Y @ Z ) ) ) @ ( mbox @ ( qmltpeq @ X @ Z ) ) ) ) ) ) ) ) ) ) ) ).

thf(eiw_di_nonempty,axiom,
    ! [W: mworld] :
    ? [X: $i] : ( eiw_di @ X @ W ) ).

thf(commutativity_of_union,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] : ( mbox @ ( qmltpeq @ ( union @ B @ C ) @ ( union @ C @ B ) ) ) ) ) ) ) ) ).

thf(subset_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( subset @ A @ C ) ) ) @ ( mbox @ ( subset @ B @ C ) ) ) ) ) ) ) ) ) ) ) ).

thf(reflexivity_of_subset,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] : ( mbox @ ( subset @ B @ B ) ) ) ) ) ).

thf(reflexivity,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] : ( mbox @ ( qmltpeq @ X @ X ) ) ) ) ) ).

thf(subset_union,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mbox @ ( subset @ B @ C ) ) @ ( mbox @ ( qmltpeq @ ( union @ B @ C ) @ C ) ) ) ) ) ) ) ) ) ).

thf(union_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( qmltpeq @ ( union @ A @ C ) @ ( union @ B @ C ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(equal_member_defn,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] :
                  ( mand
                  @ ( mbox
                    @ ( mimplies @ ( mbox @ ( qmltpeq @ B @ C ) )
                      @ ( mbox
                        @ ( mforall_di
                          @ ^ [D: $i] : ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) ) @ ( mbox @ ( mimplies @ ( mbox @ ( member @ D @ C ) ) @ ( mbox @ ( member @ D @ B ) ) ) ) ) ) ) ) )
                  @ ( mbox
                    @ ( mimplies
                      @ ( mbox
                        @ ( mforall_di
                          @ ^ [D: $i] : ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) ) @ ( mbox @ ( mimplies @ ( mbox @ ( member @ D @ C ) ) @ ( mbox @ ( member @ D @ B ) ) ) ) ) ) )
                      @ ( mbox @ ( qmltpeq @ B @ C ) ) ) ) ) ) ) ) ) ) ).

thf(subset_substitution_2,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( subset @ C @ A ) ) ) @ ( mbox @ ( subset @ C @ B ) ) ) ) ) ) ) ) ) ) ) ).

thf(subset_defn,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] :
                  ( mand
                  @ ( mbox
                    @ ( mimplies @ ( mbox @ ( subset @ B @ C ) )
                      @ ( mbox
                        @ ( mforall_di
                          @ ^ [D: $i] : ( mbox @ ( mimplies @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) ) ) ) ) )
                  @ ( mbox
                    @ ( mimplies
                      @ ( mbox
                        @ ( mforall_di
                          @ ^ [D: $i] : ( mbox @ ( mimplies @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) ) ) )
                      @ ( mbox @ ( subset @ B @ C ) ) ) ) ) ) ) ) ) ) ).

thf(mrel_transitive,axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( ( mrel @ W @ V )
        & ( mrel @ V @ U ) )
     => ( mrel @ W @ U ) ) ).

thf(member_substitution_1,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( member @ A @ C ) ) ) @ ( mbox @ ( member @ B @ C ) ) ) ) ) ) ) ) ) ) ) ).

thf(prove_idempotency_of_union,conjecture,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] : ( mbox @ ( qmltpeq @ ( union @ B @ B ) @ B ) ) ) ) ) ).

thf(union_substitution_2,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( qmltpeq @ ( union @ C @ A ) @ ( union @ C @ B ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(symmetry,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [X: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [Y: $i] : ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ X @ Y ) ) @ ( mbox @ ( qmltpeq @ Y @ X ) ) ) ) ) ) ) ) ) ).

thf(mrel_reflexive,axiom,
    ! [W: mworld] : ( mrel @ W @ W ) ).

thf(union_defn,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [D: $i] : ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( member @ D @ ( union @ B @ C ) ) ) @ ( mor @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) ) ) @ ( mbox @ ( mimplies @ ( mor @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) @ ( mbox @ ( member @ D @ ( union @ B @ C ) ) ) ) ) ) ) ) ) ) ) ) ) ).

thf(member_substitution_2,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [A: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [B: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( qmltpeq @ A @ B ) ) @ ( mbox @ ( member @ C @ A ) ) ) @ ( mbox @ ( member @ C @ B ) ) ) ) ) ) ) ) ) ) ) ).

thf(equal_defn,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] : ( mand @ ( mbox @ ( mimplies @ ( mbox @ ( qmltpeq @ B @ C ) ) @ ( mand @ ( mbox @ ( subset @ B @ C ) ) @ ( mbox @ ( subset @ C @ B ) ) ) ) ) @ ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( subset @ B @ C ) ) @ ( mbox @ ( subset @ C @ B ) ) ) @ ( mbox @ ( qmltpeq @ B @ C ) ) ) ) ) ) ) ) ) ) ).

