thf(mworld,type,
    mworld: $tType ).

thf(mindex,type,
    mindex: $tType ).

thf(mrel_type,type,
    mrel: mindex > mworld > mworld > $o ).

thf('#b_type',type,
    '#b': mindex ).

thf('#a_type',type,
    '#a': mindex ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: mindex > ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [R: mindex,Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ R @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: mindex > ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [R: mindex,Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ R @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(p_decl,type,
    p: mworld > $o ).

thf('mrel_#a_reflexive',axiom,
    ! [W: mworld] : ( mrel @ '#a' @ W @ W ) ).

thf(not_a_axiom_1,axiom,
    mlocal @ ( mnot @ p ) ).

thf(ab_axiom_2,axiom,
    mlocal @ ( mimplies @ ( mnot @ ( mbox @ '#b' @ p ) ) @ ( mbox @ '#a' @ ( mnot @ ( mbox @ '#b' @ p ) ) ) ) ).

thf(ab_axiom_1,axiom,
    mlocal @ ( mbox @ '#a' @ ( mimplies @ p @ ( mbox @ '#b' @ p ) ) ) ).

thf('mrel_#a_transitive',axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( mrel @ '#a' @ W @ U )
     <= ( ( mrel @ '#a' @ V @ U )
        & ( mrel @ '#a' @ W @ V ) ) ) ).

thf('mrel_#b_reflexive',axiom,
    ! [W: mworld] : ( mrel @ '#b' @ W @ W ) ).

thf(conj,conjecture,
    mlocal @ ( mbox @ '#a' @ ( mnot @ p ) ) ).

thf('mrel_#b_transitive',axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( ( mrel @ '#b' @ W @ V )
        & ( mrel @ '#b' @ V @ U ) )
     => ( mrel @ '#b' @ W @ U ) ) ).

