tff(sqr,type,
    sqr: $real > $real ).

tff(sqrt,type,
    sqrt: $real > $real ).

tff(sqrt_le,axiom,
    ! [X: $real,Y: $real] :
      ( $lesseq(sqrt(X),sqrt(Y))
     <= ( $lesseq(0.0,X)
        & $lesseq(X,Y) ) ) ).

tff(sqr_def,axiom,
    ! [X: $real] : ( sqr(X) = $product(X,X) ) ).

tff(sqrt_positive,axiom,
    ! [X: $real] :
      ( $lesseq(0.0,sqrt(X))
     <= $lesseq(0.0,X) ) ).

tff(sqrt_square,axiom,
    ! [X: $real] :
      ( $lesseq(0.0,X)
     => ( sqr(sqrt(X)) = X ) ) ).

tff(sqrt_mul,axiom,
    ! [X: $real,Y: $real] :
      ( ( sqrt($product(X,Y)) = $product(sqrt(X),sqrt(Y)) )
     <= ( $lesseq(0.0,Y)
        & $lesseq(0.0,X) ) ) ).

tff(sqrt_one,axiom,
    sqrt(1.0) = 1.0 ).

tff(sqrt_four,conjecture,
    sqrt(4.0) = 2.0 ).

tff(sqrt_zero,axiom,
    sqrt(0.0) = 0.0 ).

tff(square_sqrt,axiom,
    ! [X: $real] :
      ( ( sqrt($product(X,X)) = X )
     <= $lesseq(0.0,X) ) ).

