tff(list_type,type,
    list: $tType ).

tff(nil_type,type,
    nil: list ).

tff(cons_type,type,
    cons: ( $int * list ) > list ).

tff(head_type,type,
    head: list > $int ).

tff(tail_type,type,
    tail: list > list ).

tff(in,type,
    in: ( $int * list ) > $o ).

tff(inRange_type,type,
    inRange: ( $int * list ) > $o ).

tff(t,type,
    length: list > $int ).

tff(t_2,type,
    count: ( $int * list ) > $int ).

tff(t_5,type,
    append: ( list * list ) > list ).

tff(inRange,axiom,
    ! [N: $int,L: list] :
      ( inRange(N,L)
    <=> ( ( L = nil )
        | ? [K: $int,T: list] :
            ( $lesseq(0,K)
            & inRange(N,T)
            & $less(K,N)
            & ( L = cons(K,T) ) ) ) ) ).

tff(l_6,axiom,
    ! [L: list] : ( append(nil,L) = L ) ).

tff(c,conjecture,
    ~ ! [K: list,L: list] :
        ( $greater(length(append(K,L)),4)
       <= ( $greater(length(K),1)
          & $greater(length(L),1) ) ) ).

tff(l3,axiom,
    ! [L: list] :
      ( ( L = cons(head(L),tail(L)) )
      | ( L = nil ) ) ).

tff(l_1,axiom,
    ! [H: $int,T: list] : ( length(cons(H,T)) = $sum(1,length(T)) ) ).

tff(a_4,axiom,
    ! [K: $int,H: $int,T: list,N: $int] :
      ( ( K = H )
     => ( count(K,cons(H,T)) = $sum(count(K,T),1) ) ) ).

tff(in_conv,axiom,
    ! [X: $int,L: list] :
      ( ( ? [H: $int,T: list] :
            ( in(X,T)
            & ( L = cons(H,T) ) )
        | ? [H: $int,T: list] :
            ( ( X = H )
            & ( L = cons(H,T) ) ) )
    <=> in(X,L) ) ).

tff(a,axiom,
    ! [K: $int] : ( count(K,nil) = 0 ) ).

tff(a_8,axiom,
    ! [N: $int,L: list] :
      ( $greater(count(N,L),0)
    <=> in(N,L) ) ).

tff(l_7,axiom,
    ! [I: $int,K: list,L: list] : ( append(cons(I,K),L) = cons(I,append(K,L)) ) ).

tff(l2,axiom,
    ! [K: $int,L: list] : ( tail(cons(K,L)) = L ) ).

tff(a_3,axiom,
    ! [K: $int,H: $int,T: list,N: $int] :
      ( ( count(K,cons(H,T)) = count(K,T) )
     <= ( K != H ) ) ).

tff(l,axiom,
    length(nil) = 0 ).

tff(l1,axiom,
    ! [K: $int,L: list] : ( head(cons(K,L)) = K ) ).

tff(l4,axiom,
    ! [K: $int,L: list] : ( cons(K,L) != nil ) ).

