tff(list_type,type,
    list: $tType ).

tff(nil_type,type,
    nil: list ).

tff(cons_type,type,
    cons: ( $int * list ) > list ).

tff(head_type,type,
    head: list > $int ).

tff(tail_type,type,
    tail: list > list ).

tff(inRange_type,type,
    inRange: ( $int * list ) > $o ).

tff(l4,axiom,
    ! [K: $int,L: list] : ( cons(K,L) != nil ) ).

tff(c,conjecture,
    ~ ! [N: $int] :
        ( inRange(N,cons(1,cons(5,cons(2,nil))))
       <= $greatereq(N,4) ) ).

tff(inRange,axiom,
    ! [N: $int,L: list] :
      ( ( ? [K: $int,T: list] :
            ( ( L = cons(K,T) )
            & $lesseq(0,K)
            & $less(K,N)
            & inRange(N,T) )
        | ( L = nil ) )
    <=> inRange(N,L) ) ).

tff(l2,axiom,
    ! [K: $int,L: list] : ( tail(cons(K,L)) = L ) ).

tff(l1,axiom,
    ! [K: $int,L: list] : ( head(cons(K,L)) = K ) ).

tff(l3,axiom,
    ! [L: list] :
      ( ( L = cons(head(L),tail(L)) )
      | ( L = nil ) ) ).

