tff(summation_type,type,
    summation: $int > $int ).

tff(ub_type,type,
    ub: ( $int * $int * $int ) > $o ).

tff(model_max_type,type,
    model_max: ( $int * $int * $int ) > $o ).

tff(model_ub_type,type,
    model_ub: ( $int * $int * $int ) > $o ).

tff(minsol_model_max_type,type,
    minsol_model_max: ( $int * $int * $int ) > $o ).

tff(minsol_model_ub_type,type,
    minsol_model_ub: ( $int * $int * $int ) > $o ).

tff(max_type,type,
    max: ( $int * $int ) > $int ).

tff(ub,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(X,Z)
        & $lesseq(Y,Z) )
    <=> ub(X,Y,Z) ) ).

tff(model_max_3,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( $lesseq(summation(max(X,Y)),N)
    <=> model_max(X,Y,N) ) ).

tff(model_ub_3,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( model_ub(X,Y,N)
    <=> ? [Z: $int] :
          ( ub(X,Y,Z)
          & $lesseq(summation(Z),N) ) ) ).

tff(max_1,axiom,
    ! [X: $int,Y: $int] :
      ( ~ $lesseq(Y,X)
      | ( max(X,Y) = X ) ) ).

tff(summation_monotone,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(summation(X),summation(Y))
    <=> $lesseq(X,Y) ) ).

tff(max_2,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = Y )
      | ~ $lesseq(X,Y) ) ).

tff(minsol_model_max,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( ( ! [Z: $int] :
            ( model_max(X,Y,Z)
           => $lesseq(N,Z) )
        & model_max(X,Y,N) )
    <=> minsol_model_max(X,Y,N) ) ).

tff(minsol_model_ub,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( ( ! [Z: $int] :
            ( model_ub(X,Y,Z)
           => $lesseq(N,Z) )
        & model_ub(X,Y,N) )
    <=> minsol_model_ub(X,Y,N) ) ).

tff(max_is_ub_1,conjecture,
    ! [X: $int,Y: $int,Z: $int] :
      ( minsol_model_max(X,Y,Z)
    <=> minsol_model_ub(X,Y,Z) ) ).

