tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(elt2,type,
    elt2: $tType ).

tff(elt3,type,
    elt3: ty ).

tff(le1,type,
    le2: ( elt2 * elt2 ) > $o ).

tff(array_elt1,type,
    array_elt1: $tType ).

tff(sorted_sub1,type,
    sorted_sub2: ( array_elt1 * $int * $int ) > $o ).

tff(t2tb4,type,
    t2tb4: array_elt1 > uni ).

tff(tb2t4,type,
    tb2t4: uni > array_elt1 ).

tff(t2tb5,type,
    t2tb5: elt2 > uni ).

tff(tb2t5,type,
    tb2t5: uni > elt2 ).

tff(sorted1,type,
    sorted2: array_elt1 > $o ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(occ,type,
    occ1: ( ty * uni * uni * $int * $int ) > $int ).

tff(permut,type,
    permut2: ( ty * uni * uni * $int * $int ) > $o ).

tff(map_eq_sub,type,
    map_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq_sub,type,
    array_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq,type,
    array_eq: ( ty * uni * uni ) > $o ).

tff(exchange,type,
    exchange2: ( ty * uni * uni * $int * $int * $int * $int ) > $o ).

tff(exchange1,type,
    exchange3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut1,type,
    permut3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_sub,type,
    permut_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_all,type,
    permut_all: ( ty * uni * uni ) > $o ).

tff(abs,type,
    abs: $int > $int ).

tff(div,type,
    div: ( $int * $int ) > $int ).

tff(mod,type,
    mod: ( $int * $int ) > $int ).

tff(map_int_elt1,type,
    map_int_elt1: $tType ).

tff(t2tb6,type,
    t2tb6: map_int_elt1 > uni ).

tff(tb2t6,type,
    tb2t6: uni > map_int_elt1 ).

tff(contents_def2,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort1(A,U) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(ref_inversion2,axiom,
    ! [A: ty,U: uni] :
      ( sort1(ref(A),U)
     => ( U = mk_ref(A,contents(A,U)) ) ) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(wP_parameter_mergesort_rec,conjecture,
    ! [A: $int,A1: map_int_elt1,Tmp: $int,L: $int,R: $int] :
      ( ( $less(L,$difference(R,1))
       => ( ( ( ( $lesseq(0,L)
                & $lesseq(L,$sum(L,div($difference(R,L),2)))
                & ( A = Tmp )
                & $lesseq($sum(L,div($difference(R,L),2)),A) )
             => ! [A2: map_int_elt1] :
                  ( ( permut_sub1(elt3,mk_array1(elt3,A,t2tb6(A1)),mk_array1(elt3,A,t2tb6(A2)),L,R)
                   => ( ( $lesseq(0,$sum(L,div($difference(R,L),2)))
                        & ( A = Tmp )
                        & $lesseq(R,A)
                        & $lesseq($sum(L,div($difference(R,L),2)),R) )
                     => ! [A3: map_int_elt1] :
                          ( ( permut_sub1(elt3,mk_array1(elt3,A,t2tb6(A2)),mk_array1(elt3,A,t2tb6(A3)),L,R)
                           => ( ! [A4: map_int_elt1] :
                                  ( ( $lesseq(0,A)
                                    & permut3(elt3,mk_array1(elt3,A,t2tb6(A3)),mk_array1(elt3,A,t2tb6(A4)),L,R)
                                    & ! [I: $int] :
                                        ( ( tb2t5(get(elt3,int,t2tb6(A4),t2tb(I))) = tb2t5(get(elt3,int,t2tb6(A3),t2tb(I))) )
                                       <= ( ( $lesseq(R,I)
                                            & $less(I,A) )
                                          | ( $lesseq(0,I)
                                            & $less(I,L) ) ) )
                                    & sorted_sub2(tb2t4(mk_array1(elt3,A,t2tb6(A4))),L,R)
                                    & $lesseq(0,Tmp) )
                                 => permut_sub1(elt3,mk_array1(elt3,A,t2tb6(A1)),mk_array1(elt3,A,t2tb6(A4)),L,R) )
                             <= ( $lesseq(0,L)
                                & $lesseq($sum(L,div($difference(R,L),2)),R)
                                & sorted_sub2(tb2t4(mk_array1(elt3,A,t2tb6(A3))),$sum(L,div($difference(R,L),2)),R)
                                & sorted_sub2(tb2t4(mk_array1(elt3,A,t2tb6(A3))),L,$sum(L,div($difference(R,L),2)))
                                & ( Tmp = A )
                                & $lesseq(R,Tmp)
                                & $lesseq(L,$sum(L,div($difference(R,L),2))) ) ) )
                         <= ( $lesseq(0,A)
                            & $lesseq(0,Tmp)
                            & sorted_sub2(tb2t4(mk_array1(elt3,A,t2tb6(A3))),$sum(L,div($difference(R,L),2)),R)
                            & permut_sub1(elt3,mk_array1(elt3,A,t2tb6(A2)),mk_array1(elt3,A,t2tb6(A3)),$sum(L,div($difference(R,L),2)),R) ) ) ) )
                 <= ( $lesseq(0,A)
                    & $lesseq(0,Tmp)
                    & permut_sub1(elt3,mk_array1(elt3,A,t2tb6(A1)),mk_array1(elt3,A,t2tb6(A2)),L,$sum(L,div($difference(R,L),2)))
                    & sorted_sub2(tb2t4(mk_array1(elt3,A,t2tb6(A2))),L,$sum(L,div($difference(R,L),2))) ) ) )
           <= ( $less($sum(L,div($difference(R,L),2)),R)
              & $lesseq(L,$sum(L,div($difference(R,L),2))) ) )
         <= ( 2 != 0 ) ) )
     <= ( $lesseq(0,A)
        & $lesseq(R,A)
        & ( A = Tmp )
        & $lesseq(L,R)
        & $lesseq(0,L)
        & $lesseq(0,Tmp) ) ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( mod($sum($product(X,Y),Z),X) = mod(Z,X) )
     <= ( $lesseq(0,Y)
        & $lesseq(0,Z)
        & $less(0,X) ) ) ).

tff(bridgeR6,axiom,
    ! [J: uni] :
      ( sort1(map(int,elt3),J)
     => ( t2tb6(tb2t6(J)) = J ) ) ).

tff(bridgeL6,axiom,
    ! [I: map_int_elt1] : ( tb2t6(t2tb6(I)) = I ) ).

tff(get_sort4,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(0,Y)
        & $lesseq(X,0) )
     => $lesseq(div(X,Y),0) ) ).

tff(set_sort5,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(set_sort4,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(occ_eq,axiom,
    ! [A: ty,V: uni,M1: uni,M2: uni,L: $int,U: $int] :
      ( ! [I: $int] :
          ( ( $less(I,U)
            & $lesseq(L,I) )
         => ( get(A,int,M1,t2tb(I)) = get(A,int,M2,t2tb(I)) ) )
     => ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs(X)) ).

tff(exchange_permut_all,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( exchange3(A,A1,A2,I,J)
     => permut_all(A,A1,A2) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( mod(X,Y) = X )
     <= ( $lesseq(0,X)
        & $less(X,Y) ) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div(X,1) = X ) ).

tff(const_sort2,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( div($sum($product(X,Y),Z),X) = $sum(Y,div(Z,X)) )
     <= ( $lesseq(0,Y)
        & $lesseq(0,Z)
        & $less(0,X) ) ) ).

tff(exchange_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int,J: $int] :
      ( exchange2(A,A1,A2,L,U,I,J)
    <=> ( $lesseq(L,I)
        & ! [K: $int] :
            ( ( $less(K,U)
              & $lesseq(L,K) )
           => ( ( K != I )
             => ( ( get(A,int,A1,t2tb(K)) = get(A,int,A2,t2tb(K)) )
               <= ( K != J ) ) ) )
        & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
        & ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(J)) )
        & $less(J,U)
        & $lesseq(L,J)
        & $less(I,U) ) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(t2tb_sort4,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(permut_all_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( ( length1(A,A1) = length1(A,A2) )
        & permut2(A,elts(A,A1),elts(A,A2),0,length1(A,A1)) )
    <=> permut_all(A,A1,A2) ) ).

tff(permut_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( permut3(A,A1,A2,L,U)
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),U,length1(A,A1))
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),0,L) )
    <=> permut_sub1(A,A1,A2,L,U) ) ).

tff(elts_sort2,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( ( Y != 0 )
        & $lesseq(0,X) )
     => $lesseq(0,mod(X,Y)) ) ).

tff(mk_ref_sort2,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(refl2,axiom,
    ! [X: elt2] : le2(X,X) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort1(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs(X),Y)
    <=> ( $lesseq(X,Y)
        & $lesseq($uminus(Y),X) ) ) ).

tff(occ_append,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,Mid: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = $sum(occ1(A,V,M,L,Mid),occ1(A,V,M,Mid,U)) )
     <= ( $lesseq(L,Mid)
        & $lesseq(Mid,U) ) ) ).

tff(bridgeL5,axiom,
    ! [I: elt2] : ( tb2t5(t2tb5(I)) = I ) ).

tff(t2tb_sort5,axiom,
    ! [X: array_elt1] : sort1(array(elt3),t2tb4(X)) ).

tff(permut_exists,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int] :
      ( ( ( $less(I,U)
          & $lesseq(L,I) )
       => ? [J: $int] :
            ( $lesseq(L,J)
            & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
            & $less(J,U) ) )
     <= permut2(A,A1,A2,L,U) ) ).

tff(exchange_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( ( exchange2(A,elts(A,A1),elts(A,A2),0,length1(A,A1),I,J)
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> exchange3(A,A1,A2,I,J) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less($uminus(abs(Y)),mod(X,Y))
        & $less(mod(X,Y),abs(Y)) )
     <= ( Y != 0 ) ) ).

tff(sorted_sub_def1,axiom,
    ! [A: array_elt1,L: $int,U: $int] :
      ( ! [I1: $int,I2: $int] :
          ( ( $lesseq(L,I1)
            & $lesseq(I1,I2)
            & $less(I2,U) )
         => le2(tb2t5(get2(elt3,t2tb4(A),I1)),tb2t5(get2(elt3,t2tb4(A),I2))) )
    <=> sorted_sub2(A,L,U) ) ).

tff(occ_empty,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = 0 )
     <= $lesseq(U,L) ) ).

tff(map_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ! [I: $int] :
          ( ( $less(I,U)
            & $lesseq(L,I) )
         => ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(I)) ) )
    <=> map_eq_sub1(A,A1,A2,L,U) ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( ( Y != 0 )
        & $lesseq(X,0) )
     => $lesseq(mod(X,Y),0) ) ).

tff(exchange_permut_sub,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int,L: $int,U: $int] :
      ( exchange3(A,A1,A2,I,J)
     => ( ( $lesseq(L,I)
          & $less(I,U) )
       => ( ( ( $lesseq(U,length1(A,A1))
             => permut_sub1(A,A1,A2,L,U) )
           <= $lesseq(0,L) )
         <= ( $lesseq(L,J)
            & $less(J,U) ) ) ) ) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(div(X,Y),X)
        & $lesseq(0,div(X,Y)) )
     <= ( $lesseq(0,X)
        & $less(0,Y) ) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( ( get(B,A,const(B,A,B1),A1) = B1 )
     <= sort1(B,B1) ) ).

tff(get_sort5,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(total2,axiom,
    ! [X: elt2,Y: elt2] :
      ( le2(X,Y)
      | le2(Y,X) ) ).

tff(bridgeL4,axiom,
    ! [I: array_elt1] : ( tb2t4(t2tb4(I)) = I ) ).

tff(array_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( ( length1(A,A1) = length1(A,A2) )
        & $lesseq(0,L)
        & $lesseq(L,length1(A,A1))
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length1(A,A1))
        & $lesseq(0,U) )
    <=> array_eq_sub1(A,A1,A2,L,U) ) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod(X,1) = 0 ) ).

tff(occ_right_no_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ( ( occ1(A,V,M,L,U) = occ1(A,V,M,L,$difference(U,1)) )
         <= ( get(A,int,M,t2tb($difference(U,1))) != V ) )
       <= $less(L,U) )
     <= sort1(A,V) ) ).

tff(array_eq_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( map_eq_sub1(A,elts(A,A1),elts(A,A2),0,length1(A,A1))
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> array_eq(A,A1,A2) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(t2tb_sort6,axiom,
    ! [X: elt2] : sort1(elt3,t2tb5(X)) ).

tff(match_bool_sort2,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => $lesseq(abs($product(div(X,Y),Y)),abs(X)) ) ).

tff(bridgeR5,axiom,
    ! [J: uni] :
      ( ( t2tb5(tb2t5(J)) = J )
     <= sort1(elt3,J) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(X,Y)
        & $lesseq(0,X) )
     => ( div(X,Y) = 0 ) ) ).

tff(trans2,axiom,
    ! [X: elt2,Y: elt2,Z: elt2] :
      ( le2(X,Y)
     => ( le2(Y,Z)
       => le2(X,Z) ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(t2tb_sort7,axiom,
    ! [X: map_int_elt1] : sort1(map(int,elt3),t2tb6(X)) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( X = $sum($product(Y,div(X,Y)),mod(X,Y)) )
     <= ( Y != 0 ) ) ).

tff(permut_trans,axiom,
    ! [A: ty,A1: uni,A2: uni,A3: uni,L: $int,U: $int] :
      ( permut2(A,A1,A2,L,U)
     => ( permut2(A,A1,A3,L,U)
       <= permut2(A,A2,A3,L,U) ) ) ).

tff(make_sort2,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(0,Y)
        & $lesseq(0,X) )
     => $lesseq(0,div(X,Y)) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) )
       <= sort1(A,A2) )
     <= sort1(A,A1) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( $lesseq(0,X)
       => ( abs(X) = X ) )
      & ( ( abs(X) = $uminus(X) )
       <= ~ $lesseq(0,X) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(permut_def,axiom,
    ! [A: ty,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( permut2(A,M1,M2,L,U)
       => ! [V: uni] : ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) )
      & ( permut2(A,M1,M2,L,U)
       <= ! [V: uni] :
            ( sort1(A,V)
           => ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) ) ) ) ).

tff(exchange_set,axiom,
    ! [A: ty,A1: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( exchange2(A,A1,set(A,int,set(A,int,A1,t2tb(I),get(A,int,A1,t2tb(J))),t2tb(J),get(A,int,A1,t2tb(I))),L,U,I,J)
       <= ( $less(J,U)
          & $lesseq(L,J) ) )
     <= ( $lesseq(L,I)
        & $less(I,U) ) ) ).

tff(sorted_def1,axiom,
    ! [A: array_elt1] :
      ( sorted2(A)
    <=> ! [I1: $int,I2: $int] :
          ( le2(tb2t5(get2(elt3,t2tb4(A),I1)),tb2t5(get2(elt3,t2tb4(A),I2)))
         <= ( $less(I2,length1(elt3,t2tb4(A)))
            & $lesseq(I1,I2)
            & $lesseq(0,I1) ) ) ) ).

tff(occ_exists,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort1(A,V)
     => ( ? [I: $int] :
            ( $lesseq(L,I)
            & ( get(A,int,M,t2tb(I)) = V )
            & $less(I,U) )
       <= $less(0,occ1(A,V,M,L,U)) ) ) ).

tff(occ_right_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $less(L,U)
     => ( ( get(A,int,M,t2tb($difference(U,1))) = V )
       => ( occ1(A,V,M,L,U) = $sum(1,occ1(A,V,M,L,$difference(U,1))) ) ) ) ).

tff(occ_bounds,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $lesseq(occ1(A,V,M,L,U),$difference(U,L))
        & $lesseq(0,occ1(A,V,M,L,U)) )
     <= $lesseq(L,U) ) ).

tff(mk_array_sort2,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(occ_pos,axiom,
    ! [A: ty,M: uni,L: $int,U: $int,I: $int] :
      ( ( $lesseq(L,I)
        & $less(I,U) )
     => $less(0,occ1(A,get(A,int,M,t2tb(I)),M,L,U)) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(contents_sort2,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(bridgeR4,axiom,
    ! [J: uni] : ( t2tb4(tb2t4(J)) = J ) ).

tff(permut_sub_weakening,axiom,
    ! [A: ty,A1: uni,A2: uni,L1: $int,U1: $int,L2: $int,U2: $int] :
      ( permut_sub1(A,A1,A2,L1,U1)
     => ( ( permut_sub1(A,A1,A2,L2,U2)
         <= ( $lesseq(U1,U2)
            & $lesseq(U2,length1(A,A1)) ) )
       <= ( $lesseq(0,L2)
          & $lesseq(L2,L1) ) ) ) ).

tff(occ_neq,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort1(A,V)
     => ( ( occ1(A,V,M,L,U) = 0 )
       <= ! [I: $int] :
            ( ( get(A,int,M,t2tb(I)) != V )
           <= ( $lesseq(L,I)
              & $less(I,U) ) ) ) ) ).

tff(permut_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( permut2(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length1(A,A1))
        & $lesseq(0,U)
        & $lesseq(L,length1(A,A1))
        & $lesseq(0,L)
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> permut3(A,A1,A2,L,U) ) ).

