tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(sorted_sub,type,
    sorted_sub2: ( map_int_int * $int * $int ) > $o ).

tff(t2tb1,type,
    t2tb1: map_int_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > map_int_int ).

tff(array_int,type,
    array_int: $tType ).

tff(sorted_sub1,type,
    sorted_sub3: ( array_int * $int * $int ) > $o ).

tff(t2tb2,type,
    t2tb2: array_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > array_int ).

tff(sorted,type,
    sorted1: array_int > $o ).

tff(exchange,type,
    exchange2: ( ty * uni * uni * $int * $int * $int * $int ) > $o ).

tff(exchange1,type,
    exchange3: ( ty * uni * uni * $int * $int ) > $o ).

tff(occ,type,
    occ1: ( ty * uni * uni * $int * $int ) > $int ).

tff(permut,type,
    permut2: ( ty * uni * uni * $int * $int ) > $o ).

tff(map_eq_sub,type,
    map_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq_sub,type,
    array_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq,type,
    array_eq: ( ty * uni * uni ) > $o ).

tff(permut1,type,
    permut3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_sub,type,
    permut_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_all,type,
    permut_all: ( ty * uni * uni ) > $o ).

tff(qs_partition1,type,
    qs_partition2: ( array_int * array_int * $int * $int * $int * $int * $int ) > $o ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(elts_def2,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(bridgeL1,axiom,
    ! [I: map_int_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(permut_all_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( permut2(A,elts(A,A1),elts(A,A2),0,length1(A,A1))
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> permut_all(A,A1,A2) ) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(permut_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( map_eq_sub1(A,elts(A,A1),elts(A,A2),0,L)
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),U,length1(A,A1))
        & permut3(A,A1,A2,L,U) )
    <=> permut_sub1(A,A1,A2,L,U) ) ).

tff(exchange_set,axiom,
    ! [A: ty,A1: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( $less(I,U)
        & $lesseq(L,I) )
     => ( exchange2(A,A1,set(A,int,set(A,int,A1,t2tb(I),get(A,int,A1,t2tb(J))),t2tb(J),get(A,int,A1,t2tb(I))),L,U,I,J)
       <= ( $lesseq(L,J)
          & $less(J,U) ) ) ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort1(ref(A),U) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(length_def2,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(occ_exists,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $less(0,occ1(A,V,M,L,U))
       => ? [I: $int] :
            ( ( get(A,int,M,t2tb(I)) = V )
            & $less(I,U)
            & $lesseq(L,I) ) )
     <= sort1(A,V) ) ).

tff(occ_neq,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort1(A,V)
     => ( ( occ1(A,V,M,L,U) = 0 )
       <= ! [I: $int] :
            ( ( $less(I,U)
              & $lesseq(L,I) )
           => ( get(A,int,M,t2tb(I)) != V ) ) ) ) ).

tff(array_eq_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( ( length1(A,A1) = length1(A,A2) )
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),0,length1(A,A1)) )
    <=> array_eq(A,A1,A2) ) ).

tff(bridgeL2,axiom,
    ! [I: array_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(exchange_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( ( exchange2(A,elts(A,A1),elts(A,A2),0,length1(A,A1),I,J)
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> exchange3(A,A1,A2,I,J) ) ).

tff(qs_partition_def1,axiom,
    ! [A1: array_int,A2: array_int,L: $int,Ml: $int,Mr: $int,R: $int,V: $int] :
      ( qs_partition2(A1,A2,L,Ml,Mr,R,V)
    <=> ( permut_sub1(int,t2tb2(A1),t2tb2(A2),L,R)
        & ! [J: $int] :
            ( ( $lesseq(L,J)
              & $less(J,Ml) )
           => $less(tb2t(get2(int,t2tb2(A2),J)),V) )
        & ! [J: $int] :
            ( $less(V,tb2t(get2(int,t2tb2(A2),J)))
           <= ( $lesseq(Mr,J)
              & $less(J,R) ) )
        & ! [J: $int] :
            ( ( tb2t(get2(int,t2tb2(A2),J)) = V )
           <= ( $less(J,Mr)
              & $lesseq(Ml,J) ) ) ) ) ).

tff(permut_def,axiom,
    ! [A: ty,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( ! [V: uni] : ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) )
       <= permut2(A,M1,M2,L,U) )
      & ( ! [V: uni] :
            ( sort1(A,V)
           => ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) )
       => permut2(A,M1,M2,L,U) ) ) ).

tff(sorted_sub_def,axiom,
    ! [A: map_int_int,L: $int,U: $int] :
      ( ! [I1: $int,I2: $int] :
          ( $lesseq(tb2t(get(int,int,t2tb1(A),t2tb(I1))),tb2t(get(int,int,t2tb1(A),t2tb(I2))))
         <= ( $less(I2,U)
            & $lesseq(I1,I2)
            & $lesseq(L,I1) ) )
    <=> sorted_sub2(A,L,U) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(occ_bounds,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(L,U)
     => ( $lesseq(0,occ1(A,V,M,L,U))
        & $lesseq(occ1(A,V,M,L,U),$difference(U,L)) ) ) ).

tff(sorted_def,axiom,
    ! [A: array_int] :
      ( sorted1(A)
    <=> sorted_sub2(tb2t1(elts(int,t2tb2(A))),0,length1(int,t2tb2(A))) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(exchange_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( $less(I,U)
        & $lesseq(L,J)
        & $less(J,U)
        & ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(J)) )
        & ! [K: $int] :
            ( ( ( K != I )
             => ( ( get(A,int,A1,t2tb(K)) = get(A,int,A2,t2tb(K)) )
               <= ( K != J ) ) )
           <= ( $less(K,U)
              & $lesseq(L,K) ) )
        & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
        & $lesseq(L,I) )
    <=> exchange2(A,A1,A2,L,U,I,J) ) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = false1 )
      | ( U = true1 ) ) ).

tff(map_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( map_eq_sub1(A,A1,A2,L,U)
    <=> ! [I: $int] :
          ( ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(I)) )
         <= ( $lesseq(L,I)
            & $less(I,U) ) ) ) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(occ_eq,axiom,
    ! [A: ty,V: uni,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) )
     <= ! [I: $int] :
          ( ( get(A,int,M1,t2tb(I)) = get(A,int,M2,t2tb(I)) )
         <= ( $less(I,U)
            & $lesseq(L,I) ) ) ) ).

tff(exchange_permut_sub,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int,L: $int,U: $int] :
      ( ( ( $less(I,U)
          & $lesseq(L,I) )
       => ( ( $lesseq(0,L)
           => ( permut_sub1(A,A1,A2,L,U)
             <= $lesseq(U,length1(A,A1)) ) )
         <= ( $lesseq(L,J)
            & $less(J,U) ) ) )
     <= exchange3(A,A1,A2,I,J) ) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(occ_right_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ( get(A,int,M,t2tb($difference(U,1))) = V )
       => ( occ1(A,V,M,L,U) = $sum(1,occ1(A,V,M,L,$difference(U,1))) ) )
     <= $less(L,U) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(permut_exists,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int] :
      ( permut2(A,A1,A2,L,U)
     => ( ? [J: $int] :
            ( ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
            & $less(J,U)
            & $lesseq(L,J) )
       <= ( $less(I,U)
          & $lesseq(L,I) ) ) ) ).

tff(exchange_permut_all,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( exchange3(A,A1,A2,I,J)
     => permut_all(A,A1,A2) ) ).

tff(array_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( array_eq_sub1(A,A1,A2,L,U)
    <=> ( ( length1(A,A1) = length1(A,A2) )
        & $lesseq(0,L)
        & $lesseq(U,length1(A,A1))
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(0,U)
        & $lesseq(L,length1(A,A1)) ) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(wP_parameter_quick_rec1,conjecture,
    ! [A: $int,A1: map_int_int,L: $int,R: $int] :
      ( ( $lesseq(L,R)
        & $lesseq(R,A)
        & $lesseq(0,L)
        & $lesseq(0,A) )
     => ( $less($sum(L,1),R)
       => ( ! [I: $int,Mr: $int,Ml: $int,A2: map_int_int] :
              ( ( $lesseq(L,Ml)
                & $less(Ml,I)
                & $lesseq(I,Mr)
                & ! [J: $int] :
                    ( ( $less(J,Ml)
                      & $lesseq(L,J) )
                   => $less(tb2t(get(int,int,t2tb1(A2),t2tb(J))),tb2t(get(int,int,t2tb1(A1),t2tb(L)))) )
                & permut_sub1(int,mk_array1(int,A,t2tb1(A1)),mk_array1(int,A,t2tb1(A2)),L,R)
                & ! [J: $int] :
                    ( $less(tb2t(get(int,int,t2tb1(A1),t2tb(L))),tb2t(get(int,int,t2tb1(A2),t2tb(J))))
                   <= ( $less(J,R)
                      & $lesseq(Mr,J) ) )
                & ! [J: $int] :
                    ( ( $lesseq(Ml,J)
                      & $less(J,I) )
                   => ( tb2t(get(int,int,t2tb1(A2),t2tb(J))) = tb2t(get(int,int,t2tb1(A1),t2tb(L))) ) )
                & $lesseq(Mr,R) )
             => ( ( ( $less(I,A)
                    & $lesseq(0,I)
                    & $lesseq(0,A) )
                 => ( ( ( $lesseq(0,Ml)
                        & $less(Ml,A)
                        & $less(I,A)
                        & $lesseq(0,I) )
                     => ! [A3: map_int_int] :
                          ( ! [Ml1: $int] :
                              ( ! [I1: $int] :
                                  ( ( I1 = $sum(I,1) )
                                 => ( ! [J: $int] :
                                        ( ( $lesseq(L,J)
                                          & $less(J,Ml1) )
                                       => $less(tb2t(get(int,int,t2tb1(A3),t2tb(J))),tb2t(get(int,int,t2tb1(A1),t2tb(L)))) )
                                   <= permut_sub1(int,mk_array1(int,A,t2tb1(A2)),mk_array1(int,A,t2tb1(A3)),L,R) ) )
                             <= ( Ml1 = $sum(Ml,1) ) )
                         <= ( exchange3(int,mk_array1(int,A,t2tb1(A2)),mk_array1(int,A,t2tb1(A3)),Ml,I)
                            & $lesseq(0,A) ) ) )
                   <= $less(tb2t(get(int,int,t2tb1(A2),t2tb(I))),tb2t(get(int,int,t2tb1(A1),t2tb(L)))) ) )
               <= $less(I,Mr) ) )
         <= ( $less(L,A)
            & $lesseq(0,L) ) ) ) ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(permut_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( $lesseq(0,L)
        & $lesseq(0,U)
        & permut2(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length1(A,A1))
        & $lesseq(L,length1(A,A1))
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> permut3(A,A1,A2,L,U) ) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) )
       <= sort1(A,A2) )
     <= sort1(A,A1) ) ).

tff(permut_trans,axiom,
    ! [A: ty,A1: uni,A2: uni,A3: uni,L: $int,U: $int] :
      ( ( permut2(A,A2,A3,L,U)
       => permut2(A,A1,A3,L,U) )
     <= permut2(A,A1,A2,L,U) ) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) )
     <= $lesseq(X,Y) ) ).

tff(occ_right_no_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $less(L,U)
       => ( ( occ1(A,V,M,L,U) = occ1(A,V,M,L,$difference(U,1)) )
         <= ( get(A,int,M,t2tb($difference(U,1))) != V ) ) )
     <= sort1(A,V) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( ( ( A1 = A2 )
       => ( get(B,A,set(B,A,M,A1,B1),A2) = B1 ) )
     <= sort1(B,B1) ) ).

tff(array_inversion2,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(occ_pos,axiom,
    ! [A: ty,M: uni,L: $int,U: $int,I: $int] :
      ( $less(0,occ1(A,get(A,int,M,t2tb(I)),M,L,U))
     <= ( $less(I,U)
        & $lesseq(L,I) ) ) ).

tff(t2tb_sort1,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb1(X)) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(occ_append,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,Mid: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = $sum(occ1(A,V,M,L,Mid),occ1(A,V,M,Mid,U)) )
     <= ( $lesseq(Mid,U)
        & $lesseq(L,Mid) ) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(occ_empty,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(U,L)
     => ( occ1(A,V,M,L,U) = 0 ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort1(A,U) ) ).

tff(permut_sub_weakening,axiom,
    ! [A: ty,A1: uni,A2: uni,L1: $int,U1: $int,L2: $int,U2: $int] :
      ( permut_sub1(A,A1,A2,L1,U1)
     => ( ( ( $lesseq(U1,U2)
            & $lesseq(U2,length1(A,A1)) )
         => permut_sub1(A,A1,A2,L2,U2) )
       <= ( $lesseq(0,L2)
          & $lesseq(L2,L1) ) ) ) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(t2tb_sort2,axiom,
    ! [X: array_int] : sort1(array(int),t2tb2(X)) ).

tff(sorted_sub_def1,axiom,
    ! [A: array_int,L: $int,U: $int] :
      ( sorted_sub2(tb2t1(elts(int,t2tb2(A))),L,U)
    <=> sorted_sub3(A,L,U) ) ).

