tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(even,type,
    even1: $int > $o ).

tff(fact,type,
    fact1: $int > $int ).

tff(even_0,axiom,
    even1(0) ).

tff(even_not_odd,axiom,
    ! [X: $int] :
      ( ( even1($sum(X,1))
       => $false )
     <= even1(X) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) )
     <= $lesseq(X,Y) ) ).

tff(fact_0,axiom,
    fact1(0) = 1 ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(even_inversion,axiom,
    ! [Z: $int] :
      ( even1(Z)
     => ( ? [X: $int] :
            ( even1(X)
            & ( Z = $sum(X,2) ) )
        | ( Z = 0 ) ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,true1,Z,Z1) = Z )
     <= sort1(A,Z) ) ).

tff(wP_parameter_factorial,conjecture,
    ! [X: $int] :
      ( $lesseq(0,X)
     => ! [Y: $int] :
          ( ( Y = 1 )
         => ! [Z: $int] :
              ( ( Z = X )
             => ( ( $product(Y,fact1(Z)) = fact1(X) )
                & ! [Z1: $int,Y1: $int] :
                    ( ( $lesseq(0,Z1)
                      & ( $product(Y1,fact1(Z1)) = fact1(X) ) )
                   => ( ( ~ ( ( Z1 != 0 ) )
                       => ( Y1 = fact1(X) ) )
                      & ( ! [Y2: $int] :
                            ( ! [Z2: $int] :
                                ( ( Z2 = $difference(Z1,1) )
                               => ( $lesseq(0,Z2)
                                  & ( $product(Y2,fact1(Z2)) = fact1(X) )
                                  & $lesseq(0,Z1)
                                  & $less(Z2,Z1) ) )
                           <= ( Y2 = $product(Y1,Z1) ) )
                       <= ( Z1 != 0 ) ) ) )
                & $lesseq(0,Z) ) ) ) ) ).

tff(fact_n,axiom,
    ! [N: $int] :
      ( ( fact1(N) = $product(N,fact1($difference(N,1))) )
     <= $less(0,N) ) ).

tff(even_odd,axiom,
    ! [X: $int] :
      ( even1($sum(X,2))
     <= even1(X) ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort1(ref(A),U) ) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

