tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(injective,type,
    injective2: ( map_int_int * $int ) > $o ).

tff(t2tb1,type,
    t2tb1: map_int_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > map_int_int ).

tff(surjective,type,
    surjective2: ( map_int_int * $int ) > $o ).

tff(range,type,
    range2: ( map_int_int * $int ) > $o ).

tff(occ,type,
    occ1: ( ty * uni * uni * $int * $int ) > $int ).

tff(array_int,type,
    array_int: $tType ).

tff(injective1,type,
    injective3: ( array_int * $int ) > $o ).

tff(t2tb2,type,
    t2tb2: array_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > array_int ).

tff(surjective1,type,
    surjective3: ( array_int * $int ) > $o ).

tff(range1,type,
    range3: ( array_int * $int ) > $o ).

tff(surjective_def,axiom,
    ! [A: map_int_int,N: $int] :
      ( ! [I: $int] :
          ( ( $lesseq(0,I)
            & $less(I,N) )
         => ? [J: $int] :
              ( $lesseq(0,J)
              & ( tb2t(get(int,int,t2tb1(A),t2tb(J))) = I )
              & $less(J,N) ) )
    <=> surjective2(A,N) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort1(A,A1)
     => ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) ) ) ) ).

tff(occ_right_no_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ( ( occ1(A,V,M,L,U) = occ1(A,V,M,L,$difference(U,1)) )
         <= ( get(A,int,M,t2tb($difference(U,1))) != V ) )
       <= $less(L,U) )
     <= sort1(A,V) ) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(surjective_def1,axiom,
    ! [A: array_int,N: $int] :
      ( surjective3(A,N)
    <=> surjective2(tb2t1(elts(int,t2tb2(A))),N) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(injection_occ,axiom,
    ! [M: map_int_int,N: $int] :
      ( ! [V: $int] : $lesseq(occ1(int,t2tb(V),t2tb1(M),0,N),1)
    <=> injective2(M,N) ) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(occ_exists,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ? [I: $int] :
            ( ( get(A,int,M,t2tb(I)) = V )
            & $less(I,U)
            & $lesseq(L,I) )
       <= $less(0,occ1(A,V,M,L,U)) )
     <= sort1(A,V) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(injective_def,axiom,
    ! [A: map_int_int,N: $int] :
      ( injective2(A,N)
    <=> ! [I: $int,J: $int] :
          ( ( ( ( I != J )
             => ( tb2t(get(int,int,t2tb1(A),t2tb(I))) != tb2t(get(int,int,t2tb1(A),t2tb(J))) ) )
           <= ( $lesseq(0,J)
              & $less(J,N) ) )
         <= ( $less(I,N)
            & $lesseq(0,I) ) ) ) ).

tff(t2tb_sort1,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb1(X)) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) )
     <= $lesseq(X,Y) ) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(injective_surjective,axiom,
    ! [A: map_int_int,N: $int] :
      ( ( surjective2(A,N)
       <= range2(A,N) )
     <= injective2(A,N) ) ).

tff(range_def1,axiom,
    ! [A: array_int,N: $int] :
      ( range3(A,N)
    <=> range2(tb2t1(elts(int,t2tb2(A))),N) ) ).

tff(occ_right_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $less(L,U)
     => ( ( occ1(A,V,M,L,U) = $sum(1,occ1(A,V,M,L,$difference(U,1))) )
       <= ( get(A,int,M,t2tb($difference(U,1))) = V ) ) ) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(occ_empty,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(U,L)
     => ( occ1(A,V,M,L,U) = 0 ) ) ).

tff(occ_eq,axiom,
    ! [A: ty,V: uni,M1: uni,M2: uni,L: $int,U: $int] :
      ( ! [I: $int] :
          ( ( get(A,int,M1,t2tb(I)) = get(A,int,M2,t2tb(I)) )
         <= ( $lesseq(L,I)
            & $less(I,U) ) )
     => ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) ) ).

tff(injective_def1,axiom,
    ! [A: array_int,N: $int] :
      ( injective2(tb2t1(elts(int,t2tb2(A))),N)
    <=> injective3(A,N) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = false1 )
      | ( U = true1 ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(occ_neq,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort1(A,V)
     => ( ( occ1(A,V,M,L,U) = 0 )
       <= ! [I: $int] :
            ( ( $lesseq(L,I)
              & $less(I,U) )
           => ( get(A,int,M,t2tb(I)) != V ) ) ) ) ).

tff(wP_parameter_test,conjecture,
    ( ( ( ! [A: map_int_int] :
            ( ( $lesseq(0,10)
              & ( A = tb2t1(set(int,int,const(int,int,t2tb(0)),t2tb(0),t2tb(9))) ) )
           => ( ! [A1: map_int_int] :
                  ( ( ( $less(2,10)
                      & $lesseq(0,2) )
                   => ! [A2: map_int_int] :
                        ( ( ( A2 = tb2t1(set(int,int,t2tb1(A1),t2tb(2),t2tb(8))) )
                          & $lesseq(0,10) )
                       => ( ! [A3: map_int_int] :
                              ( ( ! [A4: map_int_int] :
                                    ( ( ( $less(5,10)
                                        & $lesseq(0,5) )
                                     => ! [A5: map_int_int] :
                                          ( ( ( A5 = tb2t1(set(int,int,t2tb1(A4),t2tb(5),t2tb(4))) )
                                            & $lesseq(0,10) )
                                         => ( ( $less(6,10)
                                              & $lesseq(0,6) )
                                           => ! [A6: map_int_int] :
                                                ( ( $lesseq(0,10)
                                                  & ( A6 = tb2t1(set(int,int,t2tb1(A5),t2tb(6),t2tb(0))) ) )
                                               => ( ! [A7: map_int_int] :
                                                      ( ( $lesseq(0,10)
                                                        & ( A7 = tb2t1(set(int,int,t2tb1(A6),t2tb(7),t2tb(1))) ) )
                                                     => ( ( $lesseq(0,8)
                                                          & $less(8,10) )
                                                       => ! [A8: map_int_int] :
                                                            ( ( ( A8 = tb2t1(set(int,int,t2tb1(A7),t2tb(8),t2tb(5))) )
                                                              & $lesseq(0,10) )
                                                           => ( ( $lesseq(0,9)
                                                                & $less(9,10) )
                                                             => ! [A9: map_int_int] :
                                                                  ( ( $lesseq(0,10)
                                                                    & ( A9 = tb2t1(set(int,int,t2tb1(A8),t2tb(9),t2tb(6))) ) )
                                                                 => ( ( injective2(A9,10)
                                                                      & range2(A9,10) )
                                                                   <= ( ( tb2t(get(int,int,t2tb1(A9),t2tb(0))) = 9 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(1))) = 3 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(2))) = 8 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(3))) = 2 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(4))) = 7 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(5))) = 4 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(8))) = 5 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(9))) = 6 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(7))) = 1 )
                                                                      & ( tb2t(get(int,int,t2tb1(A9),t2tb(6))) = 0 ) ) ) ) ) ) ) )
                                                 <= ( $lesseq(0,7)
                                                    & $less(7,10) ) ) ) ) ) )
                                   <= ( $lesseq(0,10)
                                      & ( A4 = tb2t1(set(int,int,t2tb1(A3),t2tb(4),t2tb(7))) ) ) )
                               <= ( $less(4,10)
                                  & $lesseq(0,4) ) )
                             <= ( $lesseq(0,10)
                                & ( A3 = tb2t1(set(int,int,t2tb1(A2),t2tb(3),t2tb(2))) ) ) )
                         <= ( $less(3,10)
                            & $lesseq(0,3) ) ) ) )
                 <= ( $lesseq(0,10)
                    & ( A1 = tb2t1(set(int,int,t2tb1(A),t2tb(1),t2tb(3))) ) ) )
             <= ( $less(1,10)
                & $lesseq(0,1) ) ) )
       <= ( $less(0,10)
          & $lesseq(0,0) ) )
     <= $lesseq(0,10) )
   <= $lesseq(0,10) ) ).

tff(t2tb_sort2,axiom,
    ! [X: array_int] : sort1(array(int),t2tb2(X)) ).

tff(occ_append,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,Mid: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = $sum(occ1(A,V,M,L,Mid),occ1(A,V,M,Mid,U)) )
     <= ( $lesseq(Mid,U)
        & $lesseq(L,Mid) ) ) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(occ_bounds,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $lesseq(occ1(A,V,M,L,U),$difference(U,L))
        & $lesseq(0,occ1(A,V,M,L,U)) )
     <= $lesseq(L,U) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(range_def,axiom,
    ! [A: map_int_int,N: $int] :
      ( range2(A,N)
    <=> ! [I: $int] :
          ( ( $lesseq(0,I)
            & $less(I,N) )
         => ( $lesseq(0,tb2t(get(int,int,t2tb1(A),t2tb(I))))
            & $less(tb2t(get(int,int,t2tb1(A),t2tb(I))),N) ) ) ) ).

tff(bridgeL1,axiom,
    ! [I: map_int_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(bridgeL2,axiom,
    ! [I: array_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( ( get(B,A,const(B,A,B1),A1) = B1 )
     <= sort1(B,B1) ) ).

tff(occ_pos,axiom,
    ! [A: ty,M: uni,L: $int,U: $int,I: $int] :
      ( ( $lesseq(L,I)
        & $less(I,U) )
     => $less(0,occ1(A,get(A,int,M,t2tb(I)),M,L,U)) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort1(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

