tff('Array',type,
    'Array[Int,Int]': $tType ).

tff(select,type,
    'select:(Array[Int,Int]*Int)>Int': ( 'Array[Int,Int]' * $int ) > $int ).

tff(store,type,
    'store:(Array[Int,Int]*Int*Int)>Array[Int,Int]': ( 'Array[Int,Int]' * $int * $int ) > 'Array[Int,Int]' ).

tff(const,type,
    'const:(Int)>Array[Int,Int]': $int > 'Array[Int,Int]' ).

tff(length,type,
    length: 'Array[Int,Int]' > $int ).

tff(div2,type,
    div2: $int > $int ).

tff(sorted,type,
    sorted: ( 'Array[Int,Int]' * $int * $int ) > $o ).

tff(formula_002,axiom,
    ! [A: 'Array[Int,Int]',B: 'Array[Int,Int]'] :
      ( ! [I: $int] : ( 'select:(Array[Int,Int]*Int)>Int'(A,I) = 'select:(Array[Int,Int]*Int)>Int'(B,I) )
     => ( A = B ) ) ).

tff(formula_001,axiom,
    ! [A: 'Array[Int,Int]',I: $int,J: $int,E: $int] :
      ( ( I != J )
     => ( 'select:(Array[Int,Int]*Int)>Int'('store:(Array[Int,Int]*Int*Int)>Array[Int,Int]'(A,I,E),J) = 'select:(Array[Int,Int]*Int)>Int'(A,J) ) ) ).

tff(formula,axiom,
    ! [A: 'Array[Int,Int]',I: $int,E: $int] : ( 'select:(Array[Int,Int]*Int)>Int'('store:(Array[Int,Int]*Int*Int)>Array[Int,Int]'(A,I,E),I) = E ) ).

tff(formula_005,axiom,
    ! [A: 'Array[Int,Int]'] : $greatereq(length(A),0) ).

tff(formula_006,axiom,
    ! [A: 'Array[Int,Int]',L: $int,U: $int] :
      ( sorted(A,L,U)
    <=> ! [I: $int,J: $int] :
          ( ( $lesseq(J,U)
            & $less(I,J)
            & $lesseq(L,I) )
         => $lesseq('select:(Array[Int,Int]*Int)>Int'(A,I),'select:(Array[Int,Int]*Int)>Int'(A,J)) ) ) ).

tff(formula_003,axiom,
    ! [I: $int,E: $int] : ( 'select:(Array[Int,Int]*Int)>Int'('const:(Int)>Array[Int,Int]'(E),I) = E ) ).

tff(formula_007,conjecture,
    ! [L: $int,U: $int,A: 'Array[Int,Int]',E: $int] :
      ( ( ( ( ? [M_2: $int] :
                ( ( $true
                 <= ( 'select:(Array[Int,Int]*Int)>Int'(A,M_2) = E ) )
                & ( ( 'select:(Array[Int,Int]*Int)>Int'(A,M_2) != E )
                 => ( ( ? [U_6: $int] :
                          ( ? [I: $int] :
                              ( $lesseq(L,I)
                              & ( 'select:(Array[Int,Int]*Int)>Int'(A,I) = E )
                              & $lesseq(I,U_6) )
                          & ( U_6 = $difference(M_2,1) ) )
                     <= ~ $less('select:(Array[Int,Int]*Int)>Int'(A,M_2),E) )
                    & ( ? [L_4: $int] :
                          ( ? [I: $int] :
                              ( $lesseq(I,U)
                              & ( 'select:(Array[Int,Int]*Int)>Int'(A,I) = E )
                              & $lesseq(L_4,I) )
                          & ( L_4 = $sum(M_2,1) ) )
                     <= $less('select:(Array[Int,Int]*Int)>Int'(A,M_2),E) ) ) )
                & ( M_2 = div2($sum(L,U)) ) )
           <= ~ $greater(L,U) )
          & ( $greater(L,U)
           => $false ) )
      <=> ? [I: $int] :
            ( $lesseq(L,I)
            & ( 'select:(Array[Int,Int]*Int)>Int'(A,I) = E )
            & $lesseq(I,U) ) )
     <= ( $lesseq(0,L)
        & sorted(A,0,$difference(length(A),1))
        & $less(U,length(A)) ) ) ).

tff(formula_004,axiom,
    ! [A: $int,Res: $int] :
      ( ( $lesseq($product(2,Res),A)
        & $greater($product(2,$sum(Res,1)),A) )
    <=> ( div2(A) = Res ) ) ).

