include('Axioms/RNG003-0.ax').
cnf(distributivity_of_difference4,axiom,
    add(additive_inverse(multiply(X,Z)),additive_inverse(multiply(Y,Z))) = multiply(add(X,Y),additive_inverse(Z)) ).

cnf(distributivity_of_difference2,axiom,
    add(multiply(X,Z),additive_inverse(multiply(Y,Z))) = multiply(add(X,additive_inverse(Y)),Z) ).

cnf(distributivity_of_difference1,axiom,
    multiply(X,add(Y,additive_inverse(Z))) = add(multiply(X,Y),additive_inverse(multiply(X,Z))) ).

cnf(inverse_product1,axiom,
    additive_inverse(multiply(X,Y)) = multiply(additive_inverse(X),Y) ).

cnf(inverse_product2,axiom,
    multiply(X,additive_inverse(Y)) = additive_inverse(multiply(X,Y)) ).

cnf(distributivity_of_difference3,axiom,
    multiply(additive_inverse(X),add(Y,Z)) = add(additive_inverse(multiply(X,Y)),additive_inverse(multiply(X,Z))) ).

cnf(prove_teichmuller_identity,negated_conjecture,
    add(add(associator(multiply(a,b),c,d),associator(a,b,multiply(c,d))),additive_inverse(add(add(associator(a,multiply(b,c),d),multiply(a,associator(b,c,d))),multiply(associator(a,b,c),d)))) != additive_identity ).

cnf(product_of_inverses,axiom,
    multiply(additive_inverse(X),additive_inverse(Y)) = multiply(X,Y) ).

